#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll mod = 998244353ll;
const int N = 200100;

std::vector<int> g[N];
int d[N], ans[N];

int main() {
    int n, m;
    scanf("%d%d", &n, &m);

    for (int i = 0; i < n - 1; ++i) {
        int from, to;
        scanf("%d%d", &from, &to);
        g[from - 1].push_back(to - 1);
        g[to - 1].push_back(from - 1);
    }

    memset(d, -1, sizeof(d));
    std::queue<int> q;
    for (int i = 0; i < m; ++i) {
        int cur;
        scanf("%d", &cur);
        d[cur - 1] = 0;
        ans[cur - 1] = 1;
        q.push(cur - 1);
    }

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto to : g[v]) {
            if (d[to] == -1) {
                d[to] = d[v] + 1;
                ans[to] = ans[v];
                q.push(to);
            } else if (d[to] == d[v] + 1) {
                ans[to] += ans[v];
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        if (ans[i] == m) {
            printf("YES\n%d\n", i + 1);
            return 0;
        }
    }

    printf("NO\n");

    return 0;
}