#include <iostream>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

struct node {
    int sum;
    int poz;
    int next;
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    int max = 0;
    for (int k = 0; k < n; k++) {
        cin >> v[k];
        if (v[k] > max) {
            max = v[k];
        }
    }

    int m;
    cin >> m;
    vector<pair<int, int>> p(m);
    int x = 0;
    for (int k = 0; k < m; k++) {
        cin >> x;
        p[k] = make_pair(x,k);
    }
    sort(p.begin(), p.end());

    vector<int> rez(m);

    vector<node> no;
    int k = 0;

    while (k < m && p[k].first < max) {
        rez[p[k].second] = 0;
        k++;
    }

    if (k < m) {
        int sum = 0;
        int max_sum = p[k].first;
        int next = 1;

        for (int j = 0; j < n; j++) {
            if (sum + v[j] > max_sum) {
                no.push_back({sum, j - 1, next});
                next++;
                sum = 0;
            }
            sum += v[j];
        }
        no.push_back({sum, n - 1, next});
        rez[p[k].second] = no.size();
    }

    int size = no.size();

    for (; k < m; k++) {
        if (k > 0 && p[k].first == p[k - 1].first) {
            rez[p[k].second] = rez[p[k-1].second];
        } else {
            int next = no[0].next;

            int max_sum = p[k].first;

            int current = 0;

            int diff = 0;
            while (next < no.size()) {
                no[current].sum -= diff;
                diff = 0;
                int poz = no[current].poz + 1;
                while (poz < n && no[current].sum + v[poz] <= max_sum) {
                    no[current].sum += v[poz];
                    diff += v[poz];
                    no[current].poz++;
                    if (no[current].next < no.size() && poz >= no[no[current].next].poz) {
                        no[current].next = no[no[current].next].next;
                        diff = 0;
                        size--;
                    }
                    poz++;
                }
                current = no[current].next;
                if (current == no.size()) {
                    break;
                }
                next = no[current].next;
            }
            rez[p[k].second] = size;
        }
    }
    for (auto i : rez) {
        if (i == 0) {
            cout << "Impossible" << '\n';
        } else {
            cout << i << '\n';
        }
    }

    return 0;
}