#include <iostream>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<string> a(n);
    vector<vector<int>> b(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n - 1; i++) {
        b[i][i + 1] = a[i][i + 1] - '0';
    }

    for (int i = 2; i < n - 1; i++) {
        for (int j = 0; j < n - i; j++) {
            int t = 0;
            for (int k = j + 1; k < j + i - 1; k++) {
                t += (a[j][k] - '0') * b[k][i + j];
            }
            string c = to_string(t % 10);
            if (c[0] == a[j][j + i]){
                b[j][i + j] = 0;
            }
            else {
                b[j][i + j] = 1;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0;j < n; j++) {
            cout << b[i][j];
        }
        cout << '\n';
    }

    return 0;
}