#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int const N = 200100;
int const INF = 1e9 + 7;

vector <int> g[N];


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n - 1; i++) {
        int v, w;
        cin >> v >> w;
        v--;w--;
        g[v].push_back(w);
        g[w].push_back(v);
    }
    vector <int> c(m);
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        c[i]--;
    }
    sort(c.begin(), c.end());
    int sz = unique(c.begin(), c.end()) - c.begin();
    c.resize(sz);
    vector <int> dist(n, INF);
    vector <int> cnt(n, 0);
    queue <int> q;
    for (int i : c) {
        dist[i] = 0;
        cnt[i] = 1;
        q.push(i);
    }
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (cnt[v] == sz) {
            cout << "YES\n";
            cout << v + 1 << '\n';
            return 0;
        }
        for (int to : g[v]) {
            if (dist[to] > dist[v] + 1) {
                dist[to] = dist[v] + 1;
                cnt[to] = cnt[v];
                q.push(to);
            } else if (dist[to] == dist[v] + 1) {
                cnt[to] += cnt[v];
            }
            if (cnt[to] == sz) {
                cout << "YES\n";
                cout << to + 1 << '\n';
                return 0;
            }
        }
    }
    cout << "NO\n";
    return 0;
}
