#include <bits/stdc++.h>

using namespace std;

struct castle {
    char name;
    int x, y;

};


int main() {
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<string> field(n);
    for (int i = 0; i < n; i++) {
        cin >> field[i];
    }
    auto ans = field;
    int A_x, A_y;
    vector<vector<int>> dp(n + 1, vector<int> (m + 1));
    vector<castle> castles;
    castles.push_back({0, -1, -1});
    castles.push_back({0, n, m});
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == 'A') {
                A_x = i;
                A_y = j;
            } else if (field[i][j] != '.') {
                dp[i + 1][j + 1]++;
                castles.push_back({field[i][j], i, j});
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            dp[i][j] += dp[i - 1][j] + dp[i][j - 1] - dp[i - 1][j - 1];
        }
    }

    int bst_min_x = -5, bst_min_y = -5, bst_max_x = -5, bst_max_y = -5;
    int best_s = 0;
    for (auto left : castles) {
        for (auto right : castles) {
            for (auto up : castles) {
                for (auto down : castles) {
                    int min_y = left.y + 1;
                    int min_x = up.x + 1;
                    int max_y = right.y - 1;
                    int max_x = down.x - 1;
                    if (min_x <= max_x && min_y <= max_y && A_x >= min_x && A_x <= max_x && A_y <= max_y && A_y >= min_y) {
                        int amount = dp[max_x + 1][max_y + 1] - dp[min_x][max_y + 1] - dp[max_x + 1][min_y] + dp[min_x][min_y];
                        if (amount == 0) {
                            int s = (max_x - min_x + 1) * (max_y - min_y + 1);
                            if (s > best_s) {
                                best_s = s;
                                bst_max_x = max_x;
                                bst_max_y = max_y;
                                bst_min_x = min_x;
                                bst_min_y = min_y;
                            }

                        }
                    }
                }
            }
        }
    }


    for (int i = bst_min_x; i <= bst_max_x; i++) {
        for (int j = bst_min_y; j <= bst_max_y; j++) {
            if (ans[i][j] == '.') {
                ans[i][j] = 'a';
            }
        }
    }

    for (int i = bst_min_x - 1; i >= 0; i--) {
        char last = 0;
        bool fnd = false;
        for (auto x : ans[i]) {
            if (x != '.') {
                fnd = true;
                break;
            }
        }
        if (fnd) {
            for (int j = 0; j < m; j++) {
                if(ans[i][j] != 'a' && ans[i][j] != 'A') {
                    if (ans[i][j] == '.' && last != 0) {
                        ans[i][j] = last;
                    } else if (ans[i][j] != '.') {
                        if (last == 0) {
                            for (int k = 0; k < j; k++) {
                                ans[i][k] = tolower(ans[i][j]);
                            }
                        }
                        last = tolower(ans[i][j]);
                    }
                }
            }
        } else {
            for (int j = 0; j < m; j++) {
                ans[i][j] = tolower(ans[i + 1][j]);
            }
        }
    }

    for (int i = bst_max_x + 1; i < n; i++) {
        char last = 0;
        bool fnd = false;
        for (auto x : ans[i]) {
            if (x != '.') {
                fnd = true;
                break;
            }
        }
        if (fnd) {
            for (int j = 0; j < m; j++) {
                if(ans[i][j] != 'a' && ans[i][j] != 'A') {
                    if (ans[i][j] == '.' && last != 0) {
                        ans[i][j] = last;
                    } else if (ans[i][j] != '.') {
                        if (last == 0) {
                            for (int k = 0; k < j; k++) {
                                ans[i][k] = tolower(ans[i][j]);
                            }
                        }
                        last = tolower(ans[i][j]);
                    }
                }
            }
        } else {
            for (int j = 0; j < m; j++) {
                ans[i][j] = tolower(ans[i - 1][j]);
            }
        }
    }


    for (int j = bst_min_y - 1; j >= 0; j--) {
        char last = 0;
        bool fnd = false;
        for (int i = bst_min_x; i <= bst_max_x; i++) {
            auto x = ans[i][j];
            if (x != '.') {
                fnd = true;
                break;
            }
        }
        if (fnd) {
            for (int i = bst_min_x; i <= bst_max_x; i++) {
                if(ans[i][j] != 'a' && ans[i][j] != 'A') {
                    if (ans[i][j] == '.' && last != 0) {
                        ans[i][j] = last;
                    } else if (ans[i][j] != '.') {
                        if (last == 0) {
                            for (int k = bst_min_x; k < i; k++) {
                                ans[k][j] = tolower(ans[i][j]);
                            }
                        }
                        last = tolower(ans[i][j]);
                    }
                }
            }
        } else {
            for (int i = bst_min_x; i <= bst_max_x; i++) {
                ans[i][j] = tolower(ans[i][j + 1]);
            }
        }
    }

    for (int j = bst_max_y; j < m; j++) {
        char last = 0;
        bool fnd = false;
        for (int i = bst_min_x; i <= bst_max_x; i++) {
            auto x = ans[i][j];
            if (x != '.') {
                fnd = true;
                break;
            }
        }
        if (fnd) {
            for (int i = bst_min_x; i <= bst_max_x; i++) {
                if(ans[i][j] != 'a' && ans[i][j] != 'A') {
                    if (ans[i][j] == '.' && last != 0) {
                        ans[i][j] = last;
                    } else if (ans[i][j] != '.') {
                        if (last == 0) {
                            for (int k = bst_min_x; k < i; k++) {
                                ans[k][j] = tolower(ans[i][j]);
                            }
                        }
                        last = tolower(ans[i][j]);
                    }
                }
            }
        } else {
            for (int i = bst_min_x; i <= bst_max_x; i++) {
                ans[i][j] = tolower(ans[i][j - 1]);
            }
        }
    }










    for (auto &x : ans) {
        cout << x << '\n';
    }










    return 0;
}
