#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <string>
#include <map>
using namespace std;

int main(){
    int t;
    cin >> t;
    while(t--){
        int ans = 0;
        int n;
        cin >> n;
        vector<long long> v(n);
        for(int i = 0; i < n; i++){
            cin >> v[i];
        }
        for(int i = 1; i < n - 1; i++){
            map<long long, int> uf;
            for(int j = 0; j < i; j++){
                long long tmp = 2 * v[i] - v[j];
                if(uf.find(tmp) != uf.end()){
                    uf[tmp]++;
                } else {
                    uf[tmp] = 1;
                }
            }
            for(int j = i + 1; j < n; j++){
                if(uf.find(v[j]) != uf.end()){
                    ans += uf[v[j]];
                }
            }
        }
        cout << ans;
    }
}

