#include <bits/stdc++.h>

using namespace std;

#define len(x) int(x.size())
#define all(x) x.begin(), x.end()

#define ff first
#define ss second

#pragma optimize("O3")

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> masi;
typedef vector <ll> masl;

const int N = 2e5 + 10;

masl g[N];

int main() {
    #ifdef HOME
    freopen("input.txt", "rt", stdin);
    #endif  //  HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    masi marked(m);
    for (int i = 0; i < m; i++) {
        cin >> marked[i];
        marked[i]--;
    }
    if (m == 1) {
        cout << "YES\n";
        cout << marked[0] + 1;
        return 0;
    }
    queue <int> q;
    q.push(marked[0]);
    masi p(n, -1), d(n, 1e9);
    d[marked[0]] = 0;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (int i : g[x]) {
            if (d[i] == 1e9) {
                q.push(i);
                d[i] = d[x] + 1;
                p[i] = x;
            }
        }
    }
    masi way;
    int cur = marked[1];
    while(cur != marked[0]) {
        way.push_back(cur);
        cur = p[cur];
    }
    way.push_back(cur);
    int l = len(way);
    if (l % 2 == 0) {
        cout << "NO";
    } else {
        int s = way[l / 2];
        q.push(s);
        d.clear();
        d.resize(n, 1e9);
        d[s] = 0;
        while(!q.empty()) {
            int x = q.front();
            for (int i : g[x]) {
                if (d[i] == 1e9) {
                    d[i] = d[x] + 1;
                    q.push(i);
                }
            }
            q.pop();
        }
        set <int> lens;
        for (int i : marked) {
       		lens.insert(d[i]);
        }
        if (len(lens) == 1) {
            cout << "YES\n";
            cout << s + 1;
        } else {
            cout << "NO";
        }
    }
    return 0;
}
