#include <iostream>

using namespace std;

struct coord {
	long x;
	long y;
	long h;
};

int main() {
	int n;
	cin >> n;
	coord* obelisks = new coord[n];

	for (int i = 0; i < n; i++) {
		cin >> obelisks[i].x >> obelisks[i].y >> obelisks[i].h;
	}

	long minx = obelisks[0].x-obelisks[0].h;
	int minx_i = 0;
	for (int i = 1; i < n; i++) {
		if (obelisks[i].x - obelisks[i].h < minx) {
			minx = obelisks[i].x - obelisks[i].h;
			minx_i = i;
		}
	}
	long maxx = obelisks[0].x + obelisks[0].h;
	int maxx_i = 0;
	for (int i = 1; i < n; i++) {
		if (obelisks[i].x + obelisks[i].h > maxx) {
			maxx = obelisks[i].x + obelisks[i].h;
			maxx_i = i;
		}
	}	
	long miny = obelisks[0].y - obelisks[0].h;
	int miny_i = 0;
	for (int i = 1; i < n; i++) {
		if (obelisks[i].y - obelisks[i].h < miny) {
			miny = obelisks[i].y - obelisks[i].h;
			miny_i = i;
		}
	}	
	long maxy = obelisks[0].y + obelisks[0].h;
	int maxy_i = 0;
	for (int i = 1; i < n; i++) {
		if (obelisks[i].y + obelisks[i].h > maxy) {
			maxy = obelisks[i].y + obelisks[i].h;
			maxy_i = i;
		}
	}

	if ((maxx - minx) % 2 == 1) {
		minx--;
	}
	if ((maxy - miny) % 2 == 1) {
		miny--;
	}

	coord pyramid;

	pyramid.x = (maxx + minx) / 2;
	pyramid.y = (maxy + miny) / 2;
	pyramid.h = maxx - pyramid.x;
	if (maxy - pyramid.y > pyramid.h) {
		pyramid.h = maxy - pyramid.y;
	}
	cout << pyramid.x << " " << pyramid.y << " " << pyramid.h;
	return 0;
}