#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <queue>


using namespace std;

#define sqr(x) x * x;
#define all(x) x.begin(), x.end()
typedef long long ll;
const int INF = 1e9;
const int MOD = 1e9 + 7;

void solve() {
	int n;
	int ans = 0;
	cin >> n;
	vector<int> a(n);
	for (int& e : a) cin >> e;
	for (int i = 0; i < n; ++i) {
		map<int, int> q;
		for (int j = i + 1; j < n; ++j) {
			if (a[i] == a[j]) {
				if (q[a[i]] > 0) {
					ans++;
				}
			}
			else {
				if (q[(a[j] - a[i])] != 0) {
					ans++;
				}
			}
			q[a[j]]++;
		}
	}
	cout << ans << endl;
}

void solve1() {
	ll n;
	cin >> n;
	vector<vector<ll>> a(n, vector<ll>(n));
	vector<vector<ll>> b(n, vector<ll>(n));
	vector<vector<ll>> c(n, vector<ll>(n, 0));
	for (ll i = 0; i < n; i++)
		for (ll j = 0; j < n; j++) {
			char c;
			cin >> c;
			a[i][j] = (ll)(c - '0');
		}
	for (ll i = 0; i < n - 1; i++)
		b[i][i + 1] = a[i][i + 1];
	for (ll i = 0; i < n - 1; i++)
		c[i][i + 1] = a[i][i + 1];
	for (ll i = n - 3; i >= 0; i--) {
		for (ll j = i + 2; j < n; j++) {
			ll sum = 0;
			for (ll k = i + 1; k < j; k++) {
				sum += c[i][k] * b[k][j];
			}
			b[i][j] = sum;
			if (sum % 10 != a[i][j]) {
				c[i][j]++;
				b[i][j]++;
			}
		}
	}
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j)
			cout << c[i][j];
		cout << endl;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve1();
	}
}