#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <queue>


using namespace std;

#define sqr(x) x * x;
#define all(x) x.begin(), x.end()
typedef long long ll;
const int INF = 1e9;
const int MOD = 1e9 + 7;

void solve() {
	int n;
	cin >> n;
	int ans = 0;
	vector<int> a(n);
	for (int& e : a) cin >> e;
	for (int i = 0; i < n; ++i) {
		unordered_map<int, int> m;
		for (int j = 0; j < i; ++j) {
			m[a[i] - a[j]]++;
		}
		if (m.size() == 0) continue;
		for (int j = i + 1; j < n; ++j) {
			ans += m[a[j] - a[i]];
		}
	}
	cout << ans << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}