#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef HOME
    freopen("in.txt", "r", stdin);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    int ax = -1;
    int ay = -1;
    vector<pair<int, int>> letters;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            if (a[i][j] == 'A') {
                ax = i;
                ay = j;
            } else if (a[i][j] != '.') {
                letters.emplace_back(i, j);
            }
        }
    }
    long long bestSquare = 0;
    int x1 = -1;
    int y1 = -1;
    int x2 = -1;
    int y2 = -1;
    for (int i1 = 0; i1 <= ax; i1++) {
        for (int i2 = ax; i2 < n; i2++) {
            int yl = 0;
            int yr = m - 1;
            for (auto &e : letters) {
                if (e.first >= i1 && e.first <= i2) {
                    if (e.second <= ay) {
                        yl = max(yl, e.second + 1);
                    } else {
                        yr = min(yr, e.second - 1);
                    }
                }
            }
            if (ay < yl || ay > yr) {
                continue;
            }
            long long now = (1LL * i2 - i1 + 1) * (1LL * yr - yl + 1);
            if (bestSquare < now) {
                bestSquare = now;
                x1 = i1;
                y1 = yl;
                x2 = i2;
                y2 = yr;
            }
        }
    }
    auto paint = [&](int x1, int y1, int x2, int y2) {
        if (x1 > x2 || y1 > y2 || x1 < 0 || y1 < 0 || x2 >= n || y2 >= m) {
            return;
        }
        int lastPaintedLine = -1;
        for (int i = x1; i <= x2; i++) {
            bool isClear = true;
            for (int j = y1; j <= y2; j++) {
                if (a[i][j] != '.') {
                    isClear = false;
                    break;
                }
            }
            if (isClear) {
                continue;
            }
            lastPaintedLine = i;
            char letter = '-';
            for (int j = y1; j <= y2; j++) {
                if (a[i][j] != '.') {
                    letter = a[i][j];
                    for (int k = j - 1; k >= y1 && a[i][k] == '.'; k--) {
                        a[i][k] = letter - ('A' - 'a');
                    }
                }
            }
            for (int j = y2; a[i][j] == '.'; j--) {
                a[i][j] = letter - ('A' - 'a');
            }
            for (int k = i - 1; k >= x1 && a[k][y1] == '.'; k--) {
                for (int j = y1; j <= y2; j++) {
                    a[k][j] = a[k + 1][j];
                    if (a[k][j] >= 'A' && a[k][j] <= 'Z') {
                        a[k][j] = a[k][j] - ('A' - 'a');
                    }
                }
            }
        }
        for (int i = lastPaintedLine + 1; i <= x2; i++) {
            for (int j = y1; j <= y2; j++) {
                a[i][j] = a[i - 1][j];
                if (a[i][j] >= 'A' && a[i][j] <= 'Z') {
                    a[i][j] = a[i][j] - ('A' - 'a');
                }
            }
        }
    };
    paint(0, 0, x1 - 1, m - 1);
    paint(x1, 0, x2, y1 - 1);
    paint(x1, y2 + 1, x2, m - 1);
    paint(x2 + 1, 0, n - 1, m - 1);
    for (int i = x1; i <= x2; i++) {
        for (int j = y1; j <= y2; j++) {
            a[i][j] = 'a';
        }
    }
    a[ax][ay] = 'A';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << a[i][j];
        }
        cout << '\n';
    }
}