#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")

#define IOS ios::sync_with_stdio(0); cin.tie(0);cout.tie(0);
using namespace std;

int n, q, maximal = 0;
vector < int > num;
vector < pair < int, int > > ask;
int next_step = 0;


int curr = 0;

void input() {
	cin >> n;
	int temp;
	for (int i = 0; i < n; i++) {
		cin >> temp;
		num.push_back(temp);
		maximal = max(temp, maximal);
	}
	cin >> q;
	for (int i = 0; i < q; i++) {
		cin >> temp;
		ask.push_back({ temp, i });
	}
}

inline int count(int sz) {
	int now = 0, result = 0;
	for (int i = 0; i < n; i++) {
		now += num[i];
		if (now > sz) {
			result++;
			now = num[i];
		}
	}
	result++;
	return result;
}

inline bool check(int max_block, int cup) {
	int now = 0, result = 0;
	for (int i = 0; i < n; i++) {
		now += num[i];
		if (now > max_block) {
			result++;
			now = num[i];
		}
	}
	result++;
	return result <= cup;
}


inline int bin(int v) {
	int l = maximal, r = 2000002;
	while (l != r) {
		int tm = (l + r) / 2;
		if (check(tm, v)) {
			r = tm;
		}
		else {
			l = tm + 1;
		}
	}
	return l;
}


void solve() {
	sort(ask.begin(), ask.end());
	curr = count(maximal);
	next_step = bin(curr - 1);
	int ans[100007];
	for (int i = 0; i < q; i++) {
		if (ask[i].first < maximal) {
			ans[ask[i].second] = 0;
		}
		else {
			if (ask[i].first >= next_step) {
				curr = count(ask[i].first);
				next_step = bin(curr - 1);
				ans[ask[i].second] = curr;
			}
			else {
				ans[ask[i].second] = curr;
			}
		}
	}
	for (int i = 0; i < q; i++) {
		if (!ans[i]) {
			cout << "Impossible\n";
			continue;
		}
		cout << ans[i] << '\n';
	}

}

int main() {
	IOS
		input();
	solve();
	return 0;
}