#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <bitset>
#include <stack>
#include <queue>
#include <cstdio>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <ctime>
#include <algorithm>
#include <cmath>
#include <string>

using namespace std;

#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()

using ll = long long;
using ld = long double;

const ld pi = acos(-1.0L);
const ld eps = 0.00001L;

template<typename T, typename TT> void mi(T& a, TT b) {
	if (b < a)a = b;
}
template<typename T, typename TT> void ma(T& a, TT b) {
	if (b > a)a = b;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;
	vector<vector<int>> t(n, vector<int>(n));
	for(int i=0;i<n;i++)
		for (int j = 0; j < n; j++) {
			char c;
			cin >> c;
			t[i][j] = c - '0';
		}

	vector<vector<int>> ans(n, vector<int>(n, 0));
	vector<vector<int>> dp(n, vector<int>(n, 0));

	for(int l=1;l<n;l++)
		for (int i = 0; i + l < n; i++)
		{
			int j = i + l;
			for (int k = i + 1; k < j; k++)
				dp[i][j] = (dp[i][j] + dp[k][j] * ans[i][k]) % 10;
			if (dp[i][j] != t[i][j])
				ans[i][j] = 1, dp[i][j] += 1;
		}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++)
			cout << ans[i][j];
		cout << "\n";
	}

	return 0;
}




