#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <bitset>
#include <stack>
#include <queue>
#include <cstdio>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <cmath>
#include <string>

using namespace std;

#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()

using ll = long long;
using ld = long double;

const ld pi = acos(-1.0L);
const ld eps = 0.00001L;

template<typename T, typename TT> void mi(T& a, TT b) {
	if (b < a)a = b;
}
template<typename T, typename TT> void ma(T& a, TT b) {
	if (b > a)a = b;
}

void solve() {

	int n;
	cin >> n;
	unordered_map<int, vector<int> > ids;

	vector<int> a(n);
	for (auto& x : a)cin >> x;
	for (int i = 0; i < n; i++) {
		ids[a[i]].pb(i);
	}
	ll re = 0;
	for (int k = n - 1; k >= 0; k--) {
		for (int j = k - 1; j >= 0; j--) {
			ll need = 2LL * a[j] - a[k];
			if (ids.count(need) == 0)continue;
			int id = lower_bound(all(ids[need]), j) - ids[need].begin();
			id--;
			if (id >= 0 && id < len(ids[need])) {
				re += id + 1;
			}
		}
	}

	cout << re << "\n";

}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}




