import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.*
import kotlin.collections.HashMap

data class IntArr(var a : IntArray, var last : Int = 0) {
    inline fun set(x : Int) {
        a[last++] = x;
    }
    inline operator fun get(i : Int) = a[i]
}

fun solve() {
    var t = readInt()
    for (keke in 1..t) {
        var n = readInt()
        var a = IntArray(n)
        for (i in 0 until n) {
            a[i] = readInt()
        }
        var map = HashMap<Int, IntArr>()
        for (i in 0 until n) {
            var now = map[a[i]]
            if (now == null) {
                var add = IntArr(IntArray(2002))
                add.set(i)
                map[a[i]] = add
            } else {
                map[a[i]]!!.set(i)
            }
        }
        var ans = 0
        for (i in 0 until n) {
            for (j in (i + 1) until n) {
                var need = 2 * a[j] - a[i]
                if (map[need] == null) {
                    continue
                }

                var fnd = map[need]!!
                var left = -1
                var right = fnd.last
                while (right - left > 1) {
                    var mid = left + right shr 1
                    if (fnd[mid] > j) {
                        right = mid
                    } else {
                        left = mid
                    }
                }
                ans += fnd.last - right
            }
        }
        out.println(ans)
    }
}

fun main() {
    solve()
    out.close()
}

var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)
var tok = StringTokenizer(" ")

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine(), " ")
    }
    return tok.nextToken()
}

fun readInt() = read().toInt()