#include <iostream>

using namespace std;

typedef long long int ll;

int n;

const int sizes = 501;

int a[sizes][sizes];

int reb[sizes][sizes];

int put[sizes][sizes];

int dp[sizes];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            char ch;
            cin >> ch;
            a[i][j] = ch - '0';
        }
    }
    for (int i = 1; i < n; i++) {
        if (a[i-1][i] == 1) {
            reb[i-1][i] = 1;
        }
    }
    for (int l = 2; l <= n - 1; l++) {
        for (int i = 0; i <= n-l-1; i++) {
            int j = i + l;
            dp[i] = 1;
            for (int k = i+1; k <= j; k++) {
                dp[k] = 0;
                for (int z = i; z < k; z++) {
                    if (reb[z][k] == 1) {
                        dp[k] = (dp[k] + dp[z]) % 10;
                    }
                }
            }
            if (dp[j] != a[i][j]) {
                reb[i][j] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << reb[i][j];
        }
        cout << '\n';
    }
    return 0;
}