#include <iostream>
#include <unordered_map>

using namespace std;

typedef long long int ll;

const int MAXN = 501;
int arr[MAXN][MAXN];
bool ans[MAXN][MAXN];

int dp[MAXN][MAXN];

int main() {
#ifdef LOCAL_JOKE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        for(int j = i + 1; j <= n; ++j) {
            if (s[j - 1] != '0') {
                arr[i][j] = s[j - 1] - '0';
            }
        }
    }
    for (int i = n; i >= 1; --i) {
        int j = -1;
        for (j = i + 1; j <= n; ++j) {
            if (arr[i][j] > 0) {
                break;
            }
        }
        if (j == -1) {
            continue;
        }
        for (int l = j; l <= n; ++l) {
            for (int k = i + 1; k < l; ++k) {
                if (ans[i][k]) {
                    dp[i][l] = (dp[i][l] + dp[k][l]) % 10;
                }
            }
            if (dp[i][l] == arr[i][l]) {
                continue;
            } else {
                ans[i][l] = true;
                dp[i][l] = (dp[i][l] + 1) % 10;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (ans[i][j]) {
                cout << 1;
            } else {
                cout << 0;
            }
        }
        cout << "\n";
    }
    return 0;
}
