#include <bits/stdc++.h>

/* ============================================================= */

template <class ...Args>
bool read(Args& ...args)
{ return (bool)(std::cin >> ... >> args); }

template <class ...Args>
void write(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)); }

template <class ...Args>
void writeln(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)) << '\n'; }

/* ============================================================= */

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::fixed(std::cout).precision(10);

    int a, b, n; read(a, b, n);
    b -= a;
    n -= a;

    int res = 2 * ((n + b - 1) / b) - 1;

    writeln(res);

    return 0;
}