#include <bits/stdc++.h>

/* ============================================================= */

template <class ...Args>
bool read(Args& ...args)
{ return (bool)(std::cin >> ... >> args); }

template <class ...Args>
void write(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)); }

template <class ...Args>
void writeln(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)) << '\n'; }

/* ============================================================= */

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::fixed(std::cout).precision(10);

    const int inf = 4e8 + 5;

    int n; read(n);

    int x_bg = inf, x_nd = -inf;
    int y_bg = inf, y_nd = -inf;
    for (int i = 0; i < n; ++i) {
        int x, y, h; read(x, y, h);
        x_bg = std::min(x_bg, x - h);
        x_nd = std::max(x_nd, x + h);
        y_bg = std::min(y_bg, y - h);
        y_nd = std::max(y_nd, y + h);
    }

    int x_sz = x_nd - x_bg;
    int y_sz = y_nd - y_bg;
    int sz = std::max(x_sz, y_sz);
    sz = (sz + 1) / 2;

    writeln(x_bg + sz, ' ', y_bg + sz, ' ', sz);

    return 0;
}