#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

void solve() {
    int n; cin >> n;
    vector<string> A(n), G(n, string(n, '0'));
    for (int i = 0; i < n; i++) cin >> A[i];

    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {

            int cur = A[i][j] - '0';
            for (int k = i + 1; k < j; k++) {
                cur -= (G[i][k] - '0') * (A[k][j] - '0');
                cur %= 10;
                if (cur < 0) cur += 10;
            }
            if (cur != 0) {
                G[i][j] = '1';
            }
        }
    }
    for (int i = 0; i < n; i++) cout << G[i] << "\n";
}