#include <bits/stdc++.h>

using namespace std;

string s[1007];
int a[1007][1007];
char ans[1005][1005];

int n, m;

int gg(int x, int y) {
    if (x < 0 || y < 0)
        return 0;
    return a[x][y];
}

int sub(int a1, int b, int c, int d) {
    if (a1 <= 0 || b <= 0) {
        return a[c][d];
    }
    return a[c][d] - a[a1 - 1][d] - a[c][b - 1] + a[a1 - 1][b - 1];
}

char lower(char x) {
    return x - ('A' - 'a');
}

void color(int x, int y, int z, int q) {
    if (z <= x || q <= y) return;

    for (int i = x; i < z; i++) {
        int k = -1;
        char let;
        for (int j = y; j < q; j++) {
            if (s[i][j] != '.') {
                let = lower(s[i][j]);
                if (k == -1) {
                    for (int t = y; t <= j; t++)
                        ans[i][t] = let;
                }
                k = j;
            } else if (k != -1) {
                ans[i][j] = let;
            }
        }
    }

    bool flag = false;
    for (int i = x; i < z; i++) {
        for (int j = y; j < q; j++) {
            if (ans[i][j] == '.' && flag) {
                ans[i][j] = ans[i - 1][j];
            } else {
                flag = true;
            }
        }
    }
    flag = false;
    for (int i = z - 1; i >= x; i--) {
        for (int j = y; j < q; j++) {
            if (ans[i][j] == '.' && flag) {
                ans[i][j] = ans[i + 1][j];
            } else {
                flag = true;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    freopen("test.in", "r", stdin);

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    int x, y;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans[i][j] = '.';
            a[i][j] = gg(i - 1, j) + gg(i, j - 1) - gg(i - 1, j - 1)
                      + (int)(s[i][j] != 'A' && s[i][j] != '.');
            if (s[i][j] == 'A') {
                x = i;
                y = j;
            }
        }
    }

    int a1, b1, c1, d1;
    int mx, my, ma = 0;

    for (int i = 0; i <= x; i++) {
        for (int j = 0; j <= y; j++) {
            if (sub(i, j, x, y) != 0) {
                continue;
            }
            mx = x + 1;
            my = y + 1;
            while (mx < n && sub(i, j, mx - 1, my - 1) == 0) mx++;
            while (my < m && sub(i, j, mx - 1, my - 1) == 0) my++;

            if ((mx - i) * (my - j) > ma) {
                ma = (mx - i) * (my - j);
                a1 = i, b1 = j, c1 = mx, d1 = my;
            }
            while (mx > x + 1 && my < m) {
                mx--;
                while (my < m && sub(i, j, mx - 1, my - 1) == 0) {
                    my++;
                    // flag = true;
                }
                if ((mx - i) * (my - j) > ma) {
                    ma = (mx - i) * (my - j);
                    a1 = i, b1 = j, c1 = mx, d1 = my;
                }
            }
        }
    }

    //cout << a1 << " " << b1 << " " << c1 << " " << d1 << " " << ma;

    for (int i = a1; i < c1; i++) {
        for (int j = b1; j < d1; j++) {
            ans[i][j] = 'a';
        }
    }

    color(0, 0, a1, m);
    color(c1, 0, n, m);

    color(a1, 0, c1, b1);
    color(a1, d1, c1, m);



    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (s[i][j] != '.')
                ans[i][j] = s[i][j];
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << ans[i][j];
        }
        cout << "\n";
    }
    return 0;
}
