#include <bits/stdc++.h>

#define all(x) begin(x), end(x)
#define sz(x) ((int)x.size())

using namespace std;
using ll = long long;
using ld = long double;
const int inf = 1e9 + 10;
const int nax = 200005;
set<int> g[nax];
bool marked[nax], drop[nax], was[nax];
int deg[nax];
int d[nax];
int par[nax];

int main() {
#ifdef local
    assert(freopen("../in.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n >> m;
    if (n == 1) {
        cout << "YES\n1";
        return 0;
    }
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].insert(v);
        g[v].insert(u);
    }
    for (int i = 0; i < m; i++) {
        int c;
        cin >> c;
        c--;
        marked[c] = true;
    }
    queue<int> q;
    for (int i = 0; i < n; i++) {
        deg[i] = sz(g[i]);
        if (g[i].size() == 1) {
            q.push(i);
        }
    }
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (marked[v]) {
            continue;
        }
        drop[v] = true;
        for (auto x:g[v]) {
            if (drop[x]) continue;
            deg[x]--;
            if (deg[x] == 1) {
                q.push(x);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        auto it = g[i].begin();
        while (it != g[i].end()) {
            if (drop[*it]) {
                it = g[i].erase(it);
            } else {
                ++it;
            }
        }
        if (!drop[i]) {
            if (deg[i] == 1) {
                assert(marked[i]);
                q.push(i);
                was[i] = true;
                d[i] = 0;
            }
        }
    }

    if (sz(q) < m) {
        cout << "NO";
        return 0;
    }
//    cout << "OK" << endl;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto x:g[v]) {
            if (drop[x])continue;
            if (was[x]) {
                if (d[x] != d[v] + 1) {
                    cout << "NO";
                    return 0;
                }
                g[x].erase(v);
                if (g[x].size() == 1) {
                    q.push(x);
                }
            } else {
                d[x] = d[v] + 1;
                was[x] = true;
                g[x].erase(v);
                if (g[x].size() == 1) {
                    q.push(x);
                }
            }
        }
    }
    cout <<"YES\n" << max_element(d, d + n) - d + 1;
}