#include <bits/stdc++.h>

#define all(x) begin(x), end(x)
#define sz(x) ((int)x.size())

using namespace std;
using ll = long long;
using ld = long double;

const int K = 1500;

bool need[K];
int ans[K];

void print_ans(int x) {
    if (x == -1) cout << "Impossible\n";
    else cout << x << '\n';
}

int main() {
#ifdef local
    assert(freopen("../in.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n; cin >> n;
    vector<int> a(n);
    for (auto &x : a) cin >> x;
    int mx = *max_element(all(a));
    vector<int> s(n);
    partial_sum(all(a), begin(s));
    int qn; cin >> qn;
    vector<int> q(qn);
    for (auto &x : q) {
        cin >> x;
        if (x < K) need[x] = 1;
    }
    for (int i = 1; i < K; ++i) if (need[i]) {
        if (i < mx) {
            ans[i] = -1;
            continue;
        }
        int j = 0;
        while (j < n) {
            int sm = 0;
            while (j < n && sm + a[j] <= i) {
                sm += a[j++];
            }
            ans[i]++;
        }
    }
    for (int i = 0; i < qn; ++i) {
        if (q[i] < K) print_ans(ans[q[i]]);
        else {
            if (q[i] < mx) print_ans(-1);
            else {
                int j = 0;
                int res = 0;
                while (j < n) {
                    int cur = (j == 0 ? 0 : s[j-1]);
                    int jj = upper_bound(begin(s) + j, end(s), cur + q[i]) - begin(s);
                    j = jj;
                    ++res;
                }
                print_ans(res);
            }
        }
    }
}