#include <bits/stdc++.h>

#define all(x) begin(x), end(x)
#define sz(x) ((int)x.size())

using namespace std;
using ll = long long;
using ld = long double;
const int inf = 1e9 + 10;

struct rect {
    int x1, y1, x2, y2;
};

rect isct(rect a, rect b) {
    return {max(a.x1, b.x1), max(a.y1, b.y1), min(a.x2, b.x2), min(a.y2, b.y2)};
}

rect get_square(int xc, int yc, int d) {
    return {xc - d, yc - d, xc + d, yc + d};
}

int main() {
#ifdef local
    assert(freopen("../in.txt", "r", stdin));
#endif
//    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n; cin >> n;
    vector<int> x(n), y(n), h(n);
    int mx = *max_element(all(h));
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i] >> h[i];
    }
    int L = mx - 1, R = 1e9;
    int xa, ya;
    auto test = [&](int cur) {
        rect res = {-inf, -inf, inf, inf};
        for (int i = 0; i < n; ++i) {
            res = isct(res, get_square(x[i], y[i], cur - h[i]));
        }
        if (res.x1 > res.x2 || res.y1 > res.y2) return false;
        else {
            xa = res.x1, ya = res.y1;
            return true;
        }
    };
    while (R - L > 1) {
        int cur = (L + R) / 2;
        if (!test(cur)) {
            L = cur;
        } else {
            R = cur;
        }
    }
    test(L + 1);
//    cout << test(2) << endl;
//    cout << test(10) << endl;
//cout << test(5) << endl;
    cout << xa << ' ' << ya << ' ' << L + 1;
}