#include <bits/stdc++.h>

#define sz(a) ((int)((a).size()))
#define char unsigned char
#define X first
#define x first
#define Y second
#define y second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

pair <int, int> seg[10005];
int row[10005];
vector <int> otr[105], g[10005];
vector <pair <int, int> > path;
bool used[10005];
pair <int, int> point[105][105];
char a[105][105];

void dfs(int num, int tx, int ty, int typ)
{
    used[num] = true;
    vector <pair <int, int> > cur;
    int coptyp = typ, nx = tx, ny = ty;
    if (typ == 0)
    {
        if (row[num] == tx) nx--, cur.pb(mp(nx, ny));
        else nx++, cur.pb(mp(nx, ny));
        coptyp ^= 1;
    }
    if (row[num] == nx)
    {
        int cpx = nx, cpy = ny;
        for (int i = ny; i <= seg[num].y - 1; i++)
        {
            cpx--, cpy++;
            cur.pb(mp(cpx, cpy));
            cpx++;
            cur.pb(mp(cpx, cpy));
        }
        for (int i = seg[num].y; i >= seg[num].x; i--)
        {
            cpx--, cpy--;
            cur.pb(mp(cpx, cpy));
            cpx++;
            cur.pb(mp(cpx, cpy));
        }
        for (int i = seg[num].x - 1; i < ny; i++)
        {
            cpx--, cpy++;
            cur.pb(mp(cpx, cpy));
            cpx++;
            cur.pb(mp(cpx, cpy));
        }
        if (typ == 0) cur.pop_back();
    }
    else
    {
        int cpx = nx, cpy = ny;
        for (int i = ny; i <= seg[num].y - 1; i++)
        {
            cpx++, cpy++;
            cur.pb(mp(cpx, cpy));
            cpx--;
            cur.pb(mp(cpx, cpy));
        }
        for (int i = seg[num].y; i >= seg[num].x; i--)
        {
            cpx++, cpy--;
            cur.pb(mp(cpx, cpy));
            cpx--;
            cur.pb(mp(cpx, cpy));
        }
        for (int i = seg[num].x - 1; i < ny; i++)
        {
            cpx++, cpy++;
            cur.pb(mp(cpx, cpy));
            cpx--;
            cur.pb(mp(cpx, cpy));
        }
        if (typ == 0) cur.pop_back();
    }
    for (int i = 0; i < (int) cur.size(); i++)
    {
        path.pb(cur[i]);
        if (point[cur[i].x][cur[i].y] != mp(0, 0))
        {
            int nexts = (num ^ point[cur[i].x][cur[i].y].x ^ point[cur[i].x][cur[i].y].y);
            if (!used[nexts])
            {
                int newtyp = 0;
                if (i % 2 == 1) newtyp = typ;
                else newtyp = (typ ^ 1);
                dfs(nexts, cur[i].x, cur[i].y, newtyp);
            }
        }
    }
    return;
}

int main()
{
#ifdef ONPC
    freopen("in.txt", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int w, h;
    cin >> w >> h;
    for (int i = 1; i <= h; i++)
        for (int j = 1; j <= w; j++)
            cin >> a[i][j];
    int quant = 0;
    for (int i = 1; i <= h; i++)
    {
        int start = -1;
        for (int j = 1; j <= w; j++)
        {
            if (a[i][j] == 'X')
            {
                if (start == -1) start = j;
            }
            else
            {
                if (start != -1)
                {
                    quant++;
                    seg[quant] = mp(start, j - 1);
                    row[quant] = i;
                    otr[i].pb(quant);
                    start = -1;
                }
            }
        }
        if (start != -1)
        {
            quant++;
            seg[quant] = mp(start, w);
            row[quant] = i;
            otr[i].pb(quant);
        }
    }

    for (int i = 1; i < h; i++)
    {
        if (otr[i].empty() || otr[i + 1].empty()) continue;
        int uk = 0;
        for (int j = 0; j < (int) otr[i].size(); j++)
        {
            while (uk < (int) otr[i + 1].size() && seg[otr[i + 1][uk]].y < seg[otr[i][j]].x - 1) uk++;
            if (uk == (int) otr[i + 1].size()) break;
            if (seg[otr[i + 1][uk]].x > seg[otr[i][j]].y + 1) continue;
            while (seg[otr[i + 1][uk]].y <= seg[otr[i][j]].y)
            {
                int u = otr[i + 1][uk], v = otr[i][j];
                g[u].pb(v), g[v].pb(u);
                point[i][max(seg[u].x, seg[v].x) - 1] = mp(u, v);
                uk++;
                if (uk == (int) otr[i + 1].size() || seg[otr[i + 1][uk]].x > seg[otr[i][j]].y + 1) break;
            }
            if (uk == (int) otr[i + 1].size()) break;
            if (seg[otr[i + 1][uk]].x > seg[otr[i][j]].y + 1) continue;

            int u = otr[i + 1][uk], v = otr[i][j];
            g[u].pb(v), g[v].pb(u);
            point[i][max(seg[u].x, seg[v].x) - 1] = mp(u, v);
        }
    }

    path.pb(mp(row[1] - 1, seg[1].x - 1));
    dfs(1, row[1] - 1, seg[1].x - 1, 1);
    cout << (int) path.size() - 2 << '\n';
    for (int i = 0; i < (int) path.size() - 1; i++) cout << path[i].x << ' ' << path[i].y << '\n';
    return 0;
}

