#include <bits/stdc++.h>

#define sz(a) ((int)((a).size()))
#define char unsigned char
#define X first
#define x first
#define Y second
#define y second

using namespace std;

typedef long long ll;
typedef long double ld;

vector<string> s;

const int N = 1005;

int up[N][N], down[N][N];

void put(int l, int r, int u, int d, char oldc)
{
    char c = (oldc - 'A') + 'a';
    for (int i = u; i <= d; i++)
        for (int j = l; j <= r; j++)
            if (s[i][j] == '.')
                s[i][j] = c;
}

char get(char c)
{
    if ('a' <= c && c <= 'z')
        return c;
    else
        return (c - 'A') + 'a';
}

void solve(int l, int r, int u, int d)
{
    if (l > r || u > d)
        return;
    int h = u;
    int new_h = u - 1;
    for (int i = u; i <= d; i++)
        for (int j = l; j <= r; j++)
            if (s[i][j] != '.')
            {
                if (i != new_h)
                {
                    h = new_h + 1;
                    new_h = i;
                }
                int x = i, y = j;
                while (x > h && s[x - 1][j] == '.')
                    x--;
                while (y > l && s[i][y - 1] == '.')
                    y--;
                put(y, j, x, i, s[i][j]);
            }
    for (int i = u; i <= d; i++)
        for (int j = l; j <= r; j++)
        {
            if (s[i][j] != '.')
                continue;
            if (j > l && s[i][j - 1] != '.' && i <= new_h)
            {
                s[i][j] = get(s[i][j - 1]);
            }
            else if (i > u && s[i - 1][j] != '.')
                s[i][j] = get(s[i - 1][j]);
        }
}

int main()
{
#ifdef ONPC
    freopen("in.txt", "r", stdin);
#endif // ONPC
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    s.resize(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    for (int j = 0; j < m; j++)
    {
        int cur = -1;
        for (int i = 0; i < n; i++)
        {
            if (s[i][j] != '.')
                cur = i;
            up[i][j] = cur;
        }
        cur = n;
        for (int i = n - 1; i >= 0; i--)
        {
            if (s[i][j] != '.')
                cur = i;
            down[i][j] = cur;
        }
    }
    int bsts = 0, l = 0, r = 0, u = 0, d = 0;
    int x = 0, y = 0;
    for (int i = 0; i < n; i++)
         for (int j = 0; j < m; j++)
            if (s[i][j] == 'A')
                x = i, y = j;
    int curu = -1, curd = n;
    for (int le = y; le >= 0; le--)
    {
        if (s[x][le] != '.' && s[x][le] != 'A')
        {
            break;
        }
        if (x)
            curu = max(curu, up[x - 1][le]);
        if (x + 1 < n)
            curd = min(curd, down[x + 1][le]);
        int U = curu, D = curd;
        for (int ri = y; ri < m; ri++)
        {
            if (s[x][ri] != '.' && s[x][ri] != 'A')
            {
                break;
            }
            if (x)
                U = max(U, up[x - 1][ri]);
            if (x + 1 < n)
                D = min(D, down[x + 1][ri]);
            if ((D - U - 1) * (ri - le + 1) > bsts)
            {
                bsts = (D - U - 1) * (ri - le + 1);
                l = le;
                r = ri;
                u = U + 1;
                d = D - 1;
            }
        }
    }
    put(l, r, u, d, 'A');
    solve(0, m - 1, 0, u - 1);
    solve(0, l - 1, u, d);
    solve(r + 1, m - 1, u, d);
    solve(0, m - 1, d + 1, n - 1);
    for (int i = 0; i < n; i++)
        cout << s[i] << '\n';
    return 0;
}
