#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;
using vint = vector <int>;

const int INF = 0x3f3f3f3f;

vint used, teams, dist;
vector <vint> d;

int main() {
	// ...
	ios::sync_with_stdio(false);
	int n, m, a, b, id(-1);
	cin >> n >> m;

	d.resize(n);
	dist.resize(n);
	used.resize(n);
	teams.resize(m);

	for (int i(0); i < n - 1; i++) {
		cin >> a >> b;

		--a, --b;
		d[a].push_back(b);
		d[b].push_back(a);
	}

	for (auto& i : teams) {
		cin >> i;
		--i;
	}

	// refr
	int i = teams.front();

	queue <int> q;
	q.push(i);
	dist[i] = 0;
	
	while (!q.empty()) {
		int curr = q.front(); q.pop();
		used[curr] = true;
	
		for (auto next : d[curr]) {
			if (!used[next]) {
				dist[next] = dist[curr] + 1;
				q.push(next);
			}
		}
	}

	id = teams.front();
	int curr = id;
	for (int z(1); z < n; z++) {
		curr = d[curr].front();

		dist[id]++;
		bool is = true;
		int num = dist[id];

		for (int j(1); j < teams.size(); j++) {
			dist[teams[j]]--;

			if (dist[teams[j]] != num)
				is = false;
		}

		if (is) {
			cout << "YES\n" << z + 1;
			return 0;
		}
	}

	cout << "NO";
}

