#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef vector<ll> vll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    if (getenv("DEBUG"))
        freopen("../in/h", "r", stdin);
    vector<int> a;
    vector<int> h;
    int n;
    cin >> n;
    a.resize(n);
    int pow = 0;
    while ((1 << pow) < n) { ++pow; }
    h.resize((1 << (pow + 1)));
    ll max_a = 0;
    for (int i = 0; i < n; ++i){
        cin >> a[i];
        if (a[i] > max_a) {
            max_a = a[i];
        }
        h[(1 << pow) + i] = a[i];
    }
    for (int p = pow - 1; p >= 0; --p) {
        ll cur = (1 << p);
        for (int i = 0; i < cur ; ++i) {
            ll prev = (cur << 1) + 2*i;
            h[cur + i] = h[prev] + h[prev + 1];
        }
    }
    int q;
    cin >> q;
    stack<ll> st;
    ll last_level = 1 << pow;
    while(q--){
        int t;
        cin >> t;
        if (t < max_a) {
            cout << "Impossible\n";
            continue;
        }
        ll batches = 0;
        ll cur_batch = 0;
        st.push(1);
        while (!st.empty()) {
            int idx = st.top();
            st.pop();
            if (h[idx] > t - cur_batch) {
                if (idx < last_level) {
                    st.push(2*idx + 1);
                    st.push(2*idx);
                } else {
                    batches ++;
                    cur_batch = h[idx];
                }
            } else {
                cur_batch += h[idx];
            }
        }
        cout << batches + 1 << '\n';
    }
    cout.flush();
}