#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef vector<ll> vll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    if (getenv("DEBUG"))
        freopen("../in/h", "r", stdin);
    vector<int> h;
    int n;
    cin >> n;
    int pow = 0;
    while ((1 << pow) < n) { ++pow; }
    h.resize((1 << (pow + 1)));
    ll max_a = 0;
    ll last_level = 1 << pow;
    ll val;
    ll sum = 0;
    for (int i = 0; i < n; ++i){
        cin >> val;
        h[last_level + i] = val;
        if (val > max_a) {
            max_a = val;
        }
        sum += val;
    }
    /*ll prev = last_level;
    ll cur = last_level >> 1;
    int cur_depth = pow - 1;
    while (cur > 0) {
        for (int i = 0; i < cur_depth; ++i) {
            ll prev = prev + 2*i;
            h[cur + i] = h[prev] + h[prev + 1];
        }
        prev = cur;
        cur >>= 1;
        cur_depth --;
    }*/
    for(int lev = pow - 1; lev >= 0; --lev) {
        ll idx = 1 << lev;
        for (int i = 0; i < idx; ++i) {
            ll prev = (1 << (lev + 1)) + 2*i;
            h[idx + i] = h[prev] + h[prev + 1];
        }
    }

    int q;
    cin >> q;
    stack<ll> st;
    vll dyn;
    dyn.resize(sum + 1);
    while(q--){
        int t;
        cin >> t;
        if (t < max_a) {
            cout << "Impossible\n";
            continue;
        }
        if (dyn[t] > 0) {
            cout << dyn[t] << '\n';
            continue;
        }
        ll batches = 0;
        ll cur_batch = 0;
        st.push(1);
        while (!st.empty()) {
            int idx = st.top();
            st.pop();
            if (h[idx] > t - cur_batch) {
                if (idx < last_level) {
                    st.push(2*idx + 1);
                    st.push(2*idx);
                } else {
                    batches ++;
                    cur_batch = h[idx];
                }
            } else {
                cur_batch += h[idx];
            }
        }
        dyn[t] = batches + 1;
        cout << batches + 1 << '\n';
    }
    cout.flush();
}