#include <bits/stdc++.h>
#define pii pair<int, int>
using namespace std;

const int N = 3 * (int)1e5;

vector<int> g[N];

int used[N];

int lg[N];

int sm[N];

int ans = 0;

int mark[N];

void dfs(int x) {
    used[x] = 1;
    lg[x] = 0;
    sm[x] = N;
    for(int u : g[x]) {
        if(used[u]) continue;
        dfs(u);
        if(lg[u] == -1) continue;
        lg[x] = max(lg[x], lg[u] + 1);
        sm[x] = min(sm[x], sm[u] + 1);
    }
    if(sm[x] == N) lg[x] = -1, sm[x] = 0;
    if(mark[x] && lg[x] == -1) {
        lg[x] = 0;
    }
    if(mark[x]) {
        sm[x] = 0;
    }
    //cout << x << " " << lg[x] << " " << sm[x] << '\n';
}

void ssd(int x) {
    if(ans == 1) return;
    used[x] = 1;
    if(lg[x] == sm[x] & lg[x] != 0) {
        cout << "YES\n";
        cout << x + 1;
        ans = 1;
        return;
    }
    int y = -1;
    for(int u : g[x]) {
        if(lg[u] == -1) continue;
        if(used[u] == 1) continue;
        //lg[u] = max(lg[u], lg[x] + 1);
        sm[u] = min(sm[u], sm[x] + 1);
        ssd(u);
    }
}

int main() {
    ios::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    for(int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(int i = 0; i < m; ++i) {
        int t;
        cin >> t;
        t--;
        mark[t] = 1;
    }
    if(m == 1) {
        cout << "YES\n";
        for(int i = 0 ;i < n; ++i) {
            if(mark[i] == 1) {
                cout << i + 1;
            }
        }
        return 0;
    }
    dfs(0);
    fill(used, used + n, 0);
    ssd(0);
    if(ans == 0) cout << "NO";
    return 0;
}

/*
6 3
1 2
2 3
3 4
4 5
4 6
1 5 6

2 2
1 2
1 2
*/

