#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for(int i = 0; i < (n); i++)
#define fornr(i,n) for(int i = (n) - 1; i >= 0; i--)
#define forab(i,a,b) for(int i = (a); i < (b); i++)
#define mp make_pair
#define pb push_back
#define sz(X) int((X).size())
#define all(X) (X).begin(),(X).end()
#define fst first
#define snd second

using ll = long long;
using pii = pair<int,int>;
using vi = vector<int>;

const int MAX_N = 105;

const int MULT[5][2] = {{-1, -1}, {-1, 1}, {-1, -1}, {-1, 1}, {-1, -1}};
const int TURN[8][2] = {{-1, 0}, {-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}};
vi TURNS[2][2] = {{{6, 7, 0}, {0, 1, 2}}, {{4, 5, 6}, {2, 3, 4}}};
const int NXT[8][2] = {{-1, 1}, {-1, -1}, {1, -1}, {-1, -1}, {-1, 1}, {-1, -1}, {1, -1}, {-1, -1}}; 

int w, h;
int a[MAX_N][MAX_N], used[MAX_N][MAX_N];
string s;

void dfs(int i, int j, int l, int r, bool up, int was) {
	used[i][j] = 1;
	int itL = 0, itR = 4;
	if (!up)
		itL++, itR++; 
	forab (g, itL, itR) {
		for (int turn : TURNS[max(l, 0)][max(r, 0)]) {
			int nI = i + TURN[turn][0];
			int nJ = j + TURN[turn][1];
			if (nI >= 0 && nJ >= 0 && nI < h && nJ < w && !used[nI][nJ] && a[nI][nJ]) {
				dfs(nI, nJ, l * NXT[turn][0], r * NXT[turn][1], up, 1);
			}
		}
		l *= MULT[g][0];
		r *= MULT[g][1];
		up ^= 1;
		if (g != 3 || was)
			cout << j + max(r, 0) << " " << i + max(l, 0) << "\n";
	}
}

int main() {
#ifdef LOCAL
	freopen(".in", "r", stdin);
	freopen(".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> w >> h;
	int ans = 0;
	forn (i, h) {
		cin >> s;
		forn (j, w)
			a[i][j] = (s[j] == 'X'), ans += a[i][j];
	}
	cout << ans * 4 - 1 << "\n";
	forn (i, h)
		forn (j, w)
			if (a[i][j]) {
				cout << j << " " << i << "\n"; 
				dfs(i, j, -1, -1, 1, 0);
				return 0;
			}
	return 0;
}