#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <string>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <utility>
#include <cmath>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define X first
#define Y second

using namespace std;  using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	
	int n;
	cin >> n;

	vector<int> a_1(n), a_2(n);

	for (int i = 0; i < n; i++) cin >> a_1[i];
	for (int i = 0; i < n; i++) cin >> a_2[i];

	// check possibility

	bool poss = true;
	vector<int> rb_1(101, -1), rb_2(101, -1);
	for (int i = n - 1; i >= 0; i--) {
		if (rb_1[a_1[i]] == -1) rb_1[a_1[i]] = i;
		if (rb_2[a_2[i]] == -1) rb_2[a_2[i]] = i;
	}

	for (int i = 0; i <= 100; i++) {
		if (rb_2[i] >= 0 && rb_1[i] == -1) poss = false;
		if (rb_2[i] >= 0 && rb_2[i] < rb_1[i]) poss = false;
	}

	if (!poss) cout << -1 << endl;
	else {
		vector<pair<int ,int>> actions;

		for (int i = n - 1; i >= 0; i--) {
			if (a_1[i] != a_2[i]) {
				// Swap all before i into a_2[i]
				int cnt_chg = 0;
				for (int j = 0; j <= i; j++) {
					if (a_1[j] == a_1[i]) {
						cnt_chg++;
						actions.eb(a_1[j], a_2[i]);
						a_1[j] = a_2[i];
					}
				}
			}
		}

		cout << sz(actions) * 2 << '\n';
		for (auto el : actions) {
			cout << "foreach ($a as &$x) if ($x == " << el.X << ") break;" << '\n';
			cout << "foreach ($a as  $x) if ($x == " << el.Y << ") break;" << '\n';
		}
	}

	//cerr << (ld)clock() / CLOCKS_PER_SEC << endl;
}