#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <string>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <utility>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define X first
#define Y second

using namespace std;  using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int n;

	cin >> n;

	vector<vi> grd(n, vi(n));
	vector<vector<bool>> gr(n, vector<bool>(n));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			char ch;
			cin >> ch;
			grd[i][j] = ch - '0';
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (grd[i][j] == 1) {
				gr[i][j] = true;
				for (int k = 0; k < n; k++) {
					grd[i][k] = (grd[i][k] - grd[j][k] + 10) % 10;
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (gr[i][j]) cout << 1;
			else cout << 0;
		}
		cout << endl;
	}
	/*
	cout << sin(355 * 2) << endl;
	for (int i = 1;; i++) {
		if (0 < sin(i) && sin(i) < 4e-5) {
			cout << i << ' ' << sin(i) << endl;
			cout << (1LL << 31) / i << endl;
			return 0;
		}
	}*/

#ifdef ROMA_UMER
	cerr << (ld)clock() / CLOCKS_PER_SEC;
#endif // ROMA_UMER

}