#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>

using namespace std;
#define BIG 1000000

const int maxA = 1e6 + 100;
int pr[maxA];
int ans[maxA];

int main() {
    //freopen("input", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    int mx = 0;
    int acc = 0;
    for(int i = 0; i < n; i++) {
        int a;
        cin >> a;
        acc += a;
        mx = max(mx, a);
        pr[acc] = acc;
    }
    int cur = 0;
    for(int i = 0; i < maxA; i++) {
        if(cur > pr[i]) {
            pr[i] = cur;
        }
        else {
            cur = pr[i];
        }
    }

    for(int i = mx; i < maxA; i++) {
        int res = 0;
        int cur = 0;
        while(cur < acc) {
            cur = pr[cur + i];
            res++;
        }
        ans[i] = res;
    }

    int q;
    cin >> q;
    for(int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if(t < mx) {
            cout << "Impossible\n";
        } else {
            cout << ans[t] << "\n";
        }
    }

    return 0;
}