#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<vector<int>> d(n, vector<int>(n));
    vector<vector<int>> ans(n, vector<int>(n));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            char c;
            cin >> c;
            d[i][j] = c - '0';
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int sum = 0;
            for (int k = i + 1; k < j; k++) {
                sum += ans[i][k] * d[k][j];
            }

            if (sum % 10 == d[i][j]) {
                ans[i][j] = 0;
            }
            else {
                ans[i][j] = 1;
            }
        }
    }

    for (auto& v : ans) {
        for (int e : v) {
            cout << e;
        }
        cout << '\n';
    }
}