#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);

    for (int &x :a) {
        cin >> x;
    }

    ll res = 0;

    for (int i = 0; i + 2 < n; i++) {
        map<int, int> cnt;
        cnt[a[i + 1]]++;

        for (int j = i + 2; j < n; j++) {
            if ((a[i] + a[j]) % 2 == 0 && cnt.count((a[i] + a[j]) / 2)) {
                res += cnt[(a[i] + a[j]) / 2];
            }

            cnt[a[j]]++;
        }
    }

    cout << res << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(cout.fixed);
    cout.precision(8);

    int test;
    cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}