#include <bits/stdc++.h>
#pragma GCC optimize("-Ofast")

using namespace std;

const int M = 1010, N = 2e5 + 10;

int n, m, a[N], d[N], p[N];
vector<vector<int> > g;

void dfs(int v, int pr = -1) {
    for (auto i : g[v]) {
        if (i != pr) {
            d[i] = d[v] + 1;
            p[i] = v;
            dfs(i, v);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        a[i]--;
    }
    if (m == 1) {
        cout << "YES" << endl;
        cout << a[0] + 1 << endl;
        return 0;
    }
    dfs(a[0]);
    int k = 1;
    for (int j = 1; j < m; j++) {
        if (d[a[j]] > d[a[k]]) {
            k = j;
        }
    }
    if (d[a[k]] % 2 == 1) {
        cout << "NO" << endl;
        return 0;
    }
    int x = a[k], w = d[a[k]] / 2;
    for (int i = 0; i < d[a[k]] / 2; i++) {
        x = p[x];
    }
    d[x] = 0;
    dfs(x);
    for (int i = 0; i < m; i++) {
        if (d[a[i]] != w) {
            cout << "NO" << endl;
            return 0;
        }
    }
    cout << "YES" << endl;
    cout << x + 1 << endl;

    return 0;
}