#include <bits/stdc++.h>
#pragma GCC optimize("-Ofast")

using namespace std;

const int M = 1010;

int n, m, x, y, s[M][M], xx[M], yy[M];
char c[M][M];
bool u[26];

int sum(int x1, int y1, int x2, int y2) {
    return s[x2][y2] - s[x1 - 1][y2] - s[x2][y1 - 1] + s[x1 - 1][y1 - 1];
}

void recalc() {
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + (c[i][j] != '.');
        }
    }
}

void f(int x, int y, int q) {
    int lx = 0, rx = 0, ly = 0, ry = 0;
    for (int li = 1; li <= x; li++) {
        if (sum(li, y, x, y) != 1) {
            continue;
        }
        for (int ri = x; ri <= n; ri++) {
            if (sum(li, y, ri, y) != 1) {
                break;
            }
            int l = 0, r = y + 1;
            while (l + 1 < r) {
                int mm = (l + r) / 2;
                if (sum(li, mm, ri, y) == 1) {
                    r = mm;
                } else {
                    l = mm;
                }
            }
            int lj = r;
            l = y - 1;
            r = m + 1;
            while (l + 1 < r) {
                int mm = (l + r) / 2;
                if (sum(li, y, ri, mm) == 1) {
                    l = mm;
                } else {
                    r = mm;
                }
            }
            int rj = l;
            if ((ri - li + 1) * (rj - lj + 1) >= (rx - lx + 1) * (ry - ly + 1)) {
                lx = li;
                rx = ri;
                ly = lj;
                ry = rj;
            }
        }
    }
    for (int i = lx; i <= rx; i++) {
        for (int j = ly; j <= ry; j++) {
            if (c[i][j] == '.') {
                c[i][j] = q + 'a';
            }
        }
    }
    recalc();
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        string ss;
        cin >> ss;
        for (int j = 1; j <= m; j++) {
            c[i][j] = ss[j - 1];
            if (c[i][j] != '.') {
                xx[c[i][j] - 'A'] = i;
                yy[c[i][j] - 'A'] = j;
            }
            s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + (c[i][j] != '.');
        }
    }
    for (int i = 0; i < 26; i++) {
        if (xx[i] != 0) {
            f(xx[i], yy[i], i);
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cout << c[i][j];
        }
        cout << '\n';
    }

    return 0;
}

/*
6 8
......X.
.F......
...A....
........
.....P..
..L.....
 */