#include <bits/stdc++.h>
#pragma GCC optimize("-Ofast")

using namespace std;

const int M = 1010;

int n, m, x, y, s[M][M];
char c[M][M];

int sum(int x1, int y1, int x2, int y2) {
    return s[x2][y2] - s[x1 - 1][y2] - s[x2][y1 - 1] + s[x1 - 1][y1 - 1];
}

void f(int x1, int y1, int x2, int y2) {
    string s = "";
    bool f = 0;
    for (int i = x1; i <= x2; i++) {
        char t = '.';
        for (int j = y1; j <= y2; j++) {
            if (c[i][j] != '.') {
                t = c[i][j];
                break;
            }
        }
        if (t == '.') {
            if (f) {
                for (int j = y1; j <= y2; j++) {
                    c[i][j] = s[j - y1];
                }
            }
        } else {
            s = "";
            for (int j = y1; j <= y2; j++) {
                if (c[i][j] == '.') {
                    c[i][j] = t - 'A' + 'a';
                } else {
                    t = c[i][j];
                }
                if (c[i][j] >= 'A' && c[i][j] <= 'Z') {
                    s.push_back(c[i][j] - 'A' + 'a');
                } else {
                    s.push_back(c[i][j]);
                }
            }
            if (f == 0) {
                for (int k = x1; k < i; k++) {
                    for (int j = y1; j <= y2; j++) {
                        c[k][j] = s[j - y1];
                    }
                }
                f = 1;
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        string ss;
        cin >> ss;
        for (int j = 1; j <= m; j++) {
            c[i][j] = ss[j - 1];
            if (c[i][j] == 'A') {
                x = i;
                y = j;
            }
            s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + (c[i][j] != '.');
        }
    }
    int lx = x, rx = x, ly = y, ry = y;
    for (int li = 1; li <= x; li++) {
        for (int ri = x; ri <= n; ri++) {
            if (sum(li, y, ri, y) != 1) {
                break;
            }
            int l = 0, r = y;
            while (l + 1 < r) {
                int mm = (l + r) / 2;
                if (sum(li, mm, ri, y) == 1) {
                    r = mm;
                } else {
                    l = mm;
                }
            }
            int lj = r;
            l = y;
            r = m + 1;
            while (l + 1 < r) {
                int mm = (l + r) / 2;
                if (sum(li, y, ri, mm) == 1) {
                    l = mm;
                } else {
                    r = mm;
                }
            }
            int rj = l;
            if ((ri - li + 1) * (rj - lj + 1) > (rx - lx + 1) * (ry - ly + 1)) {
                lx = li;
                rx = ri;
                ly = lj;
                ry = rj;
            }
        }
    }
    for (int i = lx; i <= rx; i++) {
        for (int j = ly; j <= ry; j++) {
            if (c[i][j] == '.') {
                c[i][j] = 'a';
            }
        }
    }
    f(1, 1, lx - 1, m);
    f(lx, 1, rx, ly - 1);
    f(lx, ry + 1, rx, m);
    f(rx + 1, 1, n, m);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cout << c[i][j];
        }
        cout << '\n';
    }

    return 0;
}

/*
6 8
......X.
.F......
...A....
........
.....P..
..L.....
 */