#include "bits/stdc++.h"
using namespace std;
#define ll long long
#define all(x) (x).begin(), (x).end()
#define gcd __gcd
#define IOS ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

// custom hash can be a standalone function object:
template <class S>
struct MyHash
{
    std::size_t operator()(S const& s) const noexcept
    {
        return s * 101;
    }
};

struct elem{
    unordered_map<ll, ll, MyHash<ll>> left;
    unordered_map<ll,ll, MyHash<ll>> right;
};

int main() {
    IOS

    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vector<ll> vec(n);
        for (int i = 0; i < n; ++i) {
            cin >> vec[i];
        }
        vector<elem> pcalc(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (j < i) {
                    pcalc[i].left[vec[i] - vec[j]]++;
                } else if (j > i) {
                    pcalc[i].right[vec[j] - vec[i]]++;
                }
            }
        }

        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            for (auto j : pcalc[i].left) {
                if (pcalc[i].right.count(j.first)) {
                    ans += j.second * pcalc[i].right[j.first];
                }
            }
        }
        cout << ans << '\n';
    }
    return 0;
}


/*
 6 3
 1 2
 2 3
 3 4
 4 5
 4 6
 1 5 6
 */
/*
 4
 5
 1 2 1 2 1
 3
 30 20 10
 5
 1 2 2 3 4
 9
 3 1 4 1 5 9 2 6 5
 */

