#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MX = 2e5 + 7;
vector<int> g[MX];

vector<int> used(MX);
vector<int> a;

vector<int> path;
int x;

bool dfs_path(int v) {
    if (v == x) {
        path.push_back(v);
        return 1;
    }
    used[v] = 1;
    for (int i : g[v]) {
        if (!used[i]) {
            if (dfs_path(i)) {
                path.push_back(v);
                return 1;
            }
        }
    }

    return 0;
}

vector<int> d(MX);

void dfs_dist(int v, int h = 0) {
    used[v] = 1;
    d[v] = h + 1;
    for (int i : g[v]) {
        if (!used[i]) {
          dfs_dist(i, h + 1);
        }
    }
}

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    a.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        a[i]--;
    }
    if (m == 1) {
        cout << "YES\n" << a[0] + 1 << '\n';
        return 0;
    }

    dfs_dist(a[0]);
    int pos = 0;
    for (int i = 0; i < m; i++) {
        if (d[a[pos]] < d[a[i]]) pos = i;
    }

    used.assign(n, 0);
    dfs_dist(a[pos]);

    x = 0;
    for (int i = 0; i < m; i++) {
        if (d[a[x]] < d[a[i]]) x = i;
    }
    x = a[x];

    used.assign(n, 0);
    dfs_path(a[pos]);

    if (path.size() % 2 == 0) {
        cout << "NO\n";
        return 0;
    }

    used.assign(n, 0);

    int ans =  path[path.size() / 2];

    dfs_dist(ans);

    bool ok = true;
    for (int i = 0; i < m; i++) {
        ok &= (d[a[0]] == d[a[i]]);
    }

    if (ok){
        cout << "YES\n";
        cout << ans + 1 << '\n';
        return 0;
    }
    else {

        cout << "NO\n";
    }

    return 0;
}