#include <bits/stdc++.h>
using namespace std;

string to_string(bool x)
{
    return x ? "true" : "false";
}

string to_string(char x)
{
    return string(1, x);
}

string to_string(string x)
{
    return "\"" + x + "\"";
}

string to_string(const char *x)
{
    return to_string((string) x);
}

template <typename A, typename B>
string to_string(pair<A, B> p)
{
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A arr)
{
    auto first = true;
    string result = "{";
    for (const auto &x: arr) {
        if (!first) {
            result += ", ";
        }
        result += to_string(x);
        first = false;
    }
    result += "}";
    return result;
}

void debug_out() {
    cerr << endl;
}

template <typename Head, typename ... Tail>
void debug_out(Head head, Tail ...tail) {
    cerr << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: "; debug_out(__VA_ARGS__);
#else
#define debug(...) 42;
#endif

using ll = long long;
using vi = vector < int >;

int N;
vi A;
map < int, int > cnt;

void INIT() {
	cnt.clear();
	A.clear();
}

void solve() {
	INIT();
	cin >> N;
	A.resize(N);
	for (auto &x : A) {
		cin >> x;
		cnt[x]++;
	}		
	//debug(N, A);
	ll ans = 0;
	for (int i = 0; i < N; i++) {
		cnt[A[i]]--;
		for (int j = 0; j < i; j++) {
			int d = A[i] - A[j];
			int ak = A[i] + d;
			ans += cnt[ak];			
		}
	}
	cout << ans << "\n";
}                               

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("xxx.in", "r", stdin);
    freopen("xxx.out", "w", stdout);
#endif
	int T;
	cin >> T;
	for (int i = 0; i < T; i++)
		solve();
    return 0;
}