#include <iostream>
#include <algorithm>
#include <vector>
#define MX 1001

using namespace std;

char field[MX][MX];

int emp(int k, int l, int r)
{
    int fl = 1;
    for (int i = l; i < r; i++)
        if (field[k][i] != '.') fl = 0;
    return fl;
}

void parce(int u, int d, int l, int r)
{
    if (u == d || l == r) return;
    int k = u;
    while (emp(k, l, r)) k++;

    for (int i = k; i < d; i++)
    {
        int p1 = l, p2 = l;
        while (p2 < r)
        {
            while (p2 < r && field[i][p2] =='.') p2++;
            if (p2 < r)
            {
                for (int j = p1; j < p2; j++)
                    field[i][j] = field[i][p2] - 'A' + 'a';
                p2++;
                p1 = p2;
            }
        }

        if (p1 != l)
        {
            for (int j = p1; j < r; j++)
                field[i][j] = field[i][p1-1] -'A' + 'a';
        }
        else
        {
            for (int j = l; j < r; j++)
                if (field[i-1][j] >= 'a') field[i][j] = field[i-1][j];
                else field[i][j] = field[i-1][j] - 'A' + 'a';
        }

    }

    for (int i = u; i < k; i++)
        for (int j = l; j < r; j++)
            if (field[k][j] >= 'a') field[i][j] = field[k][j];
            else field[i][j] = field[k][j] - 'A' + 'a';
}

int main(){
    int n, m;
    cin >> n >> m;

    int x, y;
    vector <int> xx, yy;
    for (int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++)
        {
            if (s[j] == 'A')
            {
                x = i;
                y = j;
            }
            if (s[j] != '.' && s[j] != 'A')
            {
                xx.push_back(i);
                yy.push_back(j);
            }
            field[i][j] = s[j];
        }
    }

    int s = -1, l, r, u, d;

    for (int i = 0; i <= y; i++)
        for (int j = y+1; j <= m; j++)
        {
            int uu = 0, dd = n;
            for (int t = 0; t < (int)xx.size(); t++)
                if (yy[t] >= i && yy[t] < j)
                {
                    if (xx[t] < x) uu = max(uu, xx[t]+1);
                    else dd = min(dd, xx[t]);
                }

            if (uu <= x && x < dd &&  s < (j-i)*(dd-uu))
            {
                s = (j-i)*(dd-uu);
                l = i;
                r= j;
                u = uu;
                d = dd;
            }
        }

    //cout << x << " " << y << "\n";
    //cout << l << " " << r << "\n";
    //cout << u <<  " " << d << "\n";
    parce(0, u, 0, m);
    parce(u, d, 0, l);
    parce(u, d, l, r);
    parce(u, d, r, m);
    parce(d, n, 0, m);

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++) cout << field[i][j];
        cout << "\n";
    }
    return 0;
}
