#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>


using namespace std;
using ll=int;
using ld=long double;




signed main() {
	ios::sync_with_stdio(false); cin.tie(0);
	int n; cin >> n;
	vector<ll> a(n);
	for (auto& x : a)
		cin >> x;
	vector<ll> pref(n + 1);
	for (int i = 1; i <= n; i++)
		pref[i] = pref[i - 1] + a[i - 1];
	

	map<int, int> mp;
	int q; cin >> q;
	
	ll mx = *max_element(a.begin(), a.end());
	while (q--) {
		int t; cin >> t;
		if (t < mx) {
			cout << "Impossible\n";
			continue;
		}
		if (mp.count(t)) {
			cout << mp[t] << '\n';
			continue;
		}
		int cnt = 0;
		for (int i = 0; i < n;) {
			cnt++;
			ll fnd = pref[i] + t;
			i = int(upper_bound(pref.begin(), pref.end(), fnd) - pref.begin()) - 1;
		}
		mp[t] = cnt;
		cout << cnt << '\n';
	}
}
