#include <iostream>
#include <vector>
#include <unordered_map>
#include <cmath>

using namespace std;

const int maxN = 2e5 + 9;

vector<int> path[maxN];
int cnt[maxN];
bool used[maxN];

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		path[u].push_back(v);
		path[v].push_back(u);
	}
	vector<int> q;
	for (int i = 0; i < m; i++) {
		int c;
		cin >> c;
		c--;
		cnt[c]++;
		used[c] = true;
		q.emplace_back(c);
	}
	while (!q.empty()) {
		vector<int> nxt;
		vector<bool> now(n);
		for (auto a: q) {
			for (auto b: path[a]) {
				if (!used[b]) {
					if (!now[b]) {
						now[b] = true;
						nxt.emplace_back(b);
					}
					cnt[b] += cnt[a];
				}
			}
		}
		q = nxt;
		for (auto a: q) {
			used[a] = true;
		}
	}
	for (int i = 0; i < n; i++) {
		if (cnt[i] == m) {
			cout << "YES\n" << i + 1 << endl;
			return 0;
		}
	}
	cout << "NO" << endl;
}
