#include <iostream>
#include <vector>
#include <unordered_map>
#include <cmath>

using namespace std;

const int maxN = 500 + 9;

int r[maxN][maxN];
int a[maxN][maxN];

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			char c;
			cin >> c;
			a[i][j] = c - '0';
		}
	}
	for (int i = 0; i < n; i++) {
		r[i][i] = 1;
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = i - 1; j >= 0; j--) {
			for (int k = 0; k < n; k++) {
				r[j][k] = (r[j][k] + 100 - a[j][i] * r[i][k]) % 10;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			r[i][j] = (10 - r[i][j]) % 10;
		}
	}
	for (int i = 0; i < n; i++) {
		r[i][i] = (r[i][i] + 1) % 10;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << r[i][j];
		}
		cout << '\n';
	}
}
