#include <bits/stdc++.h>

using namespace std;
#define pt pair <int, int>
#define ff first
#define ss second
#define mp make_pair
#define pb push_back

vector <string> g;
vector <vector <bool>> used;
vector <pt> ans;
int w, h;

bool was_up = false;

int next_corner(int corner) {
    if (corner == 0) {
        if (was_up) return 1;
        else return 2;
    }
    else if (corner == 1) {
        if (was_up) return 0;
        else return 3;
    }
    else if (corner == 2) {
        if (was_up) return 3;
        else return 0;
    }
    else if (corner == 3) {
        if (was_up) return 2;
        else return 1;
    }
}

void add_move(int nc, int i, int j) {
    if (nc == 0) {
        ans.pb(mp(i, j));
    }
    else if (nc == 1) {
        ans.pb(mp(i + 1, j));
    }
    else if (nc == 2) {
        ans.pb(mp(i + 1, j + 1));
    }
    else if (nc == 3) {
        ans.pb(mp(i, j + 1));
    }
}
void dfs(pt st, int corner);

void try_dfs(pt st, int corner) {
    int i = st.ff, j = st.ss;
    if (0 <= i && 0 <= j
         && j < h && i < w
          && !used[j][i]
           && g[j][i] == 'X') {
            dfs(st, corner);
           }
}

void dfs(pt st, int corner) {
     int i = st.ff, j = st.ss;

    //cerr << "dfs " << i << ' ' << j << '\n';
    used[j][i] = true;
    for (int u = 0; u < 4; ++u) {
        int nc = next_corner(corner);
        was_up = 1 - was_up;
        //cerr << i << ',' << j << ": " << corner << ' '  << nc <<  ' ' << was_up << '\n';
        add_move(nc, i, j);
        if (nc == 0) {
            try_dfs(mp(i - 1, j), 1);
            try_dfs(mp(i - 1, j - 1), 2);
        }
        else if (nc == 1) {
            try_dfs(mp(i, j - 1), 2);
            try_dfs(mp(i + 1, j - 1), 3);
        }
        else if (nc == 2) {
            try_dfs(mp(i + 1, j), 3);
            try_dfs(mp(i + 1, j + 1), 0);
        }
        else if (nc == 3) {
            try_dfs(mp(i, j + 1), 0);
            try_dfs(mp(i - 1, j + 1), 1);
        }
        corner = nc;
    }
}

int main()
{
    cin >> w >> h;
    g.resize(h);
    for (int i = 0; i < h; ++i)
        cin >> g[i];

    /// find start
    pt st;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            if (g[i][j] == 'X') st = mp(j, i);
        }
    }

    used.resize(h, vector<bool>(w, false));

    add_move(0, st.ff, st.ss);
    dfs(st, 0);
    ans.pop_back();

    cout << ans.size() - 1 << '\n';

    for (auto i : ans) cout << i.ff << ' ' << i.ss << '\n';
}

/*
3 2
.XX
..X
*/

