#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;
	cin >> n;

	vector<string> val(n);
	for (int i = 0; i < n; i++)
		cin >> val[i];

	vector<string> ans(n, string(n, '0'));

	for (int len = 1; len <= n; len++)
	{
		for (int i = 0; i < n - len; i++)
		{
			int sum = 0;

			const int j = i + len;
			for (int k = i + 1; k < j; k++)
				sum += (val[i][k] - '0') * (ans[k][j] - '0');

			sum %= 10;
			const char cur = char('0' + sum);
			const char next = char('0' + (sum + 1) % 10);
			assert(val[i][j] == cur || val[i][j] == next);
			if (val[i][j] == next)
				ans[i][j] = '1';
		}
	}

	for (const auto &s : ans)
		cout << s << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	time_t st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif
	return 0;
}
