#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

#define SZ(A) int((A).size())
#define ALL(A) bend(A)
#define TYPEMAX(A) std::numeric_limits<A>::max()
#define TYPEMIN(A) std::numeric_limits<A>::min()

void solve() {
    int n = input<int>();

    vector<int> x(n), y(n), h(n);
    for (int i = 0; i < n; ++i)
	cin >> x[i] >> y[i] >> h[i];

    int64_t lo = 0;  // impos
    int64_t hi = TYPEMAX(int64_t) / 3;
    tuple<int64_t, int64_t, int64_t> ans = {-1, -1, -1};
    
    while (hi - lo > 1) {
	int64_t mi = lo + (hi - lo) / 2;

	int64_t minx = TYPEMIN(int64_t);
	int64_t maxx = TYPEMAX(int64_t);

	int64_t miny = TYPEMIN(int64_t);
	int64_t maxy = TYPEMAX(int64_t);

	bool ok = true;
	for (int i = 0; i < n; ++i) {
	    if (h[i] > mi)
		ok = false;

	    int64_t delta = mi - h[i];
 	    minx = max(minx, x[i] - delta);
	    maxx = min(maxx, x[i] + delta);
	    
	    miny = max(miny, y[i] - delta);
	    maxy = min(maxy, y[i] + delta);

	}

	if (ok and minx <= maxx and miny <= maxy) {
	    hi = mi;
	    ans = make_tuple(minx, miny, mi);
	} else {
	    lo = mi;
	}
    }

    cout << get<0>(ans) << " " << get<1>(ans) << " " << get<2>(ans) << "\n";
}


int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int test_count = 1;
	//cin >> test_count;
	for (int i = 0; i < test_count; i++) {
		solve();
	}
#ifdef LOCAL
	cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
