//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

bool first = true;
int minX, minY, maxX, maxY;

void add_point(int x, int y) {
    if (first) {
        minX = maxX = x;
        minY = maxY = y;
        first = false;
        return;
    }

    minX = min(minX, x);
    maxX = max(maxX, x);
    minY = min(minY, y);
    maxY = max(maxY, y);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x, y, h;
        cin >> x >> y >> h;
        add_point(x-h, y-h);
        add_point(x+h, y-h);
        add_point(x-h, y+h);
        add_point(x+h, y+h);
    }

    int w = maxX - minX;
    int h = maxY - minY;
    int side = max(w, h);
    if (side & 1) ++side;
    side /= 2;
    int cx = minX + side;
    int cy = minY + side;
    cout << cx << ' ' << cy << ' ' << side << endl;
    return 0;
}