//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m)), res;
    vector<vector<int>> ps(n + 1, vector<int>(m + 1));

    int ax, ay;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            if (a[i][j] != '.') {
                if (a[i][j] == 'A') {
                    ax = i;
                    ay = j;
                } else {
                    ps[i+1][j+1]++;
                }
            }
            ps[i+1][j+1] += ps[i][j+1] + ps[i+1][j] - ps[i][j];
        }
    }
    res = a;

    auto pfree = [&](int x1, int y1, int x2, int y2) {
        x2++, y2++;
        return (ps[x2][y2] - ps[x1][y2] - ps[x2][y1] + ps[x1][y1]) == 0;
    };

    int mm = -1;
    int x1, y1, x2, y2;
    for (int al = 0; al <= ax; ++al) {
        for (int ar = ax; ar < n; ++ar) {
            if (!pfree(al, ay, ar, ay)) continue;
            int l = 1, r = ay + 2;
            while (r - l > 1) {
                int m = (r + l) / 2;
                int cc = ay - m + 1;
                if (pfree(al, cc, ar, ay)) {
                    l = m;
                } else {
                    r = m;
                }
            }

            int Q = ay - l + 1;
            l = 1;
            r = m - ay + 1;
            while (r - l > 1) {
                int m = (r + l) / 2;
                int cc = ay + m - 1;
                if (pfree(al, ay, ar, cc)) {
                    l = m;
                } else {
                    r = m;
                }
            }

            int W = ay + l - 1;

            int area = (W - Q + 1) * (ar - al + 1);
            if (area > mm) {
                mm = area;
                x1 = al;
                x2 = ar;
                y1 = Q;
                y2 = W;
            }
        }
    }
    x2++, y2++;

    for (int i = x1; i < x2; ++i) {
        for (int j = y1; j < y2; ++j) {
            if (res[i][j] == '.') res[i][j] = 'a';
        }
    }

    auto partition = [&](int x1, int y1, int x2, int y2) {
        if (y2 <= y1 || x2 <= x1) return;
        vector<int> prevpts;
        int I = -1;
        q:;
        for (int i = x1; i < x2; ++i) {
            vector<int> pts;
            for (int j = y1; j < y2; ++j) {
                if (a[i][j] != '.' && a[i][j] != 'A') {
                    pts.push_back(j);
                }
            }
            if (prevpts.empty()) {
                if (!pts.empty()) {
                    prevpts = pts;
                    I = i;
                    goto q;
                } else {
                    continue;
                }
            }
            int ii = i;
            if (pts.empty()) {
                pts = prevpts;
                ii = I;
            } else {
                prevpts = pts;
                I = i;
            }
            int cur = y1;
            for (int t : pts) {
                for (; cur <= t; ++cur) {
                    if (res[i][cur] == '.') res[i][cur] = tolower(a[ii][t]);
                }
            }
            for (; cur < y2; ++cur) {
                if (res[i][cur] == '.') res[i][cur] = tolower(a[ii][pts.back()]);
            }
        }
    };

    partition(0, 0, x1, m);
    partition(x2, 0, n, m);
    partition(x1, 0, x2, y1);
    partition(x1, y2, x2, m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << res[i][j];
        }
        cout << '\n';
    }

    return 0;
}