#include <bits/stdc++.h>

using namespace std;

typedef long double ld;

const ld EPS = 1e-9;

bool ls(ld& a, ld& b) {
    return a - b < EPS;
}

const int MAXN = 5e7 + 7;

ld v[MAXN];
int lst[MAXN];
int path[MAXN];

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cout << fixed << setprecision(20);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fill(&v[0], &v[0] + MAXN, 1.1);
    int n;
    cin >> n;
    v[0] = -1.1;
    lst[0] = -1;
    int len = 0, l, r, m;
    ld cur;
    for (int j = 0; j < MAXN && len < n; j++) {
        l = 0, r = len + 1;
        cur = sin(j);
        while (l + 1 < r) {
            m = (l + r) / 2;
            if (ls(cur, v[m]))
                r = m;
            else
                l = m;
        }
        path[j] = lst[r - 1];
        lst[r] = j;
        v[r] = cur;
        len = max(len, r);
        //cout << j << ' ' << len << endl;
    }

    assert(len == n);

    int x = lst[len];
    while (x != -1) {
        cout << x << "\n";
        x = path[x];
    }
    return 0;
}