
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end();


using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 30;

vector <int> g[MAXN];

vector <int> dp1(MAXN, MAXN);
vector <int> dp2(MAXN, 0);
vector <int> a1(MAXN, MAXN);
vector <int> a2(MAXN, 0);

bool c[MAXN];

void dfs(int u, int p)
{
    if (c[u])
    {
        dp1[u] = 0;
        dp2[u] = 0;
    }
    for (int v : g[u])
    {
        if (v == p)
            continue;
        dfs(v, u);
        dp1[u] = min(dp1[u], dp1[v] + 1);
        if (dp2[v] != 0 || c[v])
            dp2[u] = max(dp2[u], dp2[v] + 1);
    }
}

void dfs2(int u, int p)
{
    multiset <pair <int, int>> st1, st2;
    if (c[u])
    {
        st1.insert({0, u});
        st2.insert({0, u});
    }
    for (int v : g[u])
    {
        st1.insert({dp1[v] + 1, v});
        if (dp2[v] != 0 || c[v])
            st2.insert({dp2[v] + 1, v});
    }

    a1[u] = st1.begin()->first;
    if (!st2.empty())
        a2[u] = st2.rbegin()->first;

    for (int v : g[u])
    {
        if (v == p)
            continue;
        st1.erase({dp1[v] + 1, v});
        st2.erase({dp2[v] + 1, v});
        dp1[u] = st1.begin()->first;
        if (!st2.empty())
            dp2[u] = st2.rbegin()->first;
        else
            dp2[u] = 0;
        dfs2(v, u);
        st1.insert({dp1[v] + 1, v});
        if (dp2[v] != 0 || c[v])
            st2.insert({dp2[v] + 1, v});
        dp1[u] = st1.begin()->first;
        if (!st2.empty())
            dp2[u] = st2.rbegin()->first;
    }
}

int main()
{
#ifdef PC
    freopen("in", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 1; i < n; i++)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < m; i++)
    {
        int x;
        cin >> x;
        c[x] = 1;
    }
    dfs(1, -1);
    dfs2(1, -1);

    for (int i = 1; i <= n; i++)
    {
        if (a1[i] == a2[i])
        {
            return cout << "YES\n" << i, 0;
        }
    }
    cout << "NO";
    return 0;
}
