
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end()
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

int main()
{
#ifdef PC
    freopen("in", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    int mx = 0, total = 0;
    vector <int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        mx = max(a[i], mx);
        total += a[i];
    }
    auto get = [&](int sum)
    {
        int ans = 0, cur = 0;
        for (int i = 0; i < n; i++)
        {
            cur += a[i];
            if (cur == sum)
                cur = 0, ans++;
            else if (cur > sum)
                cur = a[i], ans++;
        }
        if (cur != 0)
            ans++;
        return ans;
    };


    vector <pair <int, int>> blocks;
    blocks.push_back({mx, get(mx)});


    while (blocks.back().second != 1)
    {
        int l = blocks.back().first, r = total + 1, m;
        while (l + 1 < r)
        {
            if (get(m = (l + r) / 2) == blocks.back().second)
                l = m;
            else
                r = m;
        }
        blocks.push_back({r, get(r)});
    }

    int m;
    cin >> m;

    while (m--)
    {
        int sum;
        cin >> sum;
        auto it = upper_bound(all(blocks), make_pair(sum, n + n));
        if (it == blocks.begin())
            cout << "Impossible\n";
        else
        {
            cout << ((--it)->second) << "\n";
        }
    }

    return 0;
}
