
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) (x).begin(), (x).end();


using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const ll MAXH = 1e18;

struct obe
{
    ll x, y, h;
    obe() : x(0), y(0), h(0) {};
    obe(ll _x, ll _y, ll _h) : x(_x), y(_y), h(_h) {};
};

bool cmp1(obe a, obe b)
{
    return a.x < b.x;
}

bool cmp2(obe a, obe b)
{
    return a.y < b.y;
}

int n;
vector <obe > a, b;

bool kekx(int id, ll h, ll &ax)
{
    ll mx = a[id + 1].x, mn = a[id].x;
    for (int i = 0; i <= id; i++)
        mx = min(mx, a[i].x + h - a[i].h);
    for (int i = id + 1; i < a.size(); i++)
        mn = max(mn, a[i].x + a[i].h - h);
    ax = mx;
    return mn <= mx;
}

bool keky(int id, ll h, ll &ay)
{
    ll mx = b[id + 1].y, mn = b[id].y;
    for (int i = 0; i <= id; i++)
        mx = min(mx, b[i].y + h - b[i].h);
    for (int i = id + 1; i < b.size(); i++)
        mn = max(mn, b[i].y + b[i].h - h);
    ay = mx;
    return mn <= mx;
}

bool findxy(ll h, ll &ax, ll &ay)
{
    bool flx = 0, fly = 0;
    for (int i = 0; i < a.size() - 1; i++)
        if (kekx(i, h, ax))
        {
            flx = 1;
            break;
        }

    for (int i = 0; i < b.size() - 1; i++)
        if (keky(i, h, ay))
        {
            fly = 1;
            break;
        }
    return flx & fly;
}

void bin(ll &ax, ll &ay, ll &ah)
{
    ll l = 0, r = MAXH, m;
    ll x, y;
    while(l + 1 < r)
    {
        m = (l + r) / 2;
        if (findxy(m, x, y))
            r = m;
        else
            l = m;
    }
    findxy(r, ax, ay);
    ah = r;
}

int main()
{
#ifdef PC
    freopen("in", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].x >> a[i].y >> a[i].h;
        b[i] = a[i];
    }

    sort(a.begin(), a.end(), cmp1);
    a.push_back(a.back());
    sort(b.begin(), b.end(), cmp2);
    b.push_back(b.back());

    ll x = 0, y = 0, h = 0;

    bin(x, y, h);
    cout << x << ' ' << y << ' ' << h << "\n";

    return 0;
}
