#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

vector<vector<int> > g;
vector<char> hab;
vector<int> d;

int d_dfs(int v, int p)
{
	d[v] = hab[v] ? 0 : -2;
	for (int u : g[v]) if (u != p)
	{
		int k = d_dfs(u, v);
		if (k == -1)
			d[v] = -1;
		if (k == -2)
			continue;
		k++;
		if (d[v] == -2)
			d[v] = k;
		if (d[v] != k)
			d[v] = -1;
	}
	return d[v];
}

int a_dfs(int v, int p, int tl)
{
	if (d[v] >= 0 && (d[v] == tl || !tl))
		return v;
	vector<pair<int, int> > ch;
	if (p != -1 && g[v].size() == 1)
		return -1;
	for (int u : g[v]) if (u != p)
		ch.push_back({ d[u] >= 0 ? d[u] + 1 : d[u], u });
	sort(ch.begin(), ch.end());
	int ntl = tl;
	if (tl)
		ntl++;
	if (hab[v] && !tl)
		ntl = 1;
	if (hab[v] && tl)
		return -1;
	if (ch.size() == 1)
		return a_dfs(ch[0].second, v, ntl);
	for (int i = 0; i < ch.size(); i++)
	{
		if (i)
			if (ch[i - 1].first != -2)
				continue;
		if (i < ch.size() - 1)
			if (ch[i + 1].first != ch.back().first || ntl && ch.back().first + 1 != ntl || ch[i + 1].first < 0)
				continue;
		int nntl = (i < ch.size() - 1) ? max(ch[i + 1].first + 1, 0) : ntl;
		int ret = a_dfs(ch[i].second, v, nntl);
		if (ret != -1)
			return ret;
	}
	return -1;
}

int32_t main()
{
#ifdef _DEBUG
	ifstream cin("input.txt");
#endif // _DEBUG

	int n, m;
	cin >> n >> m;
	g.resize(n);
	hab.resize(n);
	d.resize(n);
	for (int i = 0; i < n - 1; i++)
	{
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 0; i < m; i++)
	{
		int v;
		cin >> v;
		hab[v - 1] = 1;
	}
	d_dfs(0, -1);
	int t = a_dfs(0, -1, 0);
	if (t + 1)
		cout << "YES\n" << t + 1;
	else
		cout << "NO";
	return 0;
}