#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

int solve(const vector<int> &a, const vector<int>& p, int t)
{
	int n = a.size();
	if (t <= 100)
	{
		int pb = 0;
		int ret = 1;
		for (int i = 0; i < n; i++)
		{
			if (a[i] + pb > t)
			{
				ret++;
				pb = 0;
			}
			pb += a[i];
		}
		return ret;
	}
	for (int i = 0; i < n; i++)
	{
		int ret = 0;
		for (auto i = p.begin(); i != p.end() - 1; i = upper_bound(p.begin(), p.end(), *i + t) - 1)
			ret++;
		return ret;
	}
}

int32_t main()
{
#ifdef _DEBUG
	ifstream cin("input.txt");
#endif // _DEBUG
	int n;
	cin >> n;
	vector<int> a(n);
	int mx = 0;
	for (int& i : a)
	{
		cin >> i;
		mx = max(mx, i);
	}
	vector<int> p(n + 1);
	for (int i = 0; i < n; i++)
		p[i + 1] = p[i] + a[i];
	const int u_pc = 1e4;
	vector<int> p_ans(u_pc);
	for (int i = mx; i < u_pc; i++)
	{
		p_ans[i] = solve(a, p, i);
	}
	int m;
	cin >> m;
	for (int i = 0; i < m; i++)
	{
		int t;
		cin >> t;
		//cerr << t << " : ";
		if (t < mx)
			cout << "Impossible\n";
		else if (t < u_pc)
			cout << p_ans[t] << "\n";
		else
			cout << solve(a, p, t) << "\n";
	}
	return 0;
}