#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

using namespace std;

const int inf = (int)1e9 + 1;

inline void setmin(int &x, int y) { if (y < x) x = y; }
inline void setmax(int &x, int y) { if (y > x) x = y; }

int main()
{
    #ifdef kek
        ifstream cin("a.in");
    #endif // kek

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    int x[n], y[n], h[n];

    rep(i, 0, n)
    {
        cin >> x[i] >> y[i] >> h[i];
    }

    int L = 0, R = 1000000000, mid;
    while (R - L > 1)
    {
        mid = (L + R) / 2;
        int u = inf, d = -inf, l = -inf, r = inf;
        rep(i, 0, n)
        {
            setmin(u, y[i] + (mid - h[i]));
            setmax(d, y[i] - (mid - h[i]));
            setmin(r, x[i] + (mid - h[i]));
            setmax(l, x[i] - (mid - h[i]));
        }
        if (d <= u && l <= r)
        {
            R = mid;
        }
        else
        {
            L = mid;
        }
    }

    mid = R;
    int u = inf, d = -inf, l = -inf, r = inf;
    rep(i, 0, n)
    {
        setmin(u, y[i] + (mid - h[i]));
        setmax(d, y[i] - (mid - h[i]));
        setmin(r, x[i] + (mid - h[i]));
        setmax(l, x[i] - (mid - h[i]));
    }
    if (d <= u && l <= r)
    {
        r = mid;
    }
    else
    {
        l = mid;
    }
    cout << l << " " << d << " " << mid << endl;
    return 0;
}
