#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> bfs(deque<pair<int, int>> &c, vector<vector<int>> &a) {
    vector<pair<int, int>> p(a.size(), {-1, -1});
    while (c.size()) {
        pair<int, int> pa = c.front();
        c.pop_front();
        int v = pa.first;
        if (pa.second == -1)
            p[v] = {0, -1};
        else
            p[v] = {p[pa.second].first + 1, pa.second};
        for (int i_to = 0; i_to < a[v].size(); i_to++) {
            int to = a[v][i_to];
            if (p[to].first == -1) {
                c.push_back({to, v});
            }
        }
    }
    return p;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, u, v;
    cin >> n >> m;
    vector<vector<int>> a(n);
    vector<int> teams(m);
    for (int i = 1; i < n; i++) {
        cin >> u >> v;
        u--; v--;
        a[u].push_back(v);
        a[v].push_back(u);
    }
    for (int i = 0; i < m; i++) {
        cin >> teams[i];
        teams[i]--;
    }
    if (m == 1) {
        cout << "YES" << endl << teams[0] + 1;
        return 0;
    }
    deque<pair<int, int>> c1(m);
    for (int i = 0; i < m; i++)
        c1[i] = {teams[i], -1};
    vector<pair<int, int>> path1 = bfs(c1, a);
    int curr = 0;
    for (int i = 0; i < n; i++)
    {
        if (path1[curr].first < path1[i].first)
            curr = i;
    }
    /*for (int i = 0; i < n; i++)
        cout << path1[i].first<< " " << path1[i].second << endl;
    cout << endl;*/
    /*deque<pair<int, int>> c1(1, {teams[0], -1});
    vector<pair<int, int>> path1 = bfs(c1, a);
    if (path1[teams[1]].first % 2) {
        cout << "NO";
        return 0;
    }
    int curr = teams[1];
    for (int i = 0; i < path1[teams[1]].first / 2; i++)
        curr = path1[curr].second;*/
    deque<pair<int, int>> c2(1, {curr, -1});
    vector<pair<int, int>> path2 = bfs(c2, a);
    for (int i = 1; i < m; i++) {
        if (path2[teams[i-1]].first != path2[teams[i]].first) {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES" << endl << curr+1;
}
