#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <queue>
#include <map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	std::vector<int> a(n + 1, 0), sum(n + 1, 0);

	int mx = 0;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		mx = max(mx, a[i]);
		sum[i] = sum[i - 1] + a[i];
	}
	int PREC = 10000;
	int B = 300;

	std::vector<int> ans(PREC + 1, - 1);
	for (int q = mx; q <= PREC; q++) {
		int s = q;
		int cnt = 0;
		for (int l = 1; l <= n;) {
			int r = min(l + B - 1, n);
			while (l <= r && sum[r] - sum[l - 1] >= s) {
				s -= sum[r] - sum[l - 1];
				l = r + 1;
				r = min(l + B - 1, n);
			}
			cnt++;
		}
		ans[q] = cnt;
	}
	int SIZE = 1000 * 1000 + 1000;
	std::vector<int> p(SIZE, -1);
	p[0] = 0;
	for (int i = 1; i <= n; i++) {
		p[sum[i]] = sum[i];
	}
	int last = 0;
	for (int i = 1; i <= SIZE; i++) {
		if (p[i] != -1) {
			p[i] = last;
		} 
		last = p[i];
	}

	int m;
	cin >> m;
	while (m--) {
		int x;
		cin >> x;
		if (x <= PREC) {
			if (ans[x] == -1) {
				cout << "Impossible\n";
				continue;
			}
			cout << ans[x] << "\n";
		}
		else {
			int cnt = 0;
			int c = 0;
			while (c != sum[n]) {
				if (c == p[c + x]) {
					cout << "Impossible\n";
					continue;
				}
				c = p[c + x];
				cnt++;
			}
			cout << cnt << "\n";
		}
	}
	
}
