#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <queue>
#include <map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	std::vector<std::vector<char>> a(n, std::vector<char>(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			char x;
			cin >> x;
			a[i][j] = x - '0';
		}
	}

	std::vector<std::vector<char>> v(n, std::vector<char>(n));
	std::vector<std::vector<bool>> have(n, std::vector<bool>(n, false));

	for (int i = 0; i + 1 < n; i++) {
		if (a[i][i + 1] != 0) {
			have[i][i + 1] = true;
		}
	}

	for (int len = 2; len < n; len++) {
		
		for (int i = 0; i + len < n; i++) {
			int sum = 0;
			for (int k = i + 1; k < i + len; k++) {
				if (have[i][k]) {
					sum += a[k][i + len];
				}
			}
			
			if (sum % 10 != a[i][i + len])
				have[i][i + len] = true;
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << have[i][j];
		}
		cout << "\n";
	}

	return 0;
}

/*
5
01113
00012
00001
00001
00000
*/