#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <queue>
#include <map>

using namespace std;

bool f[2000][2001];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	vector<int> N(2001, 0);
	for (int i = 1; i <= 2000; i++) {
		N[i] = N[i - 1] + i;
	}

	vector<int> calc(2001, 0);
	calc[3] = 1;
	for (int i = 4; i <= 2000; i++) {
		calc[i] = calc[i - 1] + N[i-2];
	}

	int t;
	cin >> t;
	while (t--)
	{
		int n; cin >> n;
		vector<pair<int, short int>> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i].first;
			a[i].second = i + 1;
		}
		sort(a.begin(), a.end());

		vector< pair<int, vector<short int>> > s;
		s.push_back({a[0].first, vector<short int>()});
		s[0].second.push_back(a[0].second);
		for (int i = 1; i < n; i++) {
			if (s[s.size() - 1].first == a[i].first) {
				s[s.size() - 1].second.push_back(a[i].second);
			}
			else {
				s.push_back({ a[i].first, vector<short int>() });
				s[s.size() - 1].second.push_back(a[i].second);
			}
		}

		for (int i = 0; i < s.size(); i++) {
			for (int j = 0; j <= n; j++) {
				f[i][j] = false;
			}
		}

		for (int i = 0; i < s.size(); i++) {
			for (int j = 0; j < s[i].second.size(); j++) {
				int to = s[i].second[j];
				f[i][to] = true;
			}
		}

		vector<vector<short int>> pref(s.size(), vector<short int>(n + 1, 0));
		for (int i = 0; i < s.size(); i++) {
			for (int j = 1; j <= n; j++) {
				pref[i][j] = pref[i][j - 1] + f[i][j];
			}
		}

		int ans = 0;

		for (int i = 0; i < s.size(); i++) {
			ans += calc[s[i].second.size()];
		}

		for (int j = 1; j < s.size() - 1; j++)
		{
			int l = j - 1;
			int r = j + 1;

			while (l >= 0 && r < s.size())
			{
				if (s[j].first - s[l].first < s[r].first - s[j].first) { // go to 0
					while (l > 0 && (s[r].first - s[j].first > s[j].first - s[l].first)) {
						l--;
					}

					if (s[j].first - s[l].first == s[r].first - s[j].first) {
						for (int to : s[j].second) {
							ans += pref[l][to - 1] * (pref[r][n] - pref[r][to]);
							ans += pref[r][to - 1] * (pref[l][n] - pref[l][to]);
						}
						l--;
						r++;
					}
					else {
						r++;
					}
				}
				else if (s[j].first - s[l].first > s[r].first - s[j].first) { // go to s.size() - 1
					while ((r < (s.size() - 1)) && (s[r].first - s[j].first < s[j].first - s[l].first)) {
						r++;
					}

					if (s[j].first - s[l].first == s[r].first - s[j].first) {
						for (int to : s[j].second) {
							ans += pref[l][to - 1] * (pref[r][n] - pref[r][to]);
							ans += pref[r][to - 1] * (pref[l][n] - pref[l][to]);
						}
						l--;
						r++;
					}
					else {
						l--;
					}
				}
				else {

					for (int to : s[j].second) {
						ans += pref[l][to - 1] * (pref[r][n] - pref[r][to]);
						ans += pref[r][to - 1] * (pref[l][n] - pref[l][to]);
					}

					l--;
					r++;
					if (l < 0 || r >= s.size()) {
						break;
					}
				}
			}
		}

		cout << ans;
	}

	return 0;
}

/*

5
1 2 1 2 1

9
3 1 4 1 5 9 2 6 5

5
1 2 2 3 4

3
30 20 10
*/