#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include <unordered_map>
#include <queue>
#include<map>



typedef int ll;

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	ll t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> v(n);
		for (ll i = 0; i < n; i++) {
			cin >> v[i];
		}

		vector<map<int, short int>> cntsuff(n);
		cntsuff[n - 1][v[n - 1]]++;
		for (int i = n - 2; i >= 0; i--) {
			cntsuff[i] = cntsuff[i + 1];
			cntsuff[i][v[i]]++;
		}

		int ans = 0;
		for (int i = 0; i < n - 2; i++) {
			for (int j = i + 1; j < n - 1; j++) {
				ans += cntsuff[j + 1][v[j] + v[j] - v[i]];
			}
		}
		cout << ans << "\n";
	}

	return 0;
}

/*
4
5 1 2 1 2 1
3 30 20 10
5 1 2 2 3 4
9 3 1 4 1 5 9 2 6 5
*/