//Glushen
#include <bits/stdc++.h>
using ll = long long;
using namespace std;

vector<vector<ll>> a;
vector<bool> b;
ll diam = -1;
ll center = -1;

void dfs1(ll cur, ll parent = -1, ll dist = 0) {
    if (b[cur] && dist != 0) {
        if (diam < dist) {
            diam = dist;
            center = -1;
        }
    }

    for (auto t : a[cur]) {
        if (t == parent) continue;
        dfs1(t, cur, dist+1);
    }

    if (dist*2 == diam && center == -1) {
        center = cur;
    }
}

void dfs2(ll cur = center, ll parent = -1, ll dist = 0) {
    if (b[cur]) {
        if (dist*2 != diam) {
            cout << "NO";
            exit(0);
        }
    }

    for (auto t : a[cur]) {
        if (t == parent) continue;
        dfs2(t, cur, dist+1);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    a.resize(n);

    if (n == 1) {
        cout << "YES\n1";
        return 0;
    }

    for (ll i = 0; i < n-1; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }

    b.resize(n);

    ll x = -1;

    for (ll i = 0; i < m; i++) {
        cin >> x;
        x--;
        b[x] = true;
    }

    if (m == 1) {
        cout << "YES\n" << x+1;
        return 0;
    }

    dfs1(x);
    if (center == -1) {
        cout << "NO";
        return 0;
    }
    dfs2();

    cout << "YES\n" << (center+1);
}