#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <map>
#include <set>
#include <cmath>
#include <unordered_map>
using namespace std;

using li = long long;
using vi = vector<li>;
using vvi = vector<vi>;
using vpi = vector<pair<li, li>>;

#define rnd() rand() + rand()*(RAND_MAX + 1) 
#define forn(i,n) for(li i = 0; i < (li)n; i++)
#define ford(i,n) for(li i = n - 1; i >= 0; i--)
#define fore(i,l,r) for(li i = l;i < r; i++)
#define all(a) a.begin(),a.end()

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vvi vec(n, vi(n));
	forn(i,n){
		string s;
		cin >> s;
		forn(j, n)
			vec[i][j] = s[j] - '0';
	}
	for (int i = n - 1; i >= 0; i--) {
		for (int j = n - 1; j >= i; j--) {
			for (int k = 0; k < n; k++)
				vec[i][k] = ((vec[i][k] - vec[j][k] * vec[i][j]) % 10 + 10) % 10;
		}
	}
	forn(i, n) {
		forn(j, n)
			cout << vec[i][j];
		cout << endl;
	}
}