#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <map>
#include <unordered_map>
using namespace std;

using li = long long;
using vi = vector<li>;
using vvi = vector<vi>;
using vpi = vector<pair<li, li>>;

#define rnd() rand() + rand()*(RAND_MAX + 1) 
#define forn(i,n) for(li i = 0; i < (li)n; i++)
#define ford(i,n) for(li i = n - 1; i >= 0; i--)
#define fore(i,l,r) for(li i = l;i < r; i++)
#define all(a) a.begin(),a.end()

void solve()
{
	li n;
	cin >> n;
	vi a(n);
	forn(i, n)
		cin >> a[i];
	unordered_map<li, li> mp(1000000);
	li res = 0;
	forn(i, n)
	{
		fore(j, i + 1, n)
			if (mp.count(2 * a[i] - a[j]))
				res += mp[2 * a[i] - a[j]];
		mp[a[i]]++;
	}
	cout << res << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	forn(i, n)
		solve();
}