
#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define sz(s) (int)(s).size()
#define mp make_pair
using namespace std;

typedef long double ld;
typedef long long ll;
mt19937 rng(time(0));

struct que {
    int x;
    int ans;
    int i;

    bool operator < (que const& q) const {
        return x < q.x;
    }
};

unordered_map<int, int> res;

int get(vector<int> const& a, int x) {
    if (!res.count(x)) {
        int ans = 1;
        int s = a[0];
        for (int i = 1; i < a.size(); i++) {
            if (s + a[i] > x) {
                ans++;
                s = 0;
            }
            s += a[i];
        }
        res[x] = ans;
    }
    return res[x];
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //freopen("input.txt", "r", stdin);
    cout.precision(12);

    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &e : a) cin >> e;

    int Q;
    cin >> Q;
    vector<que> q(Q);
    for (int qq = 0; qq < Q; qq++) {
        cin >> q[qq].x;
        q[qq].i = qq;
    }
    sort(ALL(q));

    int mx = 0;
    for (int i = 0; i < n; i++) {
        mx = max(mx, a[i]);
    }

    for (int i = 0; i < Q; i++) {
        if (q[i].x < mx) {
            q[i].ans = -1;
            continue;
        }

        int ans = get(a, q[i].x);
        int l = i, r = Q;
        while (r - l > 1) {
            int m = (l + r) / 2;

            if (get(a, q[m].x) == ans) {
                l = m;
            } else {
                r = m;
            }
        }

        for (int j = i; j <= l; j++) {
            q[j].ans = ans;
        }
        i = l;
    }

    sort(ALL(q), [](que const& q1, que const& q2) {
         return q1.i < q2.i;
         });
    for (auto e : q) {
        if (e.ans == -1) cout << "Impossible\n";
        else cout << e.ans << endl;
    }
}
