
#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define sz(s) (int)(s).size()
#define mp make_pair
using namespace std;

typedef long double ld;
typedef long long ll;
mt19937 rng(time(0));

const ll INF = 1e18;

struct pt {
    int x, y, h;
};

struct rect {
    int x1, y1;
    int x2, y2;
    bool good = false;
};

rect get(vector<pt> const& a, int h) {
    vector<rect> b;
    for (auto e : a) {
        rect x;
        int dh = h - e.h;
        x.x1 = e.x - dh;
        x.x2 = e.x + dh;
        x.y1 = e.y - dh;
        x.y2 = e.y + dh;
        b.push_back(x);
    }

    rect ans;
    ans.x1 = (int) -2e9;
    ans.y1 = (int) -2e9;
    ans.x2 = (int) 2e9;
    ans.y2 = (int) 2e9;

    for (auto e : b) {
        ans.x1 = max(ans.x1, e.x1);
        ans.y1 = max(ans.y1, e.y1);
        ans.x2 = min(ans.x2, e.x2);
        ans.y2 = min(ans.y2, e.y2);
    }
    if (ans.x1 <= ans.x2 && ans.y1 <= ans.y2) ans.good = true;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cout.precision(12);
    int n;
    cin >> n;

    vector<pt> a(n);
    int mn = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y >> a[i].h;
        mn = max(mn, a[i].h);
    }

    int l = mn, r = (int) 1e9;
    while (r - l > 1) {
        int m = (l + r) / 2;
        rect ans = get(a, m);
        if (ans.good) {
            r = m;
        } else {
            l = m;
        }
    }
    rect ans = get(a, l);
    if (!ans.good) {
        ans = get(a, r);
        l = r;
    }

    cout << ans.x1 << ' ' << ans.y1 << ' ' << l;
    /*
    int k = 25000;
    int N = 1000000; //1e7
    vector<pair<ld, int>> v;
    int start = 1067218473;
    cout << start << endl;
    for (int i = start, j = 0; j < N; i++, j++) {
        while (sin(i) < 0)
            i++;
        v.emplace_back(sin(i), i);
    }
    sort(ALL(v));
    int cnt = 1;
    vector<pair<ll, int>> dp(N + 2, mp(INF, -1));
    dp[0].first = -INF;
    int mx = 0;
    for (int i = 0; i < N; i++) {
        int j = lower_bound(ALL(dp), mp(1LL * v[i].second, -1)) - dp.begin();
        dp[j] = mp(v[i].second, i);
        mx = max(mx, j);
        //cout << " " << j << endl;
    }
    cout << mx << endl;
    mx = dp[mx].second;
    for (int i = mx; i >= 0; i--) {
        if (v[i].second <= v[mx].second) {
            mx = i;
            cout << v[i].second << " " << v[i].first << endl;
        }
    }
    //cout << mx << endl;
    */
}
