#include <iostream>
#include <bits/stdc++.h>;
using namespace std;

vector<int> ver[200005];
int c[200005];
int way[200005];
bool visited[200005];

void bfs(int node, int len)
{
    if (visited[node] == true)
        return;
    visited[node] = true;

    for (int j = 0; j < ver[node].size(); j++)
    {
        if (way[ver[node][j]] == -1 && visited[ver[node][j]] == false)
            way[ver[node][j]] = len + 1;
    }

    for (int j = 0; j < ver[node].size(); j++)
        bfs(ver[node][j], len + 1);
}

int main()
{
    int n,m;
    cin>>n>>m;

    if (n == m) {
        cout << "NO";
        return 0;
    }

    for (int i = 0; i < n - 1;i++)
    {
        int u,v;
        cin>>u>>v;
        ver[u].push_back(v);
        ver[v].push_back(u);
    }
    for (int i = 1; i <= m; i++) cin>>c[i];

    sort(c);
    int qindex = 0;
    for (int i = 1; i <= n; i++)
        {
            for (int ij = 0; ij <= n; ij++) { visited[ij] = false; way[ij] = -1; }
            if (i == c[qindex++])
                continue;

            bfs(i, 0);
            bool good = true;
            for (int j = 2; j <= m; j++)
                if ( way[c[j]] != way[c[j - 1]] || way[c[j]] + way[c[j - 1]] == -2)
                    good = false;

            if (good == true) {
                cout<<"YES\n"<<i;
                return 0;
            }

        }
        cout<<"NO";
    return 0;
}
