#include <iostream>
#include <cstdlib>
#include <vector>
#include <queue>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;

    vector<int> xs(n);
    vector<int> ys(n);
    vector<int> hs(n);

    int l = 1;

    for (int i = 0; i < n; i++) {
        cin >> xs[i] >> ys[i] >> hs[i];
        l = max(l, hs[i]);
    }
    l--;

    int r = 1000000001;

    int x = 0, y = 0;

    while (r - l > 1) {
        int m = (r + l) >> 1;

        int curxl = -100000000;
        int curyl = -100000000;
        int curxh =  100000000;
        int curyh =  100000000;
        for (int i = 0; i < n; i++) {
            int xl = xs[i] - m + hs[i];
            int yl = ys[i] - m + hs[i];
            int xh = xs[i] + m - hs[i];
            int yh = ys[i] + m - hs[i];

            curxl = max(curxl, xl);
            curyl = max(curyl, yl);
            curxh = min(curxh, xh);
            curyh = min(curyh, yh);

            if (curyh < curyl || curxh < curxl) {
                break;
            }
        }

        if (curyh < curyl || curxh < curxl) {
            l = m;
        }
        else {
            r = m;
            x = curxl;
            y = curyl;
        }

    }

    cout << x << " " << y << " " << r << endl;

    return 0;
}
