#include <iostream>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;

    for (int tt = 0; tt < t; tt++) {
        int n;
        cin >> n;
        vector<int> diffs(n);
        set<int> difdiffs;

        for (int i = 0; i < n; i++) {
            cin >> diffs[i];
            difdiffs.insert(diffs[i]);
        }

        map<int, vector<int> > sufsums;

        for (int diff : difdiffs) {
            sufsums[diff] = vector<int>(n);
            int curc = 0;
            for (int i = n - 1; i >= 0; --i) {
                if (diffs[i] == diff) {
                    ++curc;
                }
                sufsums[diff][i] = curc;

            }
        }

        /* for (auto p : sufsums) {
            cout << p.first << ": ";
            for (auto i : p.second) {
                cout << i << " ";
            }
            cout << endl;
        } */

        int ans = 0;
        for (int i = 0; i < n - 2; i++) {
            for (int j = i + 1; j < n - 1; j++) {
                int reqdif = diffs[j] + diffs[j] - diffs[i];
                if (sufsums.count(reqdif)) {
                    ans += sufsums[reqdif][j + 1];
                }
            }
        }

        cout << ans << endl;
    }

    return 0;
}
