#include <iostream>
#include <vector>
#include <set>

using namespace std;

int n, m;
vector<vector<int>> g;
set<pair<int, int>> c;

vector<bool> used;
vector<int> path;
int mid, x, y, d;

bool dfs(int s, int f) {
    used[s] = 1;
    path.push_back(s);
    if (s == f) {
        d = (path.size() - 1 + x + y) / 2;
        mid = path[(path.size() - 1 + y - x) / 2];
        return ((path.size() - 1 + x + y) % 2 == 0);
    }
    for (auto to : g[s]) {
        if (!used[to]) {
            return dfs(to, f);
        }
    }
    path.pop_back();
}

int main() {
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int from, to;
        cin >> from >> to;
        g[from - 1].push_back(to - 1);
        g[to - 1].push_back(from - 1);
    }
    for (int j = 0; j < m; j++) {
        int city;
        cin >> city;
        c.insert({city - 1, 0});
    }
    while (c.size() > 1) {
        pair<int, int> city1 = *c.begin();
        c.erase(c.begin());
        pair<int, int> city2 = *c.begin();
        c.erase(c.begin());
        used.assign(n, 0);
        path = vector<int>();
        x = city1.second;
        y = city2.second;
        if (dfs(city1.first, city2.first)) {
            c.insert({mid, d});
        } else {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES\n" << c.begin() -> first + 1;
    return 0;
}