#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 200100;
const int INF = (int)1e9 + 7;
const int MAGIC = 1000;

int a[N];
int ans[N];

class Query {
public:
    int s, id;

    bool operator<(const Query& other) const {
        return s < other.s;
    }
};

Query q[N];
int qRes[N];
int ptr[N];
int sums[N];

int main() {
    int n;
    scanf("%d", &n);

    int mx = -1;
    for (int i = 0; i < n; ++i) {
        scanf("%d", &a[i]);
        mx = std::max(mx, a[i]);
    }

    for (int s = 0; s <= MAGIC; ++s) {
        if (s < mx) {
            ans[s] = INF;
            continue;
        }

        int curS = a[0];
        ans[s] = 1;
        for (int i = 1; i < n; ++i) {
            if (curS + a[i] > s) {
                curS = a[i];
                ++ans[s];
            } else {
                curS += a[i];
            }
        }

//        std::cout << s << ' ' << ans[s] << '\n';
    }

    int m;
    scanf("%d", &m);

    for (int i = 0; i < m; ++i) {
        scanf("%d", &q[i].s);
        q[i].id = i;
    }

    std::sort(q, q + m);

    bool has = false;
    int ptrCnt = 0;
    for (int i = 0; i < m; ++i) {
        int id = q[i].id;
        int s = q[i].s;

        if (s <= MAGIC) {
            qRes[id] = ans[s];
            continue;
        }

        if (s < mx) {
            qRes[id] = INF;
            continue;
        }

        if (!has) {
            ptrCnt = 1;
            ptr[0] = 0;
            sums[0] = a[0];
            int curS = a[0];

            for (int j = 1; j < n; ++j) {
                if (curS + a[j] > s) {
                    curS = a[j];
                    ++ptrCnt;
                    ptr[ptrCnt - 1] = j;
                    sums[ptrCnt - 1] = a[j];
                } else {
                    sums[ptrCnt - 1] += a[j];
                    curS += a[j];
                    ++ptr[ptrCnt - 1];
                }
            }

            has = true;
            qRes[id] = ptrCnt;
            continue;
        }

        for (int j = 0; j < ptrCnt; ++j) {
            bool fl = false;

            if (j != 0 && ptr[j - 1] >= ptr[j]) {
                ptr[j] = ptr[j - 1] + 1;
                sums[j] = a[ptr[j]];
                if (ptr[j] == n) {
                    ptrCnt = j;
                    break;
                }
            }

            while (ptr[j] + 1 < n && sums[j] + a[ptr[j] + 1] <= s) {
                ++ptr[j];
                sums[j] += a[ptr[j]];
                sums[j + 1] -= a[ptr[j]];
                fl = true;
            }

//            if (!fl) {
//                break;
//            }

            if (ptr[j] + 1 == n) {
                ptrCnt = j + 1;
                break;
            }
        }

        qRes[id] = ptrCnt;
    }

    for (int i = 0; i < m; ++i) {
        if (qRes[i] == INF) {
            printf("Impossible\n");
            continue;
        }
        printf("%d\n", qRes[i]);
    }

    return 0;
}

/*
6 6
..B...
.C....
D.....
..A..X
....Y.
...Z..
*/