#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 1100;
const ll INF = (ll)1e10;

int n;
int x[N], y[N], h[N];

ll globalX, globalY;

bool check(ll hh) {
    ll l = -INF, r = INF;
    ll u = INF, d = -INF;

    for (int i = 0; i < n; ++i) {
        ll rr = hh - h[i];

        l = std::max(l, x[i] - rr);
        r = std::min(r, x[i] + rr);
        u = std::min(u, y[i] + rr);
        d = std::max(d, y[i] - rr);
    }

    globalX = l;
    globalY = u;

    return r >= l && u >= d;
}

int main() {

    scanf("%d", &n);

    for (int i = 0; i < n; ++i) {
        scanf("%d%d%d", &x[i], &y[i], &h[i]);
    }

    ll l = 0, r = INF;
    while (r - l > 1) {
        ll h = (l + r) / 2;

        if (check(h)) {
            r = h;
        } else {
            l = h;
        }
    }

    check(r);

    printf("%lld %lld %lld\n", globalX, globalY, r);

    return 0;
}