#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 1100;

char a[N][N];
int l[N], r[N];

void restore(int left, int right, int up, int down) {
    int u = up;
    std::vector<std::pair<int, char>> cols;
    for (int i = up; i <= down; ++i) {
        std::vector<std::pair<int, char>> curCols;

        for (int j = left; j <= right; ++j) {
            if (a[i][j] != '.') {
                curCols.push_back(std::make_pair(j, a[i][j]));
            }
        }

        if (curCols.empty()) {
            continue;
        }
        if (cols.empty()) {
            cols = curCols;
            continue;
        }

        while (u < i) {
            int ptr = 0;
            for (int j = left; j <= right; ++j) {
                if (a[u][j] == '.') {
                    a[u][j] = cols[ptr].second - 'A' + 'a';
                }
                if (cols[ptr].first == j && ptr != (int)cols.size() - 1) {
                    ++ptr;
                }
            }
            ++u;
        }

        cols.swap(curCols);
    }

    while (u <= down) {
        int ptr = 0;
        for (int j = left; j <= right; ++j) {
            if (a[u][j] == '.') {
                a[u][j] = cols[ptr].second - 'A' + 'a';
            }
            if (cols[ptr].first == j && ptr != (int)cols.size() - 1) {
                ++ptr;
            }
        }
        ++u;
    }
}

int main() {
    int n, m;
    scanf("%d%d", &n, &m);

    int row, col;
    for (int i = 0; i < n; ++i) {
        scanf("\n%s", a[i]);

        for (int j = 0; j < m; ++j) {
            if (a[i][j] == 'A') {
                row = i;
                col = j;
            }
        }
//        std::cout << "SOSI\n";
    }

//    std::cout << "SOSI";

    for (int i = 0; i < n; ++i) {
        l[i] = 0;
        r[i] = m - 1;

        if (a[i][col] != '.' && i != row) {
            l[i] = m;
            r[i] = -1;
            continue;
        }

        for (int j = col - 1; j >= 0; --j) {
            if (a[i][j] != '.') {
                l[i] = j + 1;
                break;
            }
        }

        for (int j = col + 1; j < m; ++j) {
            if (a[i][j] != '.') {
                r[i] = j - 1;
                break;
            }
        }
    }

//    std::cout << row << ' ' << col << '\n';

    int bestS = 0;
    int bestL, bestR, bestU, bestD;
    int upL = 0, upR = m - 1;
    for (int up = row; up >= 0; --up) {
        upL = std::max(upL, l[up]);
        upR = std::min(upR, r[up]);

        int downL = 0, downR = m - 1;
        for (int down = row; down < n; ++down) {
            downL = std::max(downL, l[down]);
            downR = std::min(downR, r[down]);

            int ll = std::max(upL, downL);
            int rr = std::min(upR, downR);

            if (ll > rr) {
                continue;
            }

            int curS = (rr - ll + 1) * (down - up + 1);
            if (curS > bestS) {
                bestS = curS;
                bestL = ll, bestR = rr;
                bestD = down, bestU = up;
            }
        }
    }

    for (int i = bestU; i <= bestD; ++i) {
        for (int j = bestL; j <= bestR; ++j) {
            if (a[i][j] == '.') {
                a[i][j] = 'a';
            }
        }
    }

//    for (int i = 0; i < n; ++i) {
//        std::cout << l[i] << ' ' << r[i] << '\n';
//    }

//    std::cout << bestS << '\n';
//    std::cout << bestU << ' ' << bestD << ' ' << bestL << ' ' << bestR << '\n';

    if (bestU != 0) {
        restore(0, m - 1, 0, bestU - 1);
    }
    if (bestD != n - 1) {
        restore(0, m - 1, bestD + 1, n - 1);
    }
    if (bestL != 0) {
        restore(0, bestL - 1, bestU, bestD);
    }
    if (bestR != m - 1) {
        restore(bestR + 1, m - 1, bestU, bestD);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            printf("%c", a[i][j]);
        }
        printf("\n");
    }

    return 0;
}

/*
6 6
..B...
.C....
D.....
..A..X
....Y.
...Z..
*/