#include <iostream>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int INF = 1e18 + 9;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    int max_x = -INF;
    int min_x = INF;
    int max_y = -INF;
    int min_y = INF;
    for (int i = 0; i < n; i++){
        int x, y, z;
        cin >> x >> y >> z;
        max_x = max(max_x, x + z);
        min_x = min(min_x, x - z);
        max_y = max(max_y, y + z);
        min_y = min(min_y, y - z);
    }

    int x = (max_x + min_x) / 2;
    int y = (max_y + min_y) / 2;
    int h = max(abs(x - max_x), x - min_x);
    h = max(abs(x - max_y), abs(x - min_y));

    cout << x << ' ' << y << ' ' << h;
    return 0;
}