#include <iostream>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define int long long

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;

    while (q--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int& x : a)
            cin >> x;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            unordered_set<int> s;
            unordered_map<int, int> d1;
            unordered_map<int, int> d2;

            for (int j = 0; j < i; j++) {
                int k = a[i] - a[j];
                s.insert(k);
                d1[k]++;
            }

            for (int j = i + 1; j < n; j++) {
                int k = a[j] - a[i];
                s.insert(k);
                d2[k]++;
            }
            int t = 0;
            for (auto x : s) {
                t += d1[x] * d2[x];
            }
            ans += t;
        }
        cout << ans << '\n';
    }


    return 0;
}