#include <bits/stdc++.h>

using namespace std;

int n, m;
set<pair<pair<int, int>, pair<int, int>>> used;
vector<string> v;
vector<pair<int, int>> deltas = {{-1, -1}, {-1, 1}, {1, 1}, {1, -1}};
vector<pair<int, int>> deltasb = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};
int sz = 0;
int xcnt = 0;

vector <pair <int, int>> ans;

bool dfs(int x, int y, bool backside = false) {
    ans.emplace_back(x, y);
    if (sz == xcnt * 2 - 1) {
        cout << ans.size() << '\n';
        for (auto& i : ans) cout << i.second << ' ' << i.first << '\n';
        exit(0);
        return true;
    }
    if (! backside) {
        for (auto& delta : deltas) {
            int nx = x + delta.first;
            int ny = y + delta.second;
            if (nx >= 0 && ny >= 0 && nx < n  && ny < m  && v[nx][ny] == 'X') {
                pair<int, int> a = {nx,ny};
                pair<int, int> b = {x,y};
                if (a < b) {
                    swap(a, b);
                }
                if (!used.count({a, b})) {
                    used.insert({a, b});
                    sz++;
                    if (dfs(nx, ny, true)) {

                    }
                    sz--;
                    used.erase({a, b});
                }
            }

        }
    } else {
        for (auto& delta : deltasb) {
            int nx = x + delta.first;
            int ny = y + delta.second;
            if (nx >= 0 && ny  >= 0 && nx < n  && ny < m  && v[nx][ny] == 'X') {
                pair<int, int> a = {nx, ny};
                pair<int, int> b = {x, y};
                if (a < b) {
                    swap(a, b);
                }
                if (!used.count({a, b})) {
                    used.insert({a, b});
                    if (dfs(nx, ny, false)) {

                    }
                    used.erase({a, b});
                }
            }
        }
    }
    ans.pop_back();
}

int main() {
    ios_base::sync_with_stdio(0);
    cin >> m >> n;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == 'X') {
                xcnt++;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (v[i][j] == 'X') {
                dfs(i, j);
            }
        }
    }



    return 0;
}
