#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <string>
using namespace std;

const long long INF = 1000000000000;

long long ceil(long long a, long long b){
    if(a % b == 0){
        return a / b;
    } else {
        return (a / b) + 1;
    }
}

int main(){
    long long n;
    long long m1 = INF, M1 = -INF, m2 = INF, M2 = -INF;
    cin >> n;
    for(int i = 0; i < n; i++){
        long long x, y, h;
        cin >> x >> y >> h;
        m1 = min(m1, x - h);
        M1 = max(M1, x + h);
        m2 = min(m2, y - h);
        M2 = max(M2, y + h);
    }
    long long h1 = ceil(M1 - m1, 2);
    long long h2 = ceil(M2 - m2, 2);
    cout << m1 + h1 << " ";
    cout << m2 + h2 << " ";
    cout << max(h1, h2);
}
