#include <bits/stdc++.h>

using namespace std;

#define len(x) int(x.size())
#define all(x) x.begin(), x.end()

#define ff first
#define ss second

#pragma optimize("O3")

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> masi;
typedef vector <ll> masl;

const int N = 2e5 + 10;

vector <int> g[N];

void bfs(vector <int> &d, vector <int> &p, int s, int n) {
    d.clear();
    d.resize(n, 1e9);
    d[s] = 0;
    p.clear();
    p.resize(n, -1);
    queue <int> q;
    q.push(s);
    while (!q.empty()) {
        int x = q.front();
        for (int j = 0; j < len(g[x]); j++) {
            int nw = g[x][j];
            if (d[nw] > d[x] + 1){
                d[nw] = d[x] + 1;
                p[nw] = x;
                q.push(nw);
            }
        }
        q.pop();

    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector <int> marked(m);
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        x--;
        marked[i] = x;
    }
    if (m == 1) {
        cout << "YES\n1";
        return;
    }
    vector <int> p, d;
    bfs(d, p, marked[0], n);
    int cur = marked[1];
    vector <int> way;
    while (cur != marked[0]) {
        way.push_back(cur);
        cur = p[cur];
    }
    way.push_back(cur);
    if (len(way) % 2 == 0) {
        cout << "NO";
        return;
    }
    int s = way[len(way) / 2];
    bfs(d, p, s, n);
    int dist = d[marked[0]];
    for (int i = 1; i < len(marked); i++) {
        int x = d[marked[i]];
        if (x != dist) {
            cout << "NO";
            return;
        }
    }
    cout << "YES\n" << s + 1;
}

int main() {
    #ifdef HOME
    freopen("input.txt", "rt", stdin);
    #endif  //  HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
