#include <bits/stdc++.h>

using namespace std;

#define len(x) int(x.size())
#define all(x) x.begin(), x.end()

#define ff first
#define ss second

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef vector <int> masi;
typedef vector <ll> masl;

ll n, x[1005], y[1005], h[1005];

ll kabs(ll a){
    if (a > 0) return a;
    else return (-a);
}

bool valid(ll xc, ll yc, ll hc) {
    for (int i = 0; i < n; i++) {
        ll mn = min(hc - kabs(xc - x[i]), hc - kabs(yc - y[i]));
        if (h[i] > mn) return false;
    }
    return true;
}

ll a1, a2, a3= 1e15;

void lowest_height(ll xc, ll yc) {
    ll l = 0, r = 1e15; //sporno
    while (r - l > 1) {
        //cout << l << ' ' << r << endl;
        ll mid = (l + r)/2;
        if (valid(xc, yc, mid))
            r = mid;
        else
            l = mid;
    }
    //cout << l << ' ' << r << ' ' ;
    //cout << valid(xc, yc, l) << ' ';
    if (valid(xc, yc, l)) r = l;
    //cout << ' ' << xc << ' ' << yc << ' ' << r << ' ' << a3 << endl;
    if (r < a3){
        a3 = r;
        a2 = yc;
        a1 = xc;
    }
    //cout << endl << endl;
}

int main() {
 	#ifdef HOME
	freopen("input.txt", "rt", stdin);
	#endif  //  HOME
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> x[i] >> y[i] >> h[i];

    ll sumx = 0, sumy = 0, sumh = 0;
    for (int i = 0; i < n; i++) {
        sumx += x[i] * h[i];
        sumy += y[i] * h[i];
        sumh += h[i];
    }
    ll x1, y1, x2, y2, x3, y3, x4, y4;
    x1 = x2 = sumx/sumh;
    x3 = x4 = x1 + 1;
    y1 = y3 = sumy/sumh;
    y2 = y4 = y1 + 1;
    lowest_height(x1, y1);
    lowest_height(x2, y2);
    lowest_height(x3, y3);
    lowest_height(x4, y4);
    cout << a1 << ' ' << a2 << ' ' << a3;
	return 0;
}
