#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
using namespace std;

vector<int>g[1000];

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n-1; i++){
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<bool>used(n, false);
    queue<int>q;
    vector<int>time(n, 0);
    for(int i = 0; i < m; i++){
        int a;
        cin >> a;
        a--;
        q.push(a);
        used[a] = true;
        time[a]++;
    }
    int t = 2;
    int c = m;
    int cnt = 0;
    while(!q.empty()){
        int v = q.front();
        cnt++;
        q.pop();
        for(int i = 0; i < g[v].size(); i++){
            if(!used[g[v][i]]){
                q.push(g[v][i]);
                used[g[v][i]] = true;
                time[g[v][i]] = t;
            }else{
                if((time[v] - 1) != time[g[v][i]] && t != time[g[v][i]]){
                    cout << "NO";
                    return 0;
                }else if((time[v] - 1) != time[g[v][i]]){
                    m--;
                    if(m == 1){
                        cout << "YES" << "\n" << g[v][i]+1 << endl;
                        return 0;
                    }
                }
            }
        }
        if(cnt == c){
            cnt -= c;
            c = cnt;
            t++;
        }
    }



    return 0;
}
