#include <bits/stdc++.h>

#define forn(i, n) for(int i = 0; i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >= 0; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)
#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()

using namespace std;


typedef long long ll;
typedef long long LL;
typedef unsigned long long ull;
typedef unsigned long long ULL;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct __TIMESTAMP{
    ~__TIMESTAMP() {
        cerr << "\n\n=====\n" << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
    }
} __timestamp;

const int N = 105;

int n;
vector<int> a, b;
unordered_map<int, int> sa, sb;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#endif

    cin >> n;
    a.clear(), b.clear(), sa.clear();

    a.resize(n), b.resize(n);
    forn(i, n) cin >> a[i], sa[a[i]]++;
    forn(i, n) cin >> b[i];

    vector<string> ans;

    fornr(i, n) {
        sb[b[i]]++;
        if (b[i] == a[i])
            continue;
        if (sa[b[i]] == 0) {
            cout << "-1\n";
            return 0;
        }
        
        if (sb[a[i]] > 0) {
            forn(j, i + 1) {
                if (a[j] == a[i]) {
                    ans.emplace_back("foreach ($a as &$x) if ($x == " + std::to_string(a[i]) + ") break;");
                    ans.emplace_back("foreach ($a as  $x) if ($x == " + std::to_string(b[i]) + ") break;");
                    sa[a[j]]--;
                    a[j] = b[i];
                    sa[a[j]]++;
                }
            }                 
        } else {
            forn(j, i + 1) {
                if (a[j] == a[i]) {
                    if (a[j] == b[j]) {
                        cout << "-1\n";
                        return 0;
                    }
                    ans.emplace_back("foreach ($a as &$x) if ($x == " + std::to_string(a[i]) + ") break;");
                    ans.emplace_back("foreach ($a as  $x) if ($x == " + std::to_string(b[j]) + ") break;");
                    sa[a[j]]--;
                    a[j] = b[j];
                    sa[a[j]]++;
                }
            }                 
        }
    }

    cout << ans.size() << '\n';
    for (auto& s : ans)
        cout << s << '\n';

}