#include <bits/stdc++.h>

#define forn(i, n) for(int i = 0; i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >= 0; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)
#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()

using namespace std;


typedef long long ll;
typedef long long LL;
typedef unsigned long long ull;
typedef unsigned long long ULL;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct __TIMESTAMP{
    ~__TIMESTAMP() {
        cerr << "\n\n=====\n" << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
    }
} __timestamp;

const int maxn = 1179;
int x[maxn], y[maxn], h[maxn];

int ok_x, ok_y;

bool check(int n, int hg) {
    vector<int> lx, rx, ly, ry;
    forn(i, n) {
        if (hg < h[i])
            return false;
        lx.pb(x[i] - (hg - h[i]));
        rx.pb(x[i] + (hg - h[i]));
        ly.pb(y[i] - (hg - h[i]));
        ry.pb(y[i] + (hg - h[i]));
    }

    ok_x = *max_element(all(lx));
    ok_y = *max_element(all(ly));

    return ok_x <= *min_element(all(rx)) && ok_y <= *min_element(all(ry));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#endif

    int n;
    cin >> n;
    forn(i, n) {
        cin >> x[i] >> y[i] >> h[i];
    }

    int l = 0, r = 3e8;
    while (l < r - 1) {
        int mid = (l + r) / 2;

        if (check(n, mid))
            r = mid;
        else
            l = mid;
    }

    assert(check(n, r));
    cout << ok_x << " " << ok_y << " " << r << endl;
}