#include <bits/stdc++.h>

#define forn(i, n) for(int i = 0; i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >= 0; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)
#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()

using namespace std;


typedef long long ll;
typedef long long LL;
typedef unsigned long long ull;
typedef unsigned long long ULL;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct __TIMESTAMP{
    ~__TIMESTAMP() {
        cerr << "\n\n=====\n" << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
    }
} __timestamp;


const int MAXN = 1010;
char a[MAXN][MAXN];
char ans[MAXN][MAXN];
int cnt[MAXN][MAXN];
int n, m;

int getCnt(int x0, int y0, int x1, int y1) {
    return cnt[x1][y1] - cnt[x0][y1] - cnt[x1][y0] + cnt[x0][y0];
}

void f(int x0, int y0, int x1, int y1) {
    vector<pair<pii, char>> v;
    forab(i, x0, x1) {
        forab(j, y0, y1) {
            if (a[i][j] != '.') {
                v.pb({{i, j}, a[i][j]});
            }
        }
    }
    sort(all(v));
    int pos = 0;
    int xMin = x0;
    forn(i, (int) v.size() + 1) {
//    if (i != v.size())
  //      cerr << v[i].first.first << " " << v[i].first.second << " " << v[i].second << endl;
        if (i == (int) v.size() || v[i].first.first != v[pos].first.first) {
            int xMax = (i == (int) v.size()) ? x1 : v[pos].first.first + 1;
            int yMin = y0;
            forab(k, pos, i) { 
                int yMax = k + 1 == i ? y1 : v[k].first.second + 1;
//                cerr << xMin << " " << xMax << " " << yMin << " " << yMax << " " << v[k].second << endl;
                forab(x, xMin, xMax) {
                    forab(y, yMin, yMax) { 
                        ans[x][y] = a[x][y] != '.' ? v[k].second : (char) tolower(v[k].second);
                    }
                }
                yMin = yMax;
            }
            xMin = xMax;
            pos = i;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL
    freopen(".in", "r", stdin);
    freopen(".out", "w", stdout);
#endif

    scanf("%d%d", &n, &m);
    forn(i, n) scanf(" %s", a[i]);

    int aX = 0, aY = 0;
    forn(i, n) {
        int cc = 0;
        forn(j, m) {
            if (a[i][j] == 'A') aX = i, aY = j;
            cc += a[i][j] != '.';
            cnt[i + 1][j + 1] = cnt[i][j + 1] + cc;            
        }
    }

    /*
    forn(i, n + 1) {
        forn(j, m + 1) {
            printf("%d", cnt[i][j]);
        } 
        puts("");
    }
    */
    int ansNum = 0;
    int x0Ans = -1, y0Ans = -1, x1Ans = -1, y1Ans = -1;
    forn(y0, aY + 1) {
        int y1 = aY;
        int x0 = aX, x1 = aX + 1;
        while (y1 < m) {
            y1++;
            if (getCnt(x0, y0, x1, y1) > 1) {
                y1--;
                break;
            }
        }
        while (y1 > aY) {
            while(x0 > 0) {
                x0--;
                if (getCnt(x0, y0, x1, y1) > 1) {
                    x0++;
                    break;
                }
            }
            while(x1 < n) {
                x1++;
                if (getCnt(x0, y0, x1, y1) > 1) {
                    x1--;
                    break;
                }
            }
            if (ansNum < (x1 - x0) * (y1 - y0)) {
                ansNum = (x1 - x0) * (y1 - y0);
                x0Ans = x0, y0Ans = y0;        
                x1Ans = x1, y1Ans = y1;        
            }
            y1--;
        }
    }

    assert(ansNum > 0);
//    printf("%d %d %d %d\n", x0Ans, y0Ans, x1Ans, y1Ans);
    f(0, 0, x0Ans, m);
    f(x1Ans, 0, n, m);
    f(x0Ans, 0, x1Ans, y0Ans);
    f(x0Ans, y1Ans, x1Ans, m);

    forab(i, x0Ans, x1Ans) {
        forab(j, y0Ans, y1Ans) {
            ans[i][j] = a[i][j] == 'A' ? 'A' : 'a';
        }
    }
    
    forn(i, n) {
        forn(j, m) {
            printf("%c", ans[i][j]);
        }
        puts("");
    }
}

