#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <queue>


using namespace std;

#define sqr(x) x * x;
#define all(x) x.begin(), x.end()
typedef long long ll;
const int INF = 1e9;
const int MOD = 1e9 + 7;

void solve() {
	int n;
	cin >> n;
	int ans = 0;
	vector<int> a(n);
	for (int& e : a) cin >> e;
	vector<unordered_map<int, int>> q;
	q.push_back({});
	for (int i = a.size() - 2; i >= 0; --i) {
		auto tmp = q.back();
		tmp[a[i + 1]]++;
		q.push_back(tmp);
	}
	reverse(all(q));
	for(int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j) {
				ans += q[j][a[j] + (a[j] - a[i])];
		}
	cout << ans << endl;
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}