#include <bits/stdc++.h>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef HOME
    freopen("in.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> pref(n);
    int maxInA = -1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        maxInA = max(maxInA, a[i]);
        pref[i] = a[i];
        if (i != 0) {
            pref[i] += pref[i - 1];
        }
    }
    const int N = 1000000;
    vector<bool> canBe(N + 1, false);
    int m;
    cin >> m;
    vector<int> qs(m);
    for (int i = 0; i < m; i++) {
        cin >> qs[i];
        canBe[qs[i]] = true;
    }
    vector<int> ans(N + 1);
    for (int t = maxInA; t < canBe.size(); t++) {
        if (!canBe[t]) {
            continue;
        }
        ans[t] = 0;
        int firstFree = 0;
        while (firstFree < n) {
            int bl = firstFree;
            int br = n - 1;
            int rght = firstFree;
            while (bl <= br) {
                int mid = (bl + br) / 2;
                int sum = pref[mid] - (firstFree == 0 ? 0 : pref[firstFree - 1]);
                if (sum <= t) {
                    rght = mid;
                    bl = mid + 1;
                } else {
                    br = mid - 1;
                }
            }
            ans[t]++;
            firstFree = rght + 1;
        }
    }
    for (int i : qs) {
        if (i < maxInA) {
            cout << "Impossible\n";
        } else {
            cout << ans[i] << '\n';
        }
    }

}