#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <bitset>
#include <stack>
#include <queue>
#include <cstdio>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <ctime>
#include <algorithm>
#include <cmath>
#include <string>

using namespace std;

#define pb push_back
#define eb emplace_back
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()

using ll = long long;
using ld = long double;

const ld pi = acos(-1.0L);
const ld eps = 0.00001L;

template<typename T, typename TT> void mi(T& a, TT b) {
	if (b < a)a = b;
}
template<typename T, typename TT> void ma(T& a, TT b) {
	if (b > a)a = b;
}

vector<vector<int>> t;
vector<int> p;
int n;
vector<int> h;

void dfs(int v) {
	for (auto to : t[v])
		if (to != p[v]) {
			p[to] = v;
			h[to] = h[v] + 1;
			dfs(to);
		}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int m;
	cin >> n >> m;
	t = vector<vector<int>>(n);
	p = vector<int>(n, -1);

	for (int i = 1; i < n; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		t[a].pb(b);
		t[b].pb(a);
	}

	vector<int> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		a[i]--;
	}

	if (m == 1) {
		cout << "YES\n";
		cout << a[0] + 1;
		return 0;
	}

	int s = a[0];

	h.assign(n, 0);
	dfs(s);

	int v = a[1];
	int cur = h[v] / 2;

	while (v != -1 && h[v] != cur)
		v = p[v];

	vector<int> d(n, (int)1e9);
	s = v;
	d[v] = 0;
	queue<int> q;
	q.push(v);
	while (!q.empty()) {
		v = q.front();
		q.pop();
		for (auto to : t[v])
			if (d[to] > d[v] + 1)
				q.push(to), d[to] = d[v] + 1;
	}

	cur = d[a[0]];

	for(auto x : a)
		if (d[x] != cur) {
			cout << "NO\n";
			return 0;
		}

	cout << "YES\n";
	cout << s + 1;

	return 0;
}
