import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.*
import kotlin.collections.HashMap

var cnt = IntArray(1)
var dist = IntArray(300_000)
var n = 0
var m = 0

fun solve() {
    n = readInt()
    m = readInt()
    var gr = Array(n){IntArray(0)}
    var x = IntArray(n)
    var y = IntArray(n)
    var cnnt = IntArray(n)
    for (i in 0 until (n - 1)) {
        x[i] = readInt() - 1
        y[i] = readInt() - 1
        cnnt[x[i]]++
        cnnt[y[i]]++
    }
    for (i in 0 until n) {
        gr[i] = IntArray(cnnt[i])
    }

    cnt = cnnt.clone()

    for (i in 0 until (n - 1)) {
        gr[x[i]][--cnnt[x[i]]] = y[i]
        gr[y[i]][--cnnt[y[i]]] = x[i]
    }

    var q = Queue()
    var head = 0
    var tail = 0
    Arrays.fill(dist, 40_000_000)
    dist[290_000] = -1

    Arrays.fill(cnnt, 0)

    var cmd = IntArray(m)
    for (i in 0 until m) {
        cmd[i] = readInt() - 1
        q.add(cmd[i], 290_000)
    }

    while (q.noEmty()) {
        var (v, pr) = q.get()
        if (dist[v] == dist[pr] + 1) {
            cnnt[v] += 1
        } else if (dist[v] > dist[pr] + 1){
            cnnt[v] = 1
            dist[v] = dist[pr] + 1
        } else {
            continue
        }
        for (i in 0 until cnt[v]) {
            var next = gr[v][i]
            if (next == pr) {
                continue
            }
            q.add(next, v)
        }
    }

    var mx = cnnt.max()
    if (mx != m) {
        out.println("NO")
    } else {
        out.println("YES")
        for (i in 0 until n) {
            if (cnnt[i] == mx) {
                out.println(i + 1)
                return
            }
        }
    }
}

data class Pair(var x : Int, var y : Int)

data class Queue(var q: Array<Pair> = Array(100_000_000){Pair(0, 0)}, var head : Int = 0, var tail : Int = 0) {
    fun get() = q[head++]
    fun add(x: Int, y : Int) {
        q[tail++] = Pair(x, y)
    }
    fun noEmty() = (tail - head) > 0
}

fun main() {
    solve()
    out.close()
}

var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)
var tok = StringTokenizer(" ")

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine(), " ")
    }
    return tok.nextToken()
}

fun readInt() = read().toInt()