#include <iostream>
#include <algorithm>


using namespace std;

__forceinline int readInt() {
    int x;
    scanf("%i", &x);
    return x;
}

int n, q;
int a[1 << 20];
int pref[1 << 20];

int main() {
    n = readInt();
    int mx = -100;
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        a[i] = readInt();
        mx = max(a[i], mx);
        pref[i + 1] = pref[i] + a[i];
    }

    q = readInt();
    for (int i = 0; i < q; i++) {
        int qq = readInt();
        if (qq < mx) {
            printf("Impossible\n");
            continue;
        }
        if (qq >= pref[n]) {
            printf("1\n");
            continue;
        }
        int cnt = 0;
        int pred = 1;

        int val = pref[pred - 1] + qq;
        if (pref[n] / qq > (n / 3)) {
            for (int i = 1; i <= n; i++) {
                if (pref[i] > val) {
                    cnt++;
                    pred = i;
                    val = pref[pred - 1] + qq;
                }
            }
            printf("%i\n", ++cnt);
            continue;
        }

        while (pred <= n) {
            int left = pred;
            int right = n + 1;
            int val = pref[pred - 1] + qq;
            while (right - left > 1) {
                int mid = right + left >> 1;
                if (pref[mid] > val) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            cnt++;
            pred = left + 1;
        }
        printf("%i\n", cnt);
    }

    return 0;
}