import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.*
import kotlin.collections.HashMap

fun solve() {
    var n = readInt()
    var sp = Array(n) { read().toCharArray().map { it - '0' }.toIntArray() }
    var gr = Array(n) { IntArray(n) }
    for (len in 1 until n) {
        for (nowV in 0 until (n - len)) {
            var ans = 1
            for (back in 1 until len) {
                ans += gr[nowV + back][nowV + len] * sp[nowV][nowV + back]
            }
            ans %= 10
            if (ans == sp[nowV][nowV + len]) {
                gr[nowV][nowV + len] = 1
            }
        }
    }
    for (i in 0 until n) {
        out.println(String(gr[i].map { ('0' + it) }.toCharArray()))
    }
}

fun main() {
    solve()
    out.close()
}

var br = BufferedReader(InputStreamReader(System.`in`))
var out = PrintWriter(System.out)
var tok = StringTokenizer(" ")

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine(), " ")
    }
    return tok.nextToken()
}

fun readInt() = read().toInt()