#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

typedef long long int ll;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int u = 0; u < t; ++u) {
        int n;
        cin >> n;
        vector<int> a(n);
        vector<unordered_map<int, int>> v(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            for (int j = 0; j <= i; ++j) {
                v[j][a[i]]++;
            }
        }
        ll ans = 0;
        for (int i = 1; i < n - 1; ++i) {
            for (int j = 0; j < i; ++j) {
                int res = a[i] - a[j];
                int found = res + a[i];
                ans += v[i + 1][found];
            }
        }
        cout << ans << "\n";
    }

    return 0;
}