#include <iostream>
#include <string>
#include <set>
#include <map>
#include <sstream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>

#define ll long long
#define ull unsigned ll

#define MOD 1000000000+7

#define FOR(i,a,b) for(int i=a;i<b;i++)
#define LFOR(i,a,b) for(int i=b-1;i>=a;i--)


#define fori(n) for(int i = 0; i < n; i++)

using namespace std;

vector<ll> A;
vector<ll> Ap;

struct ob {
	ll x, y, h;
};

struct pt {
	ll a;
	bool type;
};

bool ptComp(pt a, pt b) {
	return a.a < b.a;
}

ll myMax(ll a, ll b) {
	if (a > b)
		return a;
	return b;
}

ll myMin(ll a, ll b) {
	if (a < b)
		return a;
	return b;
}

ll H(ll lx, ll rx, ll ly, ll ry, ll cx, ll cy) {
	return myMax(myMax(cx - lx, rx - cx), myMax(cy - ly, ry - cy));
}

// I
int main() {
	int n;
	cin >> n;

	vector<ob> v(n);
	fori(n) {
		cin >> v[i].x >> v[i].y >> v[i].h;
	}

	vector<pt> ptx(n * 2),
		pty(n * 2);
	fori(n) {
		ptx[i * 2].a = v[i].x - v[i].h;
		ptx[i * 2].type = false;
		ptx[i * 2 + 1].a = v[i].x + v[i].h;
		ptx[i * 2 + 1].type = true;

		pty[i * 2].a = v[i].y - v[i].h;
		pty[i * 2].type = false;
		pty[i * 2 + 1].a = v[i].y + v[i].h;
		pty[i * 2 + 1].type = true;
	}

	sort(ptx.begin(), ptx.end(), ptComp);
	sort(pty.begin(), pty.end(), ptComp);

	ll lx, rx, ly, ry;

	lx = ptx[0].a;
	rx = ptx[n * 2 - 1].a;

	ly = pty[0].a;
	ry = pty[n * 2 - 1].a;

	ll cx = (rx + lx) / 2,
		cy = (ry + ly) / 2;

	ll ansX, ansY, ansH;
	
	ansX = cx;
	ansY = cy;
	ansH = H(lx, rx, ly, ry, cx, cy);

	ll tmpX, tmpY, tmpH;
	
	tmpX = cx + 1;
	tmpY = cy;
	tmpH = H(lx, rx, ly, ry, tmpX, tmpY);

	if (tmpH < ansH) {
		ansX = tmpX;
		ansY = tmpY;
		ansH = tmpH;
	}



	tmpX = cx;
	tmpY = cy + 1;
	tmpH = H(lx, rx, ly, ry, tmpX, tmpY);

	if (tmpH < ansH) {
		ansX = tmpX;
		ansY = tmpY;
		ansH = tmpH;
	}



	tmpX = cx + 1;
	tmpY = cy + 1;
	tmpH = H(lx, rx, ly, ry, tmpX, tmpY);

	if (tmpH < ansH) {
		ansX = tmpX;
		ansY = tmpY;
		ansH = tmpH;
	}

	cout << ansX << " " << ansY << " " << ansH << endl;

	return 0;
}

// I
/*

1
0 0 5


2
3 3 3
6 6 2


*/


/*ll Ans(int cnt)
{
	ll c = 0;
	int st = -1;
	FOR(i, 0, Ap.size())
	{
		if (st >= 0)
		{
			if (Ap[i] - Ap[st] > cnt)
			{
				c++;
				if (st-1 == i - 1)
					return -1;
				st = i-1;
			}
		}
		else
		{
			if (Ap[i] > cnt)
			{
				c++;
				if (st-1 == i - 1)
					return -1;
				st = i-1;
			}
		}
	}
	c++;
	return c;
}*/


/*int main()
{
	int n, m;
	cin >> n;
	A.resize(n);
	Ap.assign(n, 0);
	FOR(i, 0, n)
	{
		cin >> A[i];
		if (i > 0)
			Ap[i] = Ap[i - 1];
		Ap[i] += A[i];
	}
	cin >> m;
	FOR(i, 0, m)
	{
		ll z;
		cin >> z;
		ll ret = Ans(z);
		if (ret == -1)
			cout << "Impossible\n";
		else
			cout << ret << "\n";
	}
	return 0;
}
/*
6
4 2 3 1 3 4
8
10 2 5 4 6 7 8 8
*/

/*int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		int n;
		cin >> n;

		vector <ll> v(n);
		for (int i = 0; i < n; i++)
			cin >> v[i];

		map <ll, vector <int> > m;
		for (int i = 0; i < n; i++)
			m[v[i] * 2].push_back(i);

		ll count = 0;
		for (int i = 0; i < n - 2; i++)
		{
			for (int k = i + 1; k < n - 1; k++)
			{
				auto it = m.find(v[i] + v[k]);
				if (it != m.end())
				{
					for (int j = 0; j < it->second.size(); j++)
					{
						if (i < j && j < it->second[k])
							count++;
					}
				}
			}
		}
		cout << count << '\n';
	}

	return 0;
}*/