#include <iostream>
#include <string>
#include <set>
#include <map>
#include <sstream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>

#define ll long long
#define ull unsigned ll

#define MOD 1000000000+7

#define FOR(i,a,b) for(int i=a;i<b;i++)
#define LFOR(i,a,b) for(int i=b-1;i>=a;i--)


#define fori(n) for(int i = 0; i < n; i++)

using namespace std;

// M

int main() {
	int t;
	cin >> t;
	for (int q = 0; q < t; q++) {
		int n = 0;
		cin >> n;
		vector<ll> v(n);
		fori(n)
			cin >> v[i];

		vector<map<ll, ll>> vm(n);
		vector<vector<ll>> vd(n);

		fori(n - 1) {
			vd[i].resize(n - 1 - i);
			for (int j = i + 1; j < n; j++) {
				vd[i][j - i - 1] = v[j] - v[i];
				vm[i][    vd[i][j - i - 1]   ]++;
			}
		}
		ll ans = 0;
		fori(n - 1) {
			for (int j = i + 1; j < n; j++) {
				ans += vm[j][    vd[i][j - i - 1]   ];
			}
		}
		cout << ans << endl;
	}

	return 0;
}

/*

4
5
1 2 1 2 1
3
30 20 10
5
1 2 2 3 4
9
3 1 4 1 5 9 2 6 5


*/


// I
/*

1
0 0 5


2
3 3 3
6 6 2


*/


vector<ll> A, Ap;

ll Ans(int cnt)
{
	ll c = 0;
	int st = 0;
	FOR(i, 0, Ap.size())
	{
		if (st > 0)
		{
			if (Ap[i] - Ap[st-1] > cnt)
			{
				c++;
				if (st == i)
					return -1;
				st = i;
			}
		}
		else
		{
			if (Ap[i] > cnt)
			{
				c++;
				if (st == i)
					return -1;
				st = i;
			}
		}
	}
	c++;
	return c;
}


/*int main()
{
	int n, m;
	cin >> n;
	A.resize(n);
	Ap.assign(n, 0);
	FOR(i, 0, n)
	{
		cin >> A[i];
		if (i > 0)
			Ap[i] = Ap[i - 1];
		Ap[i] += A[i];
	}
	cin >> m;
	FOR(i, 0, m)
	{
		ll z;
		cin >> z;
		ll ret = Ans(z);
		if (ret == -1)
			cout << "Impossible\n";
		else
			cout << ret << "\n";
	}
	return 0;
}
/*
6
4 2 3 1 3 4
8
10 2 5 4 6 7 8 8

5
1 1 1 1 1
2
5 6
*/

/*int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		int n;
		cin >> n;

		vector <ll> v(n);
		for (int i = 0; i < n; i++)
			cin >> v[i];

		map <ll, vector <int> > m;
		for (int i = 0; i < n; i++)
			m[v[i] * 2].push_back(i);

		ll count = 0;
		for (int i = 0; i < n - 2; i++)
		{
			for (int k = i + 1; k < n; k++)
			{
				auto it = m.find(v[i] + v[k]);
				if (it != m.end())
				{
					for (int j = 0; j < it->second.size(); j++)
					{
						if (i < it->second[j] && it->second[j] < k)
							count++;
					}
				}
			}
		}
		cout << count << '\n';
	}






	return 0;
}*/
vector<vector<int>> Adj;

void bfs(int st)
{
	vector<bool> used(Adj.size(),false);
	queue<int> q;
	q.push(st);
	used[st] = true;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		used[v] = true;
		FOR(i, 0, Adj[v].size())
		{
			if (Adj[v][i] != 0)
			{
				if (used[i] == false)
				{
					q.push(i);
				}
				else
				{
						Adj[st][i] = 0;
				}
			}
		}
	}
}

/*

int main()
{
	int n;
	cin >> n;
	Adj.resize(n);
	FOR(i, 0, n)
	{
		char ch;
		Adj[i].resize(n);
		FOR(j, 0, n)
		{
			
			cin >> ch;
			Adj[i][j] = (int)(ch - '0');
		}
		//cin >> ch;
	}


	FOR(i, 0, n)
		bfs(i);
	
	FOR(i, 0, n)
	{
		FOR(j, 0, n)
		{
			cout << Adj[i][j];
		}
		cout << "\n";
	}

}


*/
/*
5
01113
00012
00001
00001
00000
*/