#include <bits/stdc++.h>

/* ============================================================= */

template <class ...Args>
bool read(Args& ...args)
{ return (bool)(std::cin >> ... >> args); }

template <class ...Args>
void write(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)); }

template <class ...Args>
void writeln(Args&& ...args)
{ (std::cout << ... << std::forward<Args>(args)) << '\n'; }

/* ============================================================= */

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::fixed(std::cout).precision(10);

    int t; read(t);

    std::vector<int64_t> v;
    std::unordered_map<int64_t, int> cnt;
    while (t-- > 0) {
        int n; read(n);
        v.resize(n);
        for (auto& x : v)
            read(x);

        cnt.clear();
        int64_t res = 0;
        for (int i = 0; i < n; ++i) {
            const int mid = v[i];
            for (int j = i+1; j < n; ++j) {
                auto it = cnt.find(2*mid - v[j]);
                if (it != cnt.end())
                    res += it->second;
            }
            cnt[mid]++;
        }
        writeln(res);
    }

    return 0;
}