#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

vector<string> ans;

void change(int a, int b) {
    ans.push_back("foreach ($a as &$x) if ($x == " + to_string(a) + ") break;");
    ans.push_back("foreach ($a as  $x) if ($x == " + to_string(b) + ") break;");
}

void changeBack(int a, int b) {
    ans.push_back("foreach ($a as &$x) if ($x == " + to_string(a) + ") break;");
    ans.push_back("foreach ($a as  $x) if ($x == " + to_string(b) + ") break;");
}

void solve() {
    int n; cin >> n;
    vector<int> A(n), B(n), cnt(101);
    for (int &i : A) {
        cin >> i;
        cnt[i]++;
    }
    for (int &i : B) cin >> i;
    vector<int> curA;
    do {
        curA = A;
        for (int i = n - 1; i >= 0; --i) {
            if (A[i] != B[i]) {
                int ok = 0;
                for (int j = i + 1; j < n; ++j) if (A[i] == A[j]) {
                    ok = 1;
                }
                if (!ok) continue;
                for (int j = 0; j <= i; ++j)
                    if (A[j] == A[i]) {
                        if (!cnt[B[i]]) {
                            cout << "-1\n";
                            return;
                        }
                        change(A[i], B[i]);
                        cnt[A[i]]--, cnt[B[i]]++;
                        A[j] = B[i];
                    }
            }
        }
        if (curA == A && A.back() != B.back()) {
            if (!cnt[B.back()]) {
                cout << "-1\n";
                return;
            }
            int mnn = min_element(cnt.begin() + 1, cnt.end()) - cnt.begin();
            if (cnt[mnn] == 0) {
                changeBack(mnn, B.back());
                cnt[A.back()]--, cnt[B.back()]++;
                A.back() = B.back();
            }
        }
    } while (curA != A);
    if (A != B) {
        cout << "-1\n";
        return;
    }
    cout << ans.size() << "\n";
    for (auto &i : ans) {
        cout << i << "\n";
    }
}