#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

const int dd = (int)1e6 + 7;
int ans[dd];

void solve() {
    int n; cin >> n;
    vector<int> A(n);
    vector<int> pref(n + 1);
    for (int &i : A) cin >> i;
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + A[i];
    }
    int mx = *max_element(A.begin(), A.end());
    int q; cin >> q;
    while (q--) {
        int x; cin >> x;
        if (x < mx) {
            cout << "Impossible\n";
            continue;
        }
        if (ans[x]) {
            cout << ans[x] << "\n";
            continue;
        }
        int l = 0, cur = 0;
        while (l < n) {
            l = upper_bound(pref.begin() + l, pref.end(), pref[l] + x) - pref.begin() - 1;
            ++cur;
        }
        cout << (ans[x] = cur) << "\n";
    }
}