#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}

const int inf = (int)1e9;

int dx[] = { 1, 1, -1, -1 };
int dy[] = { 1, -1, 1, -1 };

void solve() {
    int n; cin >> n;
    int mxx = -inf, mnx = inf, mxy = -inf, mny = inf;
    for (int i = 0; i < n; ++i) {
        int x, y, z; cin >> x >> y >> z;
        for (int k = 0; k < 4; ++k) {
            int nx = x + dx[k] * z, ny = y + dy[k] * z;
            mxx = max(mxx, nx), mnx = min(mnx, nx);
            mxy = max(mxy, ny), mny = min(mny, ny);
        }
    }
    int len = max(mxx - mnx, mxy - mny);
    if (len & 1) ++len;
    len /= 2;
    cout << mnx + len << " " << mny + len << " " << len << "\n";
}