#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) solve();
    return 0;
}

unordered_map<ll, ll> lp(10000);
unordered_map<ll, ll> mp(10000);

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        mp[a[i]]++;
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        lp[a[i]]++;
        for (int j = i + 1; j < n; ++j) {
            lp[a[j]]++;
            ll ak = 2 * a[j] - a[i];
            ll p = mp[ak];
            p -= lp[ak];
            ans += p;
        }
        for (int j = i + 1; j < n; ++j) {
            lp[a[j]]--;
        }
    }
    for (int i = 0; i < n; ++i) {
        lp[a[i]]--;
        mp[a[i]]--;
    }
    cout << ans << "\n";
}