#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>

#define sz(a) ((int)((a).size()))
#define char unsigned char
#define X first
#define x first
#define Y second
#define y second

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 998244353;
const int N = 112345;

bool pr[N];
int d[N];
int mu[N];

const ll rev_2 = (MOD + 1LL) / 2LL;

ll binpow(ll a, ll b)
{
	ll ans = 1;
	while (b)
	{
		if (b & 1)
			ans = ans * a % MOD;
		a = a * a % MOD;
		b >>= 1;
	}
	return ans;
}

ll inv(ll a)
{
	return binpow(a, MOD - 2);
}

int main()
{
#ifdef ONPC
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // ONPC
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	pr[0] = pr[1] = 1;
	vector<int> p;
	for (int i = 2; i < N; i++)
	{
		if (!pr[i])
		{
			p.push_back(i);
			d[i] = i;
			for (int j = i + i; j < N; j += i)
			{
				pr[j] = 1;
				if (d[j] == 0 || d[j] > i)
					d[j] = i;
			}
		}
	}
	mu[1] = 1;
	for (int i = 2; i < N; i++)
	{
		if ((i / d[i]) % d[i] == 0)
		{
			mu[i] = 0;
		}
		else
		{
			mu[i] = -mu[i / d[i]];
		}
	}

	int n, k;
	cin >> n >> k;

	//cout << inv(2) * 2 % MOD << '\n';
	vector<ll> a(n + 1), b(n + 1), e(n + 1);
	for (int i = 1; i <= n; ++i)
		if (i % 2)
			e[i] = binpow(k, (i + 1) / 2) * 2 % MOD;
		else
			e[i] = binpow(k, i / 2) * (k + 1) % MOD;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; i * j <= n; ++j)
			b[i * j] = (b[i * j] + mu[j] * e[i] % MOD * i * j + MOD) % MOD;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; i * j <= n; ++j)
			a[i * j] = (a[i * j] + b[i]) % MOD;

	ll ans = 0;
	for (int i = 1; i <= n; ++i)
		ans = (ans + a[i]) % MOD;
	cout << ans * rev_2 % MOD << '\n';
	return 0;
}
