#include <iostream>
#include <string>
#include <vector>
using namespace std;

int main() {
	int n;
	cin >> n;
	vector<vector<int> > table(n, vector<int>(n));
	string s;
	for (int i = 0; i < n; i++) {
		cin >> s;
		for (int j = 0; j < n; j++) {
			table[i][j] = s[j] - '0';
		}
	}
	vector<vector<int> > g(n, vector<int>(n, 0));
	for (int i = n - 2; i >= 0; i--) {
		vector<int> e;
		for (int j = i + 1; j < n; j++) {
			int sum = 0;
			for (int k = 0; k < e.size(); k++) {
				sum += table[e[k]][j];
			}
			if (table[i][j] == (sum + 1) % 10) {
				e.push_back(j);
				g[i][j] = 1;
			}
		}
		e.clear();
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << g[i][j];
		}
		cout << endl;
	}
	return 0;
}