#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
vector <vector <int> > g;
vector <int> par;
vector <int> dist;
vector <bool> used;

void dfs(int u, int p = -1) {
    used[u] = true;
    if (p == - 1)
        dist[u] = 0;
    else
        dist[u] = dist[p] + 1;
    for (int v : g[u])
        if (!used[v])
            dfs(v, u);
}

int findRoot(int u, int k) {
    if (k == 0)
        return u;
    findRoot(par[u], k - 1);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    par.resize(n, -1);
    dist.resize(n, 0);
    used.resize(n, false);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
        par[v] = u;
    }
    vector <int> mt(m);
    for (int i = 0; i < m; ++i) {
        cin >> mt[i];
        mt[i]--;
    }
    int root = 0;
    int niter = 0;
    while (niter < 50) {
        dist.assign(n, 0);
        used.assign(n, false);
        dfs(root);
        int mn = 1e9, mx = -1e9, mxId = 0;
        for (int i = 0; i < m; ++i) {
            mn = min(mn, dist[mt[i]]);
            if (mx < dist[mt[i]]) {
                mx = dist[mt[i]];
                mxId = mt[i];
            }
        }
        if (mn == mx) {
            cout << "YES" << endl << root + 1;
            return 0;
        }
        int shift = (mx + mn) / 2 - mn;
        root = findRoot(mxId, mx - shift);
        niter++;
    }
    cout << "NO";
    return 0;
}