#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
vector <vector <ll> > g;
vector <ll> par;
vector <ll> dist;
vector <bool> used;

void dfs(ll u, ll p = -1) {
    used[u] = true;
    par[u] = p;
    if (p == - 1)
        dist[u] = 0;
    else
        dist[u] = dist[p] + 1;
    for (int v : g[u])
        if (!used[v])
            dfs(v, u);
}

ll findRoot(ll u, ll k) {
    if (k == 0)
        return u;
    return findRoot(par[u], k - 1);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    par.resize(n, -1);
    dist.resize(n, 0);
    used.resize(n, false);
    for (int i = 1; i < n; ++i) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector <ll> mt(m);
    for (int i = 0; i < m; ++i) {
        cin >> mt[i];
        mt[i]--;
    }
    ll root = 0;
    ll niter = 0;
    while (niter < 100) {
        dist.assign(n, 0);
        used.assign(n, false);
        dfs(root);
        ll mn = 1e9, mx = -1e9, mxId = -1;
        for (int i = 0; i < m; ++i) {
            mn = min(mn, dist[mt[i]]);
            if (mx < dist[mt[i]]) {
                mx = dist[mt[i]];
                mxId = mt[i];
            }
        }
        if (mn == mx) {
            cout << "YES" << endl << root + 1;
            return 0;
        }
        ll shift = (mx + mn) / 2 - mn;
        ll k = mx - shift;
        root = findRoot(mxId, k);
        niter++;
    }
    cout << "NO";
    return 0;
}