#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

struct pt {
    ll x;
    ll y;
};

ll n;
vector<pt> arr;
vector<ll> hgt;
ll keyx, keyy;

ld dist(pt const &a, pt const &b) {
    return sqrt((b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y));
}

bool check(ll h, const vector<pt> &nw){
    for (int i=0; i<n; i++){
        if (nw[i].x - hgt[i] > 0) return false;
        if (nw[i].y - hgt[i] > 0) return false;
        if (ld(nw[i].x)/(2*h) + ld(hgt[i])/(2*h) - 1 > 0) return false;
        if (ld(nw[i].y)/(2*h) + ld(hgt[i])/(2*h) - 1 > 0) return false;
    }
    return true;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    arr.resize(n);
    hgt.resize(n);
    for (int i = 0; i < n; i++) cin >> arr[i].x >> arr[i].y >> hgt[i];
    if (n == 1){
        cout << arr[0].x << " " << arr[0].y << " " << hgt[0];
        return 0;
    }
    ld maxdist = 0;
    size_t md_i = -1, md_j = -1;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            ld cur = dist(arr[i], arr[j]);
            if (cur > maxdist) {
                maxdist = cur;
                md_i = i;
                md_j = j;
            }
        }
    }
    pt k2 = {static_cast<ll>(1e9), static_cast<ll>(1e9)};
    for (auto i : arr){
        if (i.x < k2.x){
            k2 = i;
        } else if (i.x == k2.x && i.y < k2.y){
            k2 = i;
        }
    }
    keyx = round(((ld) arr[md_i].x + (ld) arr[md_j].x) / 2);
    keyy = round(((ld) arr[md_i].y + (ld) arr[md_j].y) / 2);


    ll l = 0, r = 1e17;
    while (r - l > 1) {
        vector<pt> nw(n);
        ll mid = (l + r) / 2;
        for (int i=0; i<n; i++){
            nw[i].x = arr[i].x - mid;
            nw[i].y = arr[i].y - mid;
        }
        if (check(mid, nw)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << keyx << " " << keyy << " " << r;
    return 0;
}