#include <iostream>
#include <unordered_map>
#include <vector>
#include <string>


using namespace std;

using ll = long long;

ll const maxn = 2e5 + 5;
vector<ll>g[maxn];
ll p[maxn]; bool used[maxn];

void dfs(ll u) {
	used[u] = 1;
	for (ll v : g[u]) {
		if (used[v]) continue;
		p[v] = u;
		dfs(v);
	}
}

ll d[maxn];

void dfs1(ll u, ll dd) {
	used[u] = 1;
	d[u] = dd;
	for (ll v : g[u]) {
		if (used[v]) continue;
		dfs1(v, dd + 1);
	}
}


void solve1() {
	/*ll n; cin >> n;
	vector<ll>a(n); for (ll i = 0; i < n; i++) cin >> a[i];
	ll q; cin >> q; vector<ll>b(q); for (ll i = 0; i < q; i++) cin >> b[i];
	*/
	ll n; cin >> n; ll m; cin >> m;
	for (ll i = 0; i < n - 1; i++) {
		ll x, y; cin >> x >> y; g[x].push_back(y); g[y].push_back(x);
	}
	vector<ll>a(m);
	for (ll i = 0; i < m; i++) cin >> a[i];
	if (a.size() == 1) {
		cout << "YES" << endl;
		cout << a[0];
		return;
	}
	ll root = a[0];
	p[root] = root;
	dfs(root);
	ll t = a[1];
	vector<ll>kek;
	ll v = t;
	while (v != root) {
		kek.push_back(v); v = p[v];
	}
	kek.push_back(root);
	if (kek.size() % 2 == 0) {
		cout << "NO";
		return;
	}
	ll rofl = kek[kek.size() / 2];
	fill_n(used, maxn, 0);
	fill_n(p, maxn, 0);
	dfs1(rofl, 0); bool f = true;
	for (ll i = 1; i < m; i++) {
		if (d[a[i]] != d[a[i - 1]]) f = false;
	}
	if (f) {
		cout << "YES" << endl;
		cout << rofl;
		return;
	}
	else {
		cout << "NO";
	}
}

/*
6 3
1 2
2 3
3 4
4 5
4 6
1 5 6
*/

void solve() {
	string s;
	cin >> s;
	//for (int i )

}
int main() {
	//solve();
	//return 0;
	int t = 1;
	for (; t > 0; t--) {
		solve1();
	}
}