#include <iostream>
#include <unordered_map>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>


using namespace std;

using ll = long long;

ll const maxn = 2e5 + 5;
void solve1() {
	ll n; cin >> n;
	ll mx = 0;
	vector<ll>a(n);	for (ll i = 0; i < n; i++) cin >> a[i], mx=max(a[i],mx);
	ll q; cin >> q; vector<pair<ll, ll>>b(q);
	for (ll i = 0; i < q; i++) {
		ll x; cin >> x;
		b[i] = { x, i };
	}
	sort(b.begin(), b.end());
	vector<ll>ans(q);
	vector<ll>pref(n + 1);
	pref[0] = a[0];
	for (ll i = 1; i < n; i++) pref[i] = pref[i - 1] + a[i];
	pref[n] = 1e9;


	for (ll i = 0; i < ans.size(); i++) {
		if (i == 0 || b[i].first != b[i - 1].first) {
			ll t = b[i].first;
			ll aans = 0;
			if (t < mx) {
				ans[i] = 0;
			}
			else {	
				ll j = 0;
				ll cnt = 0;
				while (j < n) {
					ll l = j;
					ll r = n;
					while (l < r - 1) {
						ll m = (l + r) / 2;
						if (pref[m] - (j ? pref[j - 1] : 0) <= t) {
							l = m;
						}
						else r = m;
					}
					cnt++;
					j = l + 1;
				}
				ans[b[i].second] = cnt;
			}
		}
		else {
			ans[b[i].second] = ans[b[i - 1].second];
		}
	}
	for (ll i = 0; i < q; i++) {
		if (ans[i]) {
			cout << ans[i] << "\n";
		}
		else {
			cout << "Impossible" << '\n';
		}
	}
}

/*
6
4 2 3 1 3 4
8
10 2 5 4 6 7 8 8

9 4
1 2
2 3
2 4
4 5
5 6
6 7
7 8
2 9
1 9 3 8


6 3
1 2
2 3
3 4
4 5
4 6
1 5 6
*/

//void solve() {
//	string s;
//	cin >> s;
//	//for (int i )
//
//}
//
//int  l[1010][1010], r[1010][1010];
//char a[1010][1010];
//int mxl[1010], mxr[1010];
//int n, m;
//
//bool chek(int u, int left, int d, int right, char ch) {
//	for (int i = u; i <= d; i++) {
//		for (int j = left; j <= right; j++) {
//			if (a[i][j] != '.')
//				return 0;
//		}
//	}
//	return 1;
//}
//
//void sw(int u, int left, int d, int right, char ch) {
//	for (int i = u; i <= d; i++) {
//		for (int j = left; j <= right; j++) {
//			a[i][j] = ch;
//		}
//	}
//	return;
//}
//
//void zamost(int x, int y, char ch) {
//	int u = x, d = x, left = y, right = y;
//	char cch = char(int(ch) - int('A') + int('a'));
//	while (1) {
//		if (chek(u - 1, left, u - 1, right, cch)) {
//			sw(u - 1, left, u - 1, right, cch);
//			u--;
//			continue;
//		}
//		if (chek(d + 1, left, d + 1, right, cch)) {
//			sw(d + 1, left, d + 1, right, cch);
//			d++;
//			continue;
//		}
//
//		if (chek(u, left - 1, d, left - 1, cch)) {
//			sw(u, left - 1, d, left - 1, cch);
//			left--;
//			continue;
//		}
//
//		if (chek(u, right + 1, d, right + 1, cch)) {
//			sw(u, right + 1, d, right + 1, cch);
//			right++;
//			continue;
//		}
//		break;
//	}
//}
//void solve2() {
//
//	cin >> n >> m;
//	int x, y;
//	for (int i = 1; i <= n; i++) {
//		for (int j = 1; j <= m; j++) {
//			cin >> a[i][j];
//			if (a[i][j] == 'A') {
//				x = i; y = j;
//			}
//		}
//	}
//	for (int i = 1; i <= n; i++) {
//		for (int j = 1; j <= m; j++) {
//			if (a[i][j] >= 'B' && a[i][j] <= 'Z') {
//				l[i][j] = 0;
//			}
//			else {
//				l[i][j] = l[i - 1][j] + 1;
//			}
//		}
//	}
//
//	for (int i = n; i >= 1; i--) {
//		for (int j = 1; j <= m; j++) {
//			if (a[i][j] >= 'B' && a[i][j] <= 'Z') {
//				r[i][j] = 0;
//			}
//			else {
//				r[i][j] = r[i + 1][j] + 1;
//			}
//		}
//	}
//
//	mxl[y] = l[x][y];
//	mxr[y] = r[x + 1][y];
//	for (int j = y + 1; j <= m; j++) {
//		mxl[j] = min(mxl[j - 1], l[x][j]);
//		mxr[j] = min(mxr[j - 1], r[x + 1][j]);
//	}
//
//	for (int j = y - 1; j >= 1; j--) {
//		mxl[j] = min(mxl[j + 1], l[x][j]);
//		mxr[j] = min(mxr[j + 1], r[x + 1][j]);
//	}
//
//	int ans = 0;
//
//	/*	for (int j = 1; j <= m; j++) {
//			cerr << mxr[j] << endl;
//		}*/
//
//	for (int i = 1; i <= y; i++) {
//		for (int j = y; j <= m; j++) {
//			if (min(mxl[j], mxl[i]) == 0) {
//				continue;
//			}
//			ans = max(ans, (j - i + 1) * (min(mxr[j], mxr[i]) + min(mxl[j], mxl[i])));
//		}
//	}
//	//	cerr << ans;
//	int u, d, left, right;
//	for (int i = 1; i <= y; i++) {
//		for (int j = m; j >= y; j--) {
//			if (min(mxl[j], mxl[i]) == 0) {
//				continue;
//			}
//			if (ans == (j - i + 1) * (min(mxr[j], mxr[i]) + min(mxl[j], mxl[i]))) {
//				left = i;
//				right = j;
//				u = x - min(mxl[j], mxl[i]) + 1;
//				d = x + min(mxr[j], mxr[i]);
//			}
//		}
//	}
//	//	cerr << u << " " << d;
//	for (int i = u; i <= d; i++) {
//		for (int j = left; j <= right; j++) {
//			a[i][j] = 'a';
//		}
//	}
//	a[x][y] = 'A';
//
//	//	cerr << endl << "-------------" << endl;
//
//	for (int ch = 'B'; ch <= 'Z'; ch++)
//		for (int i = 1; i <= n; i++) {
//			for (int j = 1; j <= m; j++) {
//				if (a[i][j] == ch) {
//					zamost(i, j, ch);
//				}
//			}
//		}
//
//	for (int i = 1; i <= n; i++) {
//		for (int j = 1; j <= m; j++) {
//			cout << a[i][j];
//		}
//		cout << endl;
//	}
//}
int main() {
	solve1();
	//solve2();
	//solve3();
	return 0;
	int t = 1;
	for (; t > 0; t--) {
		//		solve1();
	}
}