#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <string>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <utility>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define X first
#define Y second

using namespace std;  using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;

int n, m;
vector<vi> g;
vi vs;
vi path, cur;
int want;
vi d;

void dfs(int v, int p) {
	cur.pb(v);
	if (v == want) path = cur;
	for (int to : g[v]) if (to != p) dfs(to, v);
	cur.pop_back();
}

void dfs1(int v, int p) {
	for (int to : g[v]) if (to != p) d[to] = d[v] + 1, dfs1(to, v);
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	cin >> n >> m;
	g.resize(n);
	vs.resize(m);
	for (int i = 0; i < n - 1; i++) {
		int u, v; cin >> u >> v; --u; --v; g[u].pb(v); g[v].pb(u);
	}
	for (auto& v : vs) cin >> v, --v;
	if (m == 1) return cout << "YES\n" << vs[0] + 1, 0;
	want = vs[1];
	dfs(vs[0], -1);
	if (sz(path) % 2 == 0) return cout << "NO", 0;
	int rt = path[sz(path) / 2];
	d.resize(n);
	dfs1(rt, -1);
	int di = d[vs[0]];
	for (auto v : vs) if (d[v] != di) return cout << "NO", 0;
	cout << "YES\n" << rt + 1;


	/*
	cout << sin(355 * 2) << endl;
	for (int i = 1;; i++) {
		if (0 < sin(i) && sin(i) < 4e-5) {
			cout << i << ' ' << sin(i) << endl;
			cout << (1LL << 31) / i << endl;
			return 0;
		}
	}*/

#ifdef ROMA_UMER
	cerr << (ld)clock() / CLOCKS_PER_SEC;
#endif // ROMA_UMER

}