#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <string>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <utility>
#include <cmath>
#include <cassert>
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define X first
#define Y second

using namespace std;  using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int n;
	cin >> n;

	vector<int> a_1(n), a_2(n);

	for (int i = 0; i < n; i++) cin >> a_1[i];
	for (int i = 0; i < n; i++) cin >> a_2[i];

	if (a_1 == a_2) {
		cout << 0 << endl;
		return 0;
	}

	vector<int> cnt(101);
	for (int i = 0; i < n; i++) cnt[a_2[i]]++;

	bool ex_2 = false;
	for (int i = 0; i <= 100; i++) if (cnt[i] >= 2) ex_2 = true;

	if (!ex_2) {
		cout << -1 << endl;
		return 0;
	}

	vector<bool> nex(101);
	for (int i = 0; i < n; i++) nex[a_1[i]] = true;

	for (int i = 0; i <= 100; i++) {
		if (!nex[i] && cnt[i] > 0) {
			cout << -1 << endl;
			return 0;
		}
	}

	int mex = 1;
	while (nex[mex]) mex++;

	int chg, chgt;
	if (cnt[a_2[n - 1]] >= 2) chg = -1, chgt = -1;
	else {
		for (int i = 0; i <= 100; i++) {
			if (cnt[i] >= 2) {
				chgt = i;
				for (int j = 0; j < n; j++) {
					if (a_2[j] == chgt) {
						chg = j;
						cnt[a_2[j]]--;
						cnt[a_2[n - 1]]++;
						a_2[j] = a_2[n - 1];
						break;
					}
				}
				break;
			}
		}
	}

	vector<pair<int, int>> actions;

	vector<int> chg_cur(101);
	for (int i = 0; i < n - 1; i++) chg_cur[a_1[i]]++;

	cnt[a_2[n - 1]]--;

	vector<int> extra;
	for (int i = 0; i <= 100; i++) {
		for (int j = cnt[i]; j < chg_cur[i]; j++) extra.pb(i);
	}

	for (int i = 0; i <= 100; i++) {
		for (int k = chg_cur[i]; k < cnt[i]; k++) {
			actions.eb(extra.back(), i);
			for (int j = 0; j < n; j++) {
				if (a_1[j] == extra.back()) {
					a_1[j] = i;
					break;
				}
			}
			extra.pop_back();
		}
	}

	for (int i = 0; i < n - 1; i++) {
		if (a_1[i] != a_2[i]) {
			for (int j = i + 1; j < n - 1; j++) {
				if (a_1[j] == a_2[i]) {
					// SWAP procedure
					actions.eb(mex, a_1[i]);
					for (int k = 0; k <= i; k++) {
						if (a_1[k] == a_1[i])
							actions.eb(a_1[i], a_1[j]);
					}
					for (int k = 0; k <= i; k++) {
						if (a_1[k] == a_1[i])
							actions.eb(a_1[j], a_1[i]);
					}
					swap(a_1[i], a_1[j]);
					break;
				}
			}
		}
	}

	if (chg != -1) {
		actions.eb(mex, a_1[chg]);
		actions.eb(a_1[chg], chgt);
	}
	else if (a_1[n - 1] != a_2[n - 1]) {
		actions.eb(mex, a_2[n - 1]);
	}
	assert(sz(actions) <= 5000);
	cout << sz(actions) * 2 << endl;
	for (auto el : actions) {
		cout << "foreach ($a as &$x) if ($x == " << el.X << ") break;" << '\n';
		cout << "foreach ($a as  $x) if ($x == " << el.Y << ") break;" << '\n';
	}


	//cerr << (ld)clock() / CLOCKS_PER_SEC << endl;
}