#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <string>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <utility>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define X first
#define Y second

using namespace std;  using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;

const int N = 1000000 + 1;
int n;
vi a;
vi ans;
vi p;

int sum(int i, int j) {
	return p[j] - (i ? p[i - 1] : 0);
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	cin >> n;
	a.resize(n);
	int hi = 0;
	for (auto& v : a) cin >> v, hi = max(hi, v);
	p.resize(n);
	for (int i = 0; i < n; i++) p[i] = (i ? p[i - 1] : 0) + a[i];
	ans.resize(N, -1);
	
	vector<pii> segs;

	/*

	6
	4 2 3 1 3 4
	8
	10 2 5 4 6 7 8 8

	*/

	for (int i = 0; i < n; i++) {
		int j = i;
		int s = a[i];
		while (j < n - 1 && s + a[j + 1] <= hi) {
			j++;
			s += a[j];
		}
		segs.pb({ i, j });
		i = j;
	}
	ans[hi] = sz(segs);
	for (int up = hi + 1; up < N; up++) {
		int pt = -1;
		int i;
		for (i = 0; i < sz(segs) && pt < n - 1; i++) {
			segs[i].first = max(segs[i].first, pt + 1);
			segs[i].second = max(segs[i].second, pt + 1);
			while (segs[i].second < n - 1 && sum(segs[i].first, segs[i].second + 1) <= up) {
				segs[i].second++;
			}
			pt = segs[i].second;
		}
		while (sz(segs) > i) segs.pop_back();
		ans[up] = sz(segs);
	}


	int q; cin >> q;
	while (q--) {
		int v; cin >> v; if (ans[v] == -1) cout << "Impossible\n";  else cout << ans[v] << '\n';
	}


	/*
	cout << sin(355 * 2) << endl;
	for (int i = 1;; i++) {
		if (0 < sin(i) && sin(i) < 4e-5) {
			cout << i << ' ' << sin(i) << endl;
			cout << (1LL << 31) / i << endl;
			return 0;
		}
	}*/

#ifdef ROMA_UMER
	cerr << (ld)clock() / CLOCKS_PER_SEC;
#endif // ROMA_UMER

}