#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <bitset>
#include <cstring>
#include <string>
#include <ctime>
#include <random>
#include <numeric>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <utility>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define X first
#define Y second

using namespace std;  using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;

struct kek {
	ll x, y, h;
};

vector<kek> a;

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

	int n; cin >> n;
	a.resize(n);
	ll lf = 1, rg = 1e12;
	for (int i = 0; i < n; i++) cin >> a[i].x >> a[i].y >> a[i].h, lf = max(lf, a[i].h);

	const ll inf = 1e18;
	while (lf < rg) {
		ll md = (lf + rg) / 2;
		ll lx = -inf, rx = inf, ly = -inf, ry = inf;
		for (int i = 0; i < n; i++) {
			lx = max(lx, a[i].x - (md - a[i].h));
			rx = min(rx, a[i].x + (md - a[i].h));
			ly = max(ly, a[i].y - (md - a[i].h));
			ry = min(ry, a[i].y + (md - a[i].h));
		}
		if (lx <= rx && ly <= ry) rg = md;
		else lf = md + 1;
	}
	ll md = (lf + rg) / 2;
	ll lx = -inf, rx = inf, ly = -inf, ry = inf;
	for (int i = 0; i < n; i++) {
		lx = max(lx, a[i].x - (md - a[i].h));
		rx = min(rx, a[i].x + (md - a[i].h));
		ly = max(ly, a[i].y - (md - a[i].h));
		ry = min(ry, a[i].y + (md - a[i].h));
	}
	cout << lx << ' ' << ly << ' ' << md << endl;
}