#include <iostream>
#include <vector>
#include <bits/stdc++.h>

using namespace std;
#define BIG 10000000
#define sall(a) sort((a).begin(), (a).end())

int n, m;
vector<vector<int>> e;
vector<int8_t> isc;

vector<int> min_d, max_d;

void mineq(int &i, int i1);

void maxeq(int &i, int i1);

void dfs(int v, int p) {
    min_d[v] = BIG;
    max_d[v] = -BIG;

    if (isc[v]) {
//        cerr << v << " is true\n";
        min_d[v] = max_d[v] = 0;
    }

    for (auto i : e[v]) {
        if (i != p) {
            dfs(i, v);
            if (max_d[i] >= 0) {
                mineq(min_d[v], min_d[i] + 1);
                maxeq(max_d[v], max_d[i] + 1);
//                if (v == 2 && min_d[v] == 0) {
//                    cerr << "wtf << \n";
//                }
            }
        }
    }
}

void maxeq(int &i, int i1) {
    i = max(i, i1);
}

void mineq(int &i, int i1) {
    i = min(i, i1);
}

void dfs3(int v, int p, int up_d) {
    vector<pair<int, int>> dists;
    for (int i : e[v]) {
        if (i == p) continue;
        if (max_d[i] >= 0) {
            dists.push_back({max_d[i] + 1, i});
            dists.push_back({min_d[i] + 1, i});
        }
    }
    if (up_d >= 0)
        dists.push_back({up_d + 1, p});
    if (isc[v])
        dists.push_back({0, v});
    sall(dists);
    if (dists.front().first == dists.back().first) {
        cout << "YES\n" << v + 1;
        exit(0);
    }

    int max_v = dists.back().second; // try to go to it
    if (max_v == p || max_v == v) return;

    vector<int> dists2;
    for (int i : e[v]) {
        if (i == p || i == max_v) continue;
        if (max_d[i] >= 0) {
            dists2.push_back(max_d[i] + 1);
            dists2.push_back(min_d[i] + 1);
        }
    }
    if (up_d >= 0)
        dists2.push_back(up_d + 1);
    if (isc[v])
        dists2.push_back(0);
    sall(dists2);

    if (dists2.empty()) {
        dfs3(max_v, v, -1);
    } else if (dists2.front() == dists2.back()) {
        dfs3(max_v, v, dists2.front());
    }

}

int main() {
    cin >> n >> m;
    e.resize(n);
    for (int i = 0; i < n-1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        e[a].push_back(b);
        e[b].push_back(a);
    }
    if (m == 1) {
        cout << "YES\n1";
        return 0;
    }

    isc.resize(n);
    for (int i = 0; i < m; i++)  {
        int a;
        cin >> a;
//        cerr << "set " << a-1 << " true\n";
        isc[a-1] = true;
    }

    min_d.resize(n);
    max_d.resize(n);
    dfs(0, -1);
    dfs3(0, -1, -BIG);
    cout << "NO";
}