#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>

using namespace std;
#define BIG 1000000

const int maxN = 1010;
int x[maxN], y[maxN], h[maxN];

int main() {
    freopen("input", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    int xl = 1e9, xr = -1e9, yl = 1e9, yr = -1e9;
    for(int i = 0; i < n; i++) {
        cin >> x[i] >> y[i] >> h[i];
        xl = min(xl, x[i] - h[i]);
        xr = max(xr, x[i] + h[i]);
        yl = min(yl, y[i] - h[i]);
        yr = max(yr, y[i] + h[i]);
    }

    int length = xr - xl;
    int width = yr - yl;
    if(length % 2 != 0) {
        length++;
    }
    if(width % 2 != 0) {
        width++;
    }
    int height = max(length, width) / 2;
    cout << xl + height  << " " << yl + height << " " << height << "\n";

    return 0;
}