#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;
#define BIG 1000000

unordered_map<int, int> s;

long long solve(vector<int> v) {
    long long res = 0;
    for(int i = 1; i < v.size() - 1; i++) {
        s.clear();
        for(int j = 0; j < i; j++) {
            s[v[i] - v[j]]++;
        }
        for(int j = i + 1; j < v.size(); j++) {
            res += s[v[j] - v[i]];
        }
    }
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
   int t;
   cin >> t;
   for(int test = 0; test < t; test++) {
       int n;
       cin >> n;
       vector<int> t(n);
       for(int i = 0; i < n; i++)
           cin >> t[i];
       cout << solve(t) << "\n";
   }
   return 0;
}