#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

vector<vector<int> > a;
queue<int> qu;
vector<int> d, cnt;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(cout.fixed);
    cout.precision(8);

    int n, m;
    cin >> n >> m;
    a.resize(n);
    d.resize(n, INT_MAX);
    cnt.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int q, w;
        cin >> q >> w;
        q--, w--;
        a[q].push_back(w);
        a[w].push_back(q);
    }
    for (int i = 0; i < m; i++) {
        int q;
        cin >> q;
        q--;
        qu.push(q);
        d[q] = 0;
        cnt[q]++;
    }

    while (!qu.empty()) {
        int z = qu.front();
        qu.pop();
        for (auto i : a[z]) {
            if (d[i] == d[z] + 1) {
                cnt[i] += cnt[z];
            } else {
                if (d[i] > d[z] + 1) {
                    d[i] = d[z] + 1;
                    qu.push(i);
                    cnt[i] = cnt[z];
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (cnt[i] == m)
            return cout << "YES\n" << i + 1, 0;
    }
    cout << "NO";

    return 0;
}
/*
6 3
1 2
2 3
3 4
4 5
4 6
1 5 6
 */