#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int maxn = 1001010;
int n;
int a[maxn], max_a, sum_a[maxn];
int result[maxn];

int find_ans(int x) {
    if (x < max_a) return -1;
    int ans = 0;
    int cur = 0;
    while (cur < n) {
        int l = cur + 1, r = n;
        while (l < r) {
            int mid = (l + r + 1) / 2;
            if (sum_a[mid] - sum_a[cur] > x) r = mid - 1;
            else l = mid;
        }
        ++ans;
        cur = l;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(cout.fixed);
    cout.precision(8);

    cin >> n;
    sum_a[0] = 0;
    max_a = -1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        max_a = max(max_a, a[i]);
        sum_a[i + 1] = a[i] + sum_a[i];
    }

    memset(result, 0, sizeof(result));
    int q; cin >> q;
    while (q--) {
        int qr; cin >> qr;
        if (result[qr] == 0) result[qr] = find_ans(qr);
        if (result[qr] != -1) cout << result[qr] << '\n';
        else cout << "Impossible\n";
    }

    return 0;
}

/*
6
 4 2 3 1 3 4
 8
 10 2 5 4 6 7 8 8
*/