#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 550;

char g[N][N];
int cnt[N][N];
int realCnt[N][N];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(cout.fixed);
    cout.precision(8);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> g[i][j];
            cnt[i][j] = g[i][j] - '0';
            g[i][j] = 0;
        }
        realCnt[i][i] = 1;
    }

    for (int i = n - 1; i >= 0; i--) {
        for (int j = i + 1; j < n; j++) {
            int canTake = 1;

            for (int k = i + 1; k < n; k++) {
                if (realCnt[j][k] > cnt[i][k]) {
                    canTake = 0;
                }
            }

            if (canTake) {
                for (int k = i + 1; k < n; k++) {
                    realCnt[i][k] += realCnt[j][k];
                    cnt[i][k] -= realCnt[j][k];
                }

                g[i][j] = 1;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << +g[i][j];
        }

        cout << "\n";
    }

    return 0;
}