#include <iostream>
#include <vector>

using namespace std;

using lint = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> last_digit(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < n; j++) {
            last_digit[i][j] = s[j] - '0';
        }
    }
    vector<vector<lint>> answer(n, vector<lint>(n));
    auto count = answer;
    for (int len = 1; len < n; len++) { // len_edges
        for (int i = 0; i < n; i++) {
            int j = i + len;
            if (j >= n) {
                continue;
            }
            lint sum = 0;
            for (int k = i + 1; k < j; k++) {
                sum += count[i][k] * answer[k][j];
            }
            if (abs(sum - last_digit[i][j]) % 2 == 1) {
                answer[i][j] = 1;
                sum += 1;
            }
            count[i][j] = sum;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << answer[i][j];
        }
        cout << '\n';
    }
}

/*
5
 01113
 00012
 00001
 00001
 00000

 */