#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int& cur: a) {
            cin >> cur;
        }
        long long result = 0;
        for (int j = 1; j + 1 < n; j++) {
            unordered_map<int, int> diff;
            for (int i = 0; i < j; i++) {
                diff[2 * a[j] - a[i]]++;
            }
            for (int k = j + 1; k < n; k++) {
                result += diff[a[k]];
            }
        }
        cout << result << '\n';
    }
}

/*
4
 5
 1 2 1 2 1
 3
 30 20 10
 5
 1 2 2 3 4
 9
 3 1 4 1 5 9 2 6 5
 */