#include <iostream>
#include <unordered_map>
#include <vector>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;

    int a[2000];
    while (t--) {
        int n;
        cin >> n;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }

        unordered_map<int, int> diff;
        long long result = 0;
        for (int j = 1; j + 1 < n; j++) {
            diff[a[j - 1]]++;
            for (int k = j + 1; k < n; k++) {
                result += diff[2 * a[j] - a[k]];
            }
        }
        cout << result << '\n';
    }
}

/*
4
 5
 1 2 1 2 1
 3
 30 20 10
 5
 1 2 2 3 4
 9
 3 1 4 1 5 9 2 6 5
 */