#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    int n, m; cin >> n;
    vector<int> pr(n);
    int mx = 0;
    for (int i = 0; i < n; i++) {
        cin >> pr[i];
        mx = max(mx, pr[i]);
        if (i > 0) pr[i] += pr[i - 1];
    }
    map<int, int> mem;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int t; cin >> t;
        if (t < mx) {
            cout << "Impossible\n";
            continue;
        }
        if (mem.count(t)) {
            cout << mem[t] << "\n";
            continue;
        }
        int cur_ans = 0;
        for (int pos = 0; pos < n; cur_ans++) {
            int l = pos, r = n;
            int p_sum = (pos > 0 ? pr[pos - 1] : 0);
            while (l < r) {
                int mid = l + (r - l) / 2;
                if (pr[mid] - p_sum <= t) {
                    l = mid + 1;
                } else {
                    r = mid;
                }
            }
            pos = l;
        }
        cout << (mem[t] = cur_ans) << "\n";
    }
}
/*
6
4 2 3 1 3 4
8
10 2 5 4 6 7 8 8
 */