//
// Created by qf on 26.10.2019.
//
#include <iostream>
#include <vector>
#define int long long
using namespace std;
const int C = 1e18;

vector<pair<pair<int, int>, int>> obl;
int n;
int right_w = -C;
int left_w = C;
int up_h = -C;
int down_h = C;

bool check_h(int h) {
    right_w = C;
    left_w = -C;
    up_h = C;
    down_h = -C;
    for (int i = 0; i < n; i++) {
        int can = h - obl[i].second;
        if (can < 0) return false;
        right_w = min(right_w, obl[i].first.first + can);
        left_w = max(left_w, obl[i].first.first - can);
        up_h = min(up_h, obl[i].first.second + can);
        down_h = max(down_h, obl[i].first.second - can);
    }
    return left_w <= right_w && down_h <= up_h;
}

signed main() {
    cin >> n;
    obl.resize(n);
    for (auto &p: obl) {
        cin >> p.first.first >> p.first.second >> p.second;
    }
    int l = 0, r = 2LL * C;
    while (l < r) {
        int m = l + (r - l) / 2LL;
        if (!check_h(m)) {
            l = m + 1LL;
        } else {
            r = m;
        }
    }
    check_h(l);
    cout << left_w << " " << up_h << " " << l;
}