#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;

ll mod = 1e9 + 7;
const int NUM = 1e6 + 5;
const ll INF = 1e18;
vector<vector<int> > g(NUM);
bool c[NUM];
int s, t;
pair<int, int> ans;
int par[NUM];
int depth[NUM];

void dfs(int v, int p, int d){
    depth[v] = d;
    if (c[v])
        ans = max(ans, mp(d, v));
    for (auto u : g[v]){
        if (u == p)
            continue;
        dfs(u, v, d + 1);
        par[u] = v;
    }
}

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    if (n == 1 || m == 1){
        cout << "YES" << endl;
        return 0;
    }
    for (int i = 0; i < n - 1; i++){
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].pb(u);
        g[u].pb(v);
    }
    for (int i = 0; i < n; i++)
        c[i] = false;
    for (int i = 0; i < m; i++){
        int v;
        cin >> v;
        c[v - 1] = true;
    }
    dfs(0, -1, 0);
    s = ans.se;
    ans = mp(0, 0);
    dfs(s, -1, 0);
    t = ans.se;
    vector<int> path;
    while(t != s){
        path.pb(t);
        t = par[t];
    }
    if (path.size() % 2){
        cout << "NO" << endl;
        return 0;
    }
    int v = path[path.size() / 2];
    dfs(v, -1, 0);
    set<int> st;
    for (int i = 0; i < NUM; i++)
        if (c[i])
            st.insert(depth[i]);
    if (st.size() > 1){
        cout << "NO" << endl;
        return 0;
    }
    cout << "YES" << endl << v + 1 << endl;
    return 0;
}