#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <queue>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz size()
#define fori(i,s,n) for (int i = (s); i < (n); ++i)

using namespace std;

typedef long long LL;

void set_precise(int n) {
	cout << setprecision(n);
	cout << fixed;
}



vector <LL> a;

int get_ans(int b) {
	int sum = 0;
	int ans = 0;
	fori(i, 0, a.sz) {
		if (sum + a[i] > b) {
			++ans;
			sum = 0;
		}
		sum += a[i];
		if (a[i] > b) {
			return -1;
		}
	}
	++ans;
	return ans;
}

int bin_search(int L, int R, int ans) {
	while (R - L > 1) {
		int M = (L + R) / 2;
		if (get_ans(M) <= ans) {
			R = M;
		}
		else {
			L = M;
		}
	}
	return R;
}

int small_anses[1003];
vector <pair <int, int> > big_anses;
vector <int> to_search;

int main() {
#ifdef _DEBUG
	freopen("inputH.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	int sum = 0;
	int max_a = 0;
	fori(i, 0, n) {
		LL x;
		cin >> x;
		a.pb(x);
		sum += x;
		if (x > max_a) {
			max_a = x;
		}
	}
	fori(i, 1, 1001) {
		small_anses[i] = get_ans(i);
	}
	int des_ans = 1;
	big_anses.pb(mp(sum, sum));
	while (true) {
		++des_ans;
		if (des_ans > n) {
			break;
		}
		int R = big_anses[des_ans - 2].fs;
		int L = sum / des_ans;
		if (sum % des_ans == 0) {
			--L;
		}
		int cur_min = bin_search(L, R, des_ans);
		int cur_max = big_anses[des_ans - 2].fs - 1;
		big_anses.pb(mp(cur_min, cur_max));
		if (cur_min < 1000) {
			break;
		}
	}
	fori(i, 0, big_anses.sz) {
		to_search.pb(big_anses[i].fs);
	}
	sort(to_search.begin(), to_search.end());
	int m;
	cin >> m;
	fori(i, 0, m) {
		int t;
		cin >> t;
		if (t < max_a) {
			cout << "Impossible" << endl;
			continue;
		}
		if (t < 1000) {
			cout << small_anses[t] << endl;
			continue;
		}
		auto pos = upper_bound(to_search.begin(), to_search.end(), t);
		int d = pos - to_search.begin() - 1;
		cout << to_search.sz - d << endl;
	}
	return 0;
}