#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define fori(i,s,n) for (int i = (s); i < (n); ++i)

using namespace std;

typedef long long LL;

void set_precise(int n) {
	cout << setprecision(n);
	cout << fixed;
}

LL M = 10;

LL msum(LL a, LL b) {
	return (a + b) % M;
}

LL mmpl(LL a, LL b) {
	return (a * b) % M;
}

LL act[503][503] = { 0 };
LL cnt[503][503] = { 0 };
LL g[503][503] = { 0 };

int main() {
#ifdef _DEBUG
	freopen("inputJ.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	fori(i, 0, n) {
		string s;
		cin >> s;
		fori(j, 0, n) {
			act[i][j] = s[j] - '0';
		}
	}

	fori(d, 1, n) {
		fori(s, 0, n - d) {
			int e = s + d;
			LL cur_cnt = 0;
			fori(m, s + 1, e) {
				cur_cnt = msum(cur_cnt, mmpl(cnt[s][m], g[m][e]));
			}
			if (cur_cnt != act[s][e]) {
				g[s][e] = 1;
				cur_cnt = msum(cur_cnt, 1);
			}
			cnt[s][e] = cur_cnt;
		}
	}

	fori(i, 0, n) {
		fori(j, 0, n) {
			cout << g[i][j];
		}
		cout << endl;
	}
	return 0;
}