#include "bits/stdc++.h"
using namespace std;
#define ll long long
#define all(x) (x).begin(), (x).end()
#define gcd __gcd
#define IOS ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

struct elem{
    vector<ll> childs;
    ll depth;
    ll parent;
};

vector<elem> tree;

void dfs(ll cur_node, ll cur_par, ll depth){
    tree[cur_node].depth = depth;
    tree[cur_node].parent = cur_par;
    for(auto child : tree[cur_node].childs){
        if(child != cur_par){
            dfs(child, cur_node, depth + 1);
        }
    }
}

int main() {
    IOS

    ll n,m;
    cin >> n >> m;
    tree.resize(n + 1);
    for(int i = 0; i < n - 1; ++i){
        ll a,b;
        cin >> a >> b;
        tree[a].childs.push_back(b);
        tree[b].childs.push_back(a);
    }

    vector<ll> c(m);
    for(int i =0 ;i  < m; ++i){
        cin >> c[i];
    }
    if(m == 1){
        cout << "YES\n";
        cout << c[0];
        return 0;
    }
    dfs(c[0], -1,0);
    if(tree[c[1]].depth % 2 == 1)
    {
        cout << "NO";
        return 0;
    }

    ll rad = tree[c[1]].depth / 2;

    ll cur_v = c[1];
    for(int i = 0; i < rad; ++i){
        cur_v = tree[cur_v].parent;
    }

    dfs(cur_v, -1, 0);

    for(auto i : c){
        if(tree[i].depth != rad){
            cout << "NO";
            return 0;
        }
    }

    cout << "YES\n";
    cout << cur_v;
    return 0;
}


/*
 6 3
 1 2
 2 3
 3 4
 4 5
 4 6
 1 5 6
 */
/*
 4
 5
 1 2 1 2 1
 3
 30 20 10
 5
 1 2 2 3 4
 9
 3 1 4 1 5 9 2 6 5
 */

//ll t;
//cin >> t;
//while(t--){
//ll n;
//cin >> n;
//vector<ll> vec(n);
//for(int i = 0; i < n; ++i){
//cin >> vec[i];
//}
//vector<elem> pcalc(n);
//for(int i = 0; i < n; ++i){
//for(int j = 0;j < n; ++j){
//if(j < i){
//pcalc[i].left[vec[i] - vec[j]]++;
//}else if(j > i){
//pcalc[i].right[vec[j] - vec[i]]++;
//}
//}
//}
//
//ll ans = 0;
//for(int i = 0; i < n; ++i){
//for(auto j : pcalc[i].left){
//if(pcalc[i].right.count(j.first)){
//ans += j.second * pcalc[i].right[j.first];
//}
//}
//}
//cout << ans << '\n';
//}