#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int inf = 1e9;
const int N = 2e5 + 5;
const int K = 1000;

int n, q;
int a[N];
int qs[N];
int mx;

void read() {
    cin >> n;
    mx = 0;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        mx = max(mx, a[i]);
    }
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> qs[i];
    }
}

int fast_res[N];
int mem[K];
int pref[N];

void fast() {
    for (int k = 1; k < K; k++) {
        if (k < mx) continue;
        int i = 1;
        while (i <= n) {
            int sm = a[i];
            while (i < n && sm + a[i + 1] <= k) {
                i++;
                sm += a[i];
            }
            mem[k]++;
            i++;
        }
    }
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }
    for (int i = 0; i < q; i++) {
        int k = qs[i];
        if (k < mx) {
            fast_res[i] = -1;
            continue;
        }
        if (k < K) {
            fast_res[i] = mem[k];
            continue;
        }
        int pos = 1;
        while (pos <= n) {
            int bl = pos;
            int br = n + 1;
            int bm;
            while (br - bl > 1) {
                bm = (bl + br) >> 1;
                if (pref[bm] - pref[pos - 1] <= k) {
                    bl = bm;
                } else {
                    br = bm;
                }
            }
            int next_pos = bl;
            fast_res[i]++;
            pos = next_pos + 1;
        }
    }
}

void WORK() {
    read();
    fast();
    for (int i = 0; i < q; i++) {
        if (fast_res[i] == -1) {
            cout << "Impossible\n";
        } else {
            cout << fast_res[i] << "\n";
        }
    }
}

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    WORK();

    return 0;
}