#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int inf = 1e9;

const int N = 1005;

struct pt {
    int x, y, h;
};

int n;
pt p[N];

void read() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y >> p[i].h;
    }
}

bool check(int H, int& x, int& y) {
    int lx = -inf;
    int rx = +inf;
    int ly = -inf;
    int ry = +inf;
    for (int i = 0; i < n; i++) {
        int di = H - p[i].h;
        lx = max(lx, p[i].x - di);
        rx = min(rx, p[i].x + di);
        ly = max(ly, p[i].y - di);
        ry = min(ry, p[i].y + di);
    }
    x = lx;
    y = ly;
    return (lx <= rx && ly <= ry);
}

void fast() {
    int bl = 0;
    int br = inf;
    int bm;
    int x, y;
    while (br - bl > 1) {
        bm = (bl + br) / 2;
        if (check(bm, x, y)) {
            br = bm;
        } else {
            bl = bm;
        }
    }
    check(br, x, y);
    cout << x << " " << y << " " << br << "\n";
}

void WORK() {
    read();
    fast();
}

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    WORK();

    return 0;
}