#include <bits/stdc++.h>
using namespace std;

string to_string(bool x)
{
    return x ? "true" : "false";
}

string to_string(char x)
{
    return string(1, x);
}

string to_string(string x)
{
    return "\"" + x + "\"";
}

string to_string(const char *x)
{
    return to_string((string) x);
}

template <typename A, typename B>
string to_string(pair<A, B> p)
{
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A>
string to_string(A arr)
{
    auto first = true;
    string result = "{";
    for (const auto &x: arr) {
        if (!first) {
            result += ", ";
        }
        result += to_string(x);
        first = false;
    }
    result += "}";
    return result;
}

void debug_out() {
    cerr << endl;
}

template <typename Head, typename ... Tail>
void debug_out(Head head, Tail ...tail) {
    cerr << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]: "; debug_out(__VA_ARGS__);
#else
#define debug(...) 42;
#endif

using ll = long long;
using vi = vector < int >;

const int MAXN = 555;

int init[MAXN][MAXN];
int n;
int cnt[MAXN][MAXN];
int ans[MAXN][MAXN];

void solve() {
	cin >> n;
	for(int i = 0; i < n; i++) 
		for(int j = 0; j < n; j++) {
			char x; cin >> x;
			init[i][j] = int(x - '0');
		}
	
	for(int v = 0; v < n; v++) {
		for(int u = v - 1; u >= 0; u--) {
			int cur = 0;
			for(int t = u + 1; t < v; t++) {
				if(ans[t][v])
					cur = (cur + cnt[u][t]) % 10; 
			}
			if(cur != init[u][v]) {
				ans[u][v] = 1;
				cnt[u][v] = (cur + 1) % 10;
			}
			else {
				ans[u][v] = 0;
				cnt[u][v] = (cur) % 10;
			}
		}

	}
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < n; j++) 
			cout << ans[i][j];
		cout << endl;
	}
}                               

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("xxx.in", "r", stdin);
    freopen("xxx.out", "w", stdout);
#endif
	solve();
    return 0;
}