#include <iostream>
#include <vector>

using namespace std;

const int MX = 3*1e5 + 10;
vector <int> g[MX];
int pr[MX], h[MX];

void dfs(int v, int pp)
{
    pr[v] = pp;
    if (pp < 0) h[v] = 0;
    else h[v] = h[pp] + 1;

    for (int u : g[v])
        if (u != pp) dfs(u, v);
}

int main(){
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n-1; i++)
    {
        int a, b;
        cin >> a >> b;
        g[a-1].push_back(b-1);
        g[b-1].push_back(a-1);
    }

    int c[m];
    for (int i = 0; i < m; i++)
    {
        cin >> c[i];
        c[i]--;
    }


    int root1 = c[0];
    dfs(root1, -1);

    int mx = 0, root2 = c[0];
    for (int i = 0; i < m; i++)
    {
        if (h[c[i]] > mx)
        {
            mx = h[c[i]];
            root2 = c[i];
        }
    }


    vector <int> vc;

    if (m == 1)
    {
        cout << "YES\n1\n";
        return 0;
    }


    int v = root2;
    while (v != -1)
    {
        vc.push_back(v);
        v = pr[v];
    }

    if (vc.size()%2 == 0)
    {
        cout << "NO\n";
        return 0;
    }

    int root = vc[vc.size()/2];
    dfs(root, -1);
    int fl = 1;

    for (int i = 0; i < m; i++)
        if (h[c[i]] != h[c[0]]) fl = 0;

    if (fl) cout << "YES\n" << root+1 << "\n";
    else cout << "NO\n";
    return 0;
}
