#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#define MX 1000000000

using namespace std;

bool cmp(pair<int, int> p1, pair<int, int> p2)
{
    return p1.second - p1.first < p2.second - p2.first;
}

int main(){
    int n;
    cin >> n;

    int cnt[n][n];
    for (int i = 0; i < n; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < n; j++)
            cnt[i][j] = s[j] - '0';
    }
    vector <pair<int, int> > ord;

    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++) ord.push_back({i, j});

    sort(ord.begin(), ord.end(), cmp);

    int m[n][n];
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++) m[i][j] = 0;

    for (auto xx : ord)
    {
        int a = xx.first;
        int b = xx.second;
        int res = 0;
        for (int c = a+1; c < b; c++)
            if (m[a][c]) res += cnt[c][b];

        if (res%10 != cnt[a][b]) m[a][b] = 1;
    }

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++) cout << m[i][j];
        cout << "\n";
    }

    return 0;
}

