#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>


using namespace std;
using ll=long long;
using ld=long double;




signed main() {
	ios::sync_with_stdio(false); cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<set<ll>> g(n);
	vector<int> deg(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		--a;
		--b;
		g[a].insert(b);
		g[b].insert(a);
		deg[a]++;
		deg[b]++;
	}
	vector<int> kek(m);
	set<int> sin;
	for (int i = 0; i < m; i++) {
		cin >> kek[i];
		kek[i]--;
		sin.insert(kek[i]);
	}
	queue <int> q;
	int t = n;
	for (int i = 0; i < n; i++)
		if (deg[i] == 1 && sin.count(i)==0) q.push(i);
	while (!q.empty()) {
		t--;
		int u = q.front();
		if (!g[u].empty()) {
			int v = *g[u].begin();
			g[v].erase(u);
			if (deg[v] != 1)
			{
				deg[v]--;
				if (deg[v] == 1 && sin.count(v)==0) q.push(v);
			}
		}
		q.pop();
		g[u] = {};
		deg[u] = 0;
	}
	set<ll> lol;
	for (auto u : sin) {
		lol.insert(u);
		if (deg[u] != 1)
		{
			cout << "NO";
			return 0;
		}
	}
	while (t > 2) {
		set<ll> newlol;
		for (auto v : lol) {
			int u = *g[v].begin();
			deg[v] = 0;
			g[v] = {};
			g[u].erase(v);
			deg[u]--;
			newlol.insert(u);
			t--;
		}
		for (auto v : newlol) {
			if(deg[v]>1 || lol.count(v)==1) 
			{
				cout << "NO";
				return 0;
			}
		}
		lol = newlol;
	}
	if (lol.size() == 1) {
		cout << "YES" << '\n';
		cout << *lol.begin() + 1;
	}
	else cout << "NO";



}
