#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>

using namespace std;
using ll=long long;
using ld=long double;




signed main(){ 
	ios::sync_with_stdio(false); cin.tie(0);
	int n; cin >> n;
	vector<ll> x(n), y(n), h(n);
	for (int i = 0; i < n; i++)
		cin >> x[i] >> y[i] >> h[i];

	ll lx = 1e18, rx = -1e18, up = -1e18, dw = 1e18;
	for (int i = 0; i < n; i++) {
		lx = min(lx, x[i] - h[i]);
		rx = max(rx, x[i] + h[i]);
		dw = min(dw, y[i] - h[i]);
		up = max(up, y[i] + h[i]);
	}
	if (up - dw > rx - lx)
		rx = lx + up - dw;
	if (rx - lx > up - dw)
		up = dw + rx - lx;
	assert(up - dw == rx - lx);
	if ((up - dw) % 2 == 1)
		up++, rx++;
	
	cout << (lx + rx) / 2 << " " << (up + dw) / 2 << " ";
	cout << (up - dw) / 2 << endl;
}
