#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>

using namespace std;
using ll=long long;
using ld=long double;


void color(vector<vector<char>>& x, int a, int b, int c, int d) {
	if (c < a || b > d)
		return;
	int begx = a;
	int num = 0;
	char col = '.';
	for (int j = a; j <= c; j++) {
		int begy = b;
		for (int i = b; i <= d; i++) {

			if (x[j][i] != '.') {
				col = x[j][i];
				for (int k = begx; k <= j; k++)
					for (int l = begy; l <= i; l++)
						x[k][l] = x[j][i] + +'a' - 'A';
				begy = i + 1;
				num++;

			}
		}
		if (num != 0) {
			for (int k = begx; k <= j; k++)
				for (int l = begy; l <= d; l++)
					x[k][l] = col + 'a' - 'A';
			begx = j + 1;
		}
		

	}

	for (int j = begx; j <= c; j++) {
		for (int i = b; i <= d; i++) {
			x[j][i] = col + 'a' - 'A';
		}
	}



}


signed main(){ 
	ios::sync_with_stdio(false); cin.tie(0);
	int n, m; cin >> n >> m;
	vector<vector<char>> mp(n, vector<char>(m));
	vector<int> used(m);
	vector<vector<int>> pref(n, vector<int>(m + 1));
	int ia = -1, ib = -1;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			pref[i][j + 1] = pref[i][j];
			cin >> mp[i][j];
			if (mp[i][j] == 'A') {
				ia = i, ib = j;
			}
			else if (mp[i][j] != '.')
				used[j] = 1, pref[i][j + 1]++;
		}
	///vector<int> used(m);
	

	auto ok = [&](int l, int r, int ind) {
		return pref[ind][r] - pref[ind][l + 1] == 0;
	};


	ll sm = 0;
	int l1 = -1, r1 = -1;
	int lw = -1, up = -1;
	//int lx = m, rx = -1, up = -1, dw = n;
	for (int i = -1; i <= m; i++) {
		for (int j = i + 1; j <= m; j++) {
			if (!((i == -1 || used[i]) && (j == m || used[j]))) {
				continue;
			}
			int ind1 = ia;
			while (ind1 >= 0 && ok(i, j, ind1))
				ind1--;
			int ind2 = ia;
			while (ind2 < n && ok(i, j, ind2))
				ind2++;
			if (i == -1 && j == m) {
				i = i;
			}
			if ((j - i - 1) * 1LL * (ind2 - ind1 - 1) > sm) {
				
				sm = (j - i - 1) * 1LL * (ind2 - ind1 - 1);
				l1 = i;
				r1 = j;
				lw = ind1;
				up = ind2;
			}
		}
	}

	cout << sm << endl;
	auto mp2 = mp;

	color(mp, up, 0, n - 1, r1 - 1);
	color(mp, lw + 1, r1, n - 1, m - 1);
	color(mp, 0, l1 + 1, lw, m - 1);
	color(mp, 0, 0, up - 1, l1);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (mp2[i][j] >= 'A' && mp2[i][j] <= 'Z')
				mp[i][j] = mp2[i][j];
			if (mp[i][j] == '.')
				mp[i][j] = 'a';
		}
	}
	
	for (auto& x : mp) {
		for (auto& y : x)
			cout << y;
		cout << endl;
	}
}
