#include <iostream>
#include <vector>

using namespace std;

const int maxn = 200;
int a[maxn], b[maxn];
int n;
vector<pair<int, int>> res;

void print_set_first_of_to(int x, int y)
{
    cout << "foreach ($a as &$x) if ($x == " << x << ") break;\n";
    cout << "foreach ($a as  $x) if ($x == " << y << ") break;\n";
}

void sfot(int x, int y)
{
    res.push_back({x, y});
}

void fail()
{
    cout << "-1\n";
    exit(0);
}

bool cr[maxn];

bool have(int c)
{
    for (int i = 0; i < n; ++i) {
        if (a[i] == c) {
            return true;
        }
    }
    return false;
}

void filluntil(int i, int c)
{
    if (a[i] == c) return;
    if (!have(c)) fail();
    int cur = a[i];
    while (a[i] != c) {
        for (int j = 0; j < n; ++j) {
            if (a[j] == cur) {
                sfot(cur, c);
                a[j] = c;
                break;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    for (int i = 0; i < n; ++i) {
        bool crit = 1;
        for (int j = i+1; j < n; ++j) {
            if (b[j] == b[i]) {
                crit = 0;
                break;
            }
        }
        cr[i] = crit;
    }

    for (int i = n-1; i >= 0; --i) {
        if (cr[i] && (a[i] != b[i])) {
            filluntil(i, b[i]);
        }
    }

    for (int i = n-1; i >= 0; --i) {
        if (a[i] == b[i]) {
            continue;
        }
        filluntil(i, b[i]);
    }

    cout << res.size() * 2 << '\n';
    for (auto p: res) {
        print_set_first_of_to(p.first, p.second);
    }
    return 0;
}
