#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;
	cin >> n;

	vector<int> a(n);
	for (int &x : a)
		cin >> x;

	const int maxa = *max_element(a.begin(), a.end());
	cerr << maxa << endl;

	vector<int> suma(n + 1);
	partial_sum(a.begin(), a.end(), suma.begin() + 1);

	vector<int> mem_ans(suma[n] + 1, -1);

	int q;
	cin >> q;

	for (int i = 0; i < q; i++)
	{
		int t;
		cin >> t;

		if (t < maxa)
		{
			cout << "Impossible\n";
			continue;
		}

		if (mem_ans[t] == -1)
		{
			int pos = 0, cnt = 0;
			while (pos < n)
			{
				pos = upper_bound(suma.begin() + pos + 1, suma.end(),
						suma[pos] + t) - suma.begin() - 1;
				cnt++;
			}

			mem_ans[t] = cnt;
		}

		cout << mem_ans[t] << "\n";
	}

	cout.flush();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	time_t st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif
	return 0;
}
