#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	int b = numeric_limits<int>::max(), t = numeric_limits<int>::min();
	int l = numeric_limits<int>::max(), r = numeric_limits<int>::min();

	for (int i = 0; i < n; i++)
	{
		int x, y, z;

		cin >> x >> y >> z;

		b = min(b, y - z);
		t = max(t, y + z);
		l = min(l, x - z);
		r = max(r, x + z);
	}

	if ((b + t) % 2 != 0)
		t++;
	if ((l + r) % 2 != 0)
		r++;

	int hx = (l + r) / 2;
	int hy = (b + t) / 2;
	int hh = max(r - l, b - t) / 2;

	cout << hx << ' ' << hy << ' ' << hh << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	time_t st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif
	return 0;
}
