#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int t;
	cin >> t;

	for (int test = 0; test < t; test++)
	{
		int n;
		cin >> n;

		vector<pair<int, int>> arr(n);
		for (int i = 0; i < n; i++)
		{
			cin >> arr[i].first;
			arr[i].second = i;
		}

		sort(arr.begin(), arr.end());
		auto rev = arr;
		reverse(rev.begin(), rev.end());

		ll ans = 0;

		for (const auto &pr : arr)
		{
			int aj, j;
			tie(aj, j) = pr;

			int ptr_l = 0, ptr_r = 0, cnt = 0;

			for (const auto &other_pr : arr)
			{
				if (other_pr.second >= j)
					continue;

				int ai, i;
				tie(ai, i) = other_pr;

				const int target = 2 * aj - ai;

				while (ptr_l < n && rev[ptr_l].first > target)
				{
					cnt -= (rev[ptr_l].second > j ? 1 : 0);
					ptr_l++;
				}
				while (ptr_r < n && rev[ptr_r].first >= target)
				{
					cnt += (rev[ptr_r].second > j ? 1 : 0);
					ptr_r++;
				}

//				cnt = 0;
//				for (auto x : rev)
//					cnt += (x.first == target && x.second > j);

				ans += cnt;

			}
		}

		cout << ans << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	time_t st = clock();

	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << (clock() - st) / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif
	return 0;
}
