#include <iostream>
#include <cmath>
#include <vector>
#include <unordered_map>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> d(n);
//    string s;
//    cin >> s;
    for (int i = 0; i < n; i++) {
        d.resize(n);
        string s;
        cin >> s;
        for (int j = 0; j < n; j++) {
            d[i].push_back(s[j]-'0');
        }
    }
    vector<vector<int>> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i].resize(n, 0);
    }
    for (int i = 1; i < n; i++) {
        vector<int> dp(i, 0);
        for (int j = i - 1; j >= 0; j--) {
            for (int k = j; k < i; k++) {
                if (ans[j][k] == 1)
                    dp[j] += dp[k];
            }
            if (dp[j] % 10 != d[j][i]) {
                dp[j]++;
                ans[j][i] = 1;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cout << ans[i][j];
        }
        cout << "\n";
    }
}