#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

#define SZ(A) int((A).size())
#define ALL(A) bend(A)



void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> graph(n);

    for (int i = 1; i < n; ++i) {
	int v = input<int>() - 1;
	int u = input<int>() - 1;

	graph[v].push_back(u);
	graph[u].push_back(v);
    }

    vector<int> arr(m);
    for (int& elem: arr)
	elem = input<int>() - 1;

    if (m == 1) {
	cout << "YES\n1\n";
	return;
    }

    auto get_dist = [&](int v) {
			vector<int> res(n, int(1e9));

			res[v] = 0;
			queue<int> q;
			q.push(v);

			while (not q.empty()) {
			    int u = q.front();
			    q.pop();

			    for (int w: graph[u])
				if (res[w] > res[u] + 1) {
				    res[w] = res[u] + 1;
				    q.push(w);
				}
			}

			return res;
		    };

    const int inf = 1e9;
    queue<int> q;
    vector<int> thedist(n, inf);
    vector<int> cntdist(n, 0);

    for (int v: arr) {
	thedist[v] = 0;
	cntdist[v] = 1;
	q.push(v);
    }

    while (not q.empty()) {
	int v = q.front();
	q.pop();

	for (int u: graph[v]) {
	    if (thedist[u] == thedist[v] + 1) {
		cntdist[u] += cntdist[v];
	    } else if (thedist[u] == inf) {
		thedist[u] = thedist[v] + 1;
		cntdist[u] = cntdist[v];
		q.push(u);
	    }
	}
    }
    
    int vv = 0;
    for (int v = 0; v < n; ++v)
	if (cntdist[v] == m)
	    vv = v;

    auto dst = get_dist(vv);
    for (int i = 1; i < m; ++i)
	if (dst[arr[i - 1]] != dst[arr[i]]) {
	    cout << "NO\n";
	    return;
	}

    cout << "YES\n";
    cout << vv +1 << "\n";
    return;
    
}


int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int test_count = 1;
	//cin >> test_count;
	for (int i = 0; i < test_count; i++) {
		solve();
	}
#ifdef LOCAL
	cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
