#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename T>
void input_seq(T a, T b) {
    std::generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

#define SZ(A) int((A).size())
#define ALL(A) bend(A)
#define TYPEMAX(A) std::numeric_limits<A>::max()
#define TYPEMIN(A) std::numeric_limits<A>::min()

void solve() {
    int n = input<int>();
    vector<int> arr(n);
    input_seq(ALL(arr));

    int mx = *std::max_element(ALL(arr));
    
    vector<int> res(n + 1);
    for (int i = 0; i < n; ++i)
	res[i + 1] = res[i] + arr[i];

    int q = input<int>();
    vector<int> quer(q);

    for (int i = 0; i < q; ++i)
	quer[i] = input<int>();

    auto real_quer = quer;
    std::sort(ALL(real_quer));
    real_quer.erase(std::unique(ALL(real_quer)), real_quer.end());

    vector<int> ans(SZ(real_quer));
    for (int i = 0; i < SZ(real_quer); ++i) {
	if (real_quer[i] < mx) {
	    ans[i] = -1;
	    continue;
	}

	int p = 0, nseg = 0;
	while (p != n) {
	    auto ind = std::upper_bound(ALL(res), res[p] + real_quer[i]) - res.begin() - 1;

	    nseg += 1;
	    p = ind;
	}

	ans[i] = nseg;
    }
    
    for (int x: quer) {
	int i = std::lower_bound(ALL(real_quer), x) - real_quer.begin();
	if (ans[i] == -1)
	    cout << "Impossible\n";
	else
	    cout << ans[i] << "\n";
    }
}


int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int test_count = 1;
	//cin >> test_count;
	for (int i = 0; i < test_count; i++) {
		solve();
	}
#ifdef LOCAL
	cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
