#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

template <typename T>
T input() {
    T res;
    cin >> res;
    return res;
}

#define SZ(A) int((A).size())
#define ALL(A) bend(A)

void solve() {
	int n;
	cin >> n;
	vector<int> mas(n), left[n], right[n];
	for (int i = 0; i < n; i++)
		cin >> mas[i];
	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			right[i].push_back(mas[j] - mas[i]);
			left[j].push_back(mas[j] - mas[i]);
		}
	}	
	long long ans = 0;
	for (int i = 0; i < n; i++)
	{
		sort(left[i].begin(), left[i].end());
		sort(right[i].begin(), right[i].end());
		int q = 0, w = 0;
		while (q < (int)left[i].size() && w < (int)right[i].size())
		{
			if (left[i][q] < right[i][w])
				q++;
			else if (left[i][q] > right[i][w])
				w++;
			else
			{
				int x = left[i][q];
				long long cnt1 = 0, cnt2 = 0;
				while (q < (int)left[i].size() && left[i][q] == x)
				{
					q++;
					cnt1++;
				}
				while (w < (int)right[i].size() && right[i][w] == x)
				{
					w++;
					cnt2++;
				}
				ans += cnt1 * cnt2;
			}
		}
	}
	cout << ans << "\n";
}


int main() {
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(false);
	int test_count = 1;
	cin >> test_count;
	for (int i = 0; i < test_count; i++) {
		solve();
	}
#ifdef LOCAL
	cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}
