//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define KEK (SUKA++, die(), cout)

vector<vector<char>> a, used;
int n, m;
int SUKA = 0;

vector<vector<vector<pair<int, int>>>> adj;

const int dx[8] = {-1, 0, 1, 0, -1, -1, 1, 1};
const int dy[8] = {-1, -1, 1, 1, 0, 1, -1, 0};
const int tx[4] = {0, 1, 0, 1};
const int ty[4] = {0, 1, 1, 0};

void dfs(int x, int y) {
    used[x][y] = 1;
    for (int d = 0; d < 8; ++d) {
        int nx = x + dx[d];
        int ny = y + dy[d];
        if (nx < 0 || ny < 0 || nx >= n || ny >= m) continue;
        if (used[nx][ny]) continue;
        if (a[nx][ny] != 'X') continue;
        adj[x][y].emplace_back(nx, ny);
        dfs(nx, ny);
    }
}



int RR;

int die() {
    if (SUKA - 1 == RR) exit(0);
    return 0;
}


int cx, cy;

void cross(int x, int y, int sx, int sy) {
    if (sx == x && sy == y) {
        KEK << (x + 1) << " " << (y + 1) << endl;
        KEK << x << " " << (y + 1) << endl;
        KEK << x + 1 << " " << y << endl;
        KEK << x << " " << y << endl;
    } else if (sx == x && sy == y + 1) {
        KEK << x + 1 << " " << y << endl;
        KEK << x << " " << y << endl;
        KEK << (x + 1) << " " << (y + 1) << endl;
        KEK << x << " " << (y + 1) << endl;
    } else if (sx == x + 1 && sy == y) {
        KEK << x << " " << y << endl;
        KEK << (x + 1) << " " << (y + 1) << endl;
        KEK << x << " " << (y + 1) << endl;
        KEK << x + 1 << " " << y << endl;
    } else if (sx == x + 1 && sy == y + 1) {
        KEK << x << " " << (y + 1) << endl;
        KEK << x + 1 << " " << y << endl;
        KEK << x << " " << y << endl;
        KEK << (x + 1) << " " << (y + 1) << endl;
    }
}

void stitch(int x, int y, int sx, int sy) {
    auto &ad = adj[x][y];
    if (ad.empty()) {
        cross(x, y, sx, sy);
        return;
    }
    pair<int, int> qq[8];
    for (auto &p : qq) p = {-1, -1};
    int ss = 0;
    if (sx == x + 1 && sy == y +1) ss = 1;
    if (sx == x + 1 && sy == y) ss = 3;
    if (sx == x + 0 && sy == y +1) ss = 2;

    for (int d = 0; d < 8; ++d) {
        for (auto p : ad) {
            int nx = x + dx[d];
            int ny = y + dy[d];
            if (p.first == nx && p.second == ny)  {
                qq[d] = p;
            }
        }
    }

    for (int i = 0; i < 4; ++i, ss = (ss + 1) % 4) {
        for (int d = 2 * ss; d <= 2* ss + 1; ++d) {
            if (qq[d].first != -1) {
                stitch(qq[d].first, qq[d].second, x + tx[ss], y + ty[ss]);
            }
        }
        if (ss == 0) KEK << (x + 1) << " " << (y + 1) << endl;
        if (ss == 1) KEK << (x + 0) << " " << (y + 1) << endl;
        if (ss == 2) KEK << (x + 1) << " " << (y + 0) << endl;
        if (ss == 3) KEK << (x + 0) << " " << (y + 0) << endl;
    }
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    a.resize(n, vector<char>(m));
    used.resize(n, vector<char>(m));
    adj.resize(n, vector<vector<pair<int, int>>>(m));
    int rx = -1, ry = -1;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            cnt += a[i][j] == 'X';
            if (rx == -1 && a[i][j] == 'X') {
                rx = i; ry = j;
            }
        }
    }
    cx = rx; cy = ry;
    dfs(rx, ry);
    cout <<( RR = cnt * 4 - 1) << endl;
    stitch(rx, ry, rx, ry);

    return 0;
}