//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e9 + 7;

vector<vector<ll>> g;

vector<char> isT;

vector<ll> d, p;

ll bfs(ll vv, ll n) {
    ll v1 = vv;
    d.assign(n, INF);
    p.assign(n, -1);
    queue<ll> q;
    q.push(vv);
    d[vv] = 0;
    while (q.size()) {
        ll v = q.front();
        q.pop();
        if (isT[v] && d[v] > d[v1]) v1 = v;
        for (auto to : g[v]) {
            if (d[to] > d[v] + 1) {
                q.push(to);
                d[to] = d[v] + 1;
                p[to] = v;
            }
        }
    }
    return v1;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        ll v, to;
        cin >> v >> to;
        --v, --to;
        g[v].push_back(to);
        g[to].push_back(v);
    }
    isT.assign(n, 0);
    vector<ll> vv(m);
    for (int i = 0; i < m; ++i) {
        cin >> vv[i];
        --vv[i];
        isT[vv[i]] = 1;
    }
    ll v1 = bfs(vv[0], n);
    ll v2 = bfs(v1, n);
    if (d[v2] % 2) {
        cout << "NO";
        return 0;
    }
    ll dist = d[v2] / 2;
    for (int i = 0; i < dist; ++i) v2 = p[v2];
    cout << "YES\n";
    cout << v2 + 1;

    return 0;
}