#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n), ps(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ps[i + 1] = ps[i] + a[i];
    }
    int q;
    cin >> q;
    vector<pair<int, int>> t(q);
    vector<int> ans(q);
    for (int i = 0; i < q; ++i) {
        cin >> t[i].first;
        t[i].second = i;
    }
    sort(t.begin(), t.end());
    int me = *max_element(a.begin(), a.end());

    int prev = me, S = 0;
    vector<int> split;
    for (int i = 0; i < n; ++i) {
        int s = S + a[i];
        if (s > me) {
            split.push_back(i);
            s = a[i];
        }
        S = s;
    }

    int pr = split.size() + 1;
    for (auto [k, _] : t) {
        if (k < me) {
            ans[_] = -1;
            continue;
        }
        int shift = k - prev;
        if (shift <= 0) {
            ans[_] = pr;
            continue;
        }
        prev = k;
        if (k <= 1000) {
            split.clear();
            S = 0;
            for (int i = 0; i < n; ++i) {
                int s = S + a[i];
                if (s > k) {
                    split.push_back(i);
                    s = a[i];
                }
                S = s;
            }
            ans[_] = pr = split.size() + 1;
            continue;
        }
        int last = 0, i;
        for (i = 0; i < split.size(); ++i) {
            int nv = split[i] + 1;
            while (nv <= n && ps[nv] - ps[last] <= k) {
                split[i]++;
                nv++;
            }
            last = split[i];
            if (split[i] >= n) {
                split.erase(split.begin() + i, split.end());
                break;
            }
        }
        ans[_] = pr = split.size() + 1;
    }

    for (int i : ans) {
        if (i == -1) {
            cout << "Impossible\n";
            continue;
        }
        cout << i << '\n';
    }

    cerr << clock() * 1.0 / CLOCKS_PER_SEC << endl;
    return 0;
}