#include <bits/stdc++.h>

using namespace std;

int a[300000];

int part(int x, int n)
{
    int ans = 0, cur = 0;
    for(int i = 0; i < n; i++)
    {
        if(a[i] > x)
            return -1;
        if(a[i] + cur > x)
        {
            ans++;
            cur = a[i];
        }
        else
            cur += a[i];
    }
    if(cur)
        ans++;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cout << fixed << setprecision(20);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, q;
    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cin >> q;
    vector<pair<int, int>> qu(q);
    vector<int> ans(q);
    for(int i = 0; i < q; i++)
    {
        cin >> qu[i].first;
        qu[i].second = i;
    }
    sort(qu.rbegin(), qu.rend());
    int cur_ans = part(qu.begin()->first, n);
    if(cur_ans == -1)
    {
        for(int i = 0; i < q; i++)
            cout << "Impossible\n";
        return 0;
    }
    for(int i = 0; i < q; i++)
    {
        int cur_ans = part(qu[i].first, n);
        if(cur_ans == -1)
            break;
        int l = i, r = q, m;
        for(;l + 1 < r;)
        {
            m = (l + r) >> 1;
            int new_ans = part(qu[m].first, n);
            if(new_ans == -1 || new_ans > cur_ans)
                r = m;
            else
                l = m;
        }
        for(int j = i; j <= l; j++)
            ans[qu[j].second] = cur_ans;
        i = l;
    }
    for(int i = 0; i < q; i++)
        if(ans[i])
            cout << ans[i] << "\n";
        else
            cout << "Impossible\n";
    return 0;
}