#include <bits/stdc++.h>

using namespace std;

pair<pair<int, int>, bool> get(vector<pair<pair<int, int>, int>> &kek, int d) {
    int x1 = -1000000000;
    int y1 = -1000000000;
    int x2 = 1000000000;
    int y2 = 1000000000;
    for (auto p: kek) {
        if (d < p.second) return {{0, 0}, 0};
        int d1 = d - p.second;
        x1 = max(x1, p.first.first - d1);
        x2 = min(x2, p.first.first + d1);
        y1 = max(y1, p.first.second - d1);
        y2 = min(y2, p.first.second + d1);
    }
    if (x1 > x2 || y1 > y2) {
        return {{0, 0}, 0};
    }
    return {{x1, y1}, 1};
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cout << fixed << setprecision(20);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> kek(n);
    for (int i = 0; i < n; i++) {
        cin >> kek[i].first.first >> kek[i].first.second >> kek[i].second;
    }
    int l = -1;
    int r = 1000000000;
    while (l < r - 1) {
        int m = (l + r) / 2;
        auto p = get(kek, m);
        if (!p.second) {
            l = m;
        } else {
            r = m;
        }
    }
    auto p = get(kek, r);
    cout << p.first.first << " " << p.first.second << " " << r << endl;
    return 0;
}