#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MOD = 998244353;

int main() {
    int n, k;
    cin >> n >> k;
    if (n == 1) {
        cout << k;
        return 0;
    }
    vector<ll> p(n + 1);
    p[0] = 1;
    p[1] = k;
    for (int i = 2; i < p.size(); i++) {
        p[i] = (k * p[i - 2]) % MOD;
    }
    vector<ll> pref(n + 1);
    pref[0] = 1;
    for (int i = 1; i < pref.size(); i++) {
        pref[i] = (pref[i - 1] + p[i]) % MOD;
    }

    vector<ll> powers;
    ll k_power = 1;
    for (int i = 0; i <= n; i++) {
        powers.push_back(k_power);
        k_power *= k;
        k_power %= MOD;
    }

    ll ans = 0;
    for (int i = 0 ; i < n; i++) {
        ans += pref[i] * p[n - i];
        ans %= MOD;
    }
//    cout << ans << "\n";
    ll sum_pis = 0;
    for (int i = 2; i <= n; i++) {
        for (int j = 1; j * j < i; j++) {
            if (n % j == 0) {
                sum_pis += powers[j] * (i / j - 1);
                sum_pis %= MOD;
                if (i / j != i) {
                    sum_pis += powers[i / j] * (i / (i / j) - 1);
                    sum_pis %= MOD;
                }
            }
        }
//        cout << i i<< " " << sum_pis << endl;
    }
//    cout << sum_pis << "\n";
    ans = (ans - sum_pis + MOD) % MOD;
    cout << ans;
    return 0;
}

