#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<vector<int>> v(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            char c;
            cin >> c;
            v[i][j] = c -'0';
        }
    }

    vector<vector<int>> g(n);
    vector<int64_t> counts(n);
    counts[0] = 1;
    counts[1] = 1;
    g[0].push_back(1);
    for (int i = 2; i < n; i++) {

        vector <int> hasEdges;
        if (v[i - 1][i] != 0) {
            hasEdges.push_back(i - 1);
            g[i - 1].push_back(i);
        }
        for (int j = i - 2; j >= 0; j--) {

            int summ = 0;
            for (auto x: hasEdges) {
                summ += v[j][x];
            }
            summ %= 10;
            if (summ != v[j][i]) {
                hasEdges.push_back(j);
                g[j].push_back(i);
            }
        }
    }

    vector<vector<char>> matrix(n, vector<char>(n, '0'));
    for (int i = 0; i < n; i++) {
        for (auto x: g[i]) {
           matrix[i][x] = '1';
        }
    }

    for (int i = 0; i < n; i++ ) {
        for (int j = 0; j < n; j++) {
            cout << matrix[i][j];
        }
        cout << endl;
    }
    return 0;
}
