#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <deque>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()
#define read(a) for (int i = 0; i < a.size(); ++i) cin >> a[i];
#define printv(a, text) cout << text << " = "; for (auto e : a) cout << e << ' '; cout << endl;
#define printm(a, text) cout << text << " =\n"; for (auto e : a) cout << e.first << ' ' << e.second << endl; cout << endl;

typedef long long ll;
typedef pair <int, int> pii;

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0); cin.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> ans(n, vector<int>(n)), inp(n, vector<int>(n));

    for (int i = 0; i < n; i++){
        string s;
        cin >> s;
        for (int j = 0; j < n; j++) {
            inp[i][j] = s[j] - '0';
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int res = inp[i][j];
            for (int k = 0; k < j; k++) {
                res -= ans[i][k] * inp[k][j];
            }
            while (res < 0 || res > 1) {
                inp[i][j] += 10;
                res = inp[i][j];
                for (int k = 0; k < j; k++) {
                    res -= ans[i][k] * inp[k][j];
                }
            }
            ans[i][j] = res;
        }
    }

    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++) {
            cout << ans[i][j];
        }
        cout << "\n";
    }

    return 0;
}
