#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

int32_t main()
{
#ifdef _DEBUG
	ifstream cin("input.txt");
#endif // _DEBUG
	queue<int> q;
	int n;
	cin >> n;
	int m;
	cin >> m;
	vector<vector<int> > g(n);
	for (int i = 0; i < n - 1; i++)
	{
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	vector<int> len(n, -1), cnt(n, 0);

	for (int i = 0; i < m; i++)
	{
		int v;
		cin >> v;
		--v;
		len[v] = 0;
		cnt[v] = 1;
		q.push(v);
	}
	while (q.size())
	{
		int v = q.front();
		q.pop();
		if (cnt[v] == m)
		{
			cout << "YES\n" << v + 1;
			return 0;
		}
		for (int u : g[v])
		{
			if (len[u] == len[v] + 1)
			{
				cnt[u] += cnt[v];
			}
			if (len[u] == -1)
			{
				len[u] = len[v] + 1;
				cnt[u] = cnt[v];
				q.push(u);
			}
		}
	}
	cout << "NO";
	return 0;
}