#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

using namespace std;

const int inf = (int)1e9 + 1;
const ld pi = atan2(0, -1);

inline void setmin(int &x, int y) { if (y < x) x = y; }
inline void setmax(int &x, int y) { if (y > x) x = y; }

const int N = 1000;

string a[N];

int main()
{
    #ifdef kek
        ifstream cin("a.in");
    #endif // kek

    int n, m;
    cin >> n >> m;
    rep(i, 0, n)
    {
        cin >> a[i];
    }
    int x, y;
    rep(i, 0, n)
    {
        rep(j, 0, m)
        {
            if (a[i][j] == 'A')
            {
                x = i;
                y = j;
            }
        }
    }
    int up[m], down[m];
    rep(j, 0, m)
    {
        up[j] = 0;
        while (x - up[j] - 1 >= 0 && a[x - up[j] - 1][j] == '.')
            up[j]++;
        down[j] = 0;
        while (x + down[j] + 1 < n && a[x + down[j] + 1][j] == '.')
            down[j]++;
    }
    int best = 1, a1 = y, a2 = y, a3 = x, a4 = x;
    int UP = inf, DOWN = inf;
    repb(l, y, -1)
    {
        if (a[x][l] != 'A' && a[x][l] != '.')
            break;
        setmin(UP, up[l]);
        setmin(DOWN, down[l]);
        int U = UP, D = DOWN;
        rep(r, y, m)
        {
            if (a[x][r] != 'A' && a[x][r] != '.')
                break;
            setmin(U, up[r]);
            setmin(D, down[r]);
            if ((r - l + 1) * (1 + U + D) > best)
            {
                best = (r - l + 1) * (1 + U + D);
                a1 = l; a2 = r;
                a3 = x - U;
                a4 = x + D;
            }
        }
    }
    rep(i, a3, a4 + 1)
        rep(j, a1, a2 + 1)
            if (a[i][j] != 'A')
                a[i][j] = 'a';
    rep(i, 0, n)
        rep(j, 0, m)
            if (a[i][j] != '.' && a[i][j] != 'A' && a[i][j] != 'a')
            {
                char c = a[i][j] - 'A' + 'a';
                repb(k, j - 1, -1)
                    if (a[i][k] == '.')
                        a[i][k] = c;
                    else
                        break;
                rep(k, j + 1, m)
                    if (a[i][k] == '.')
                        a[i][k] = c;
                    else
                        break;
            }
    rep(i, 0, n)
        rep(j, 0, m)
            if (a[i][j] != '.' && a[i][j] != 'A' && a[i][j] != 'a')
            {
                char c;
                if (a[i][j] >= 'a' && a[i][j] <= 'z')
                    c = a[i][j];
                else
                    c = a[i][j] - 'A' + 'a';
                int l = j, r = j;
                while (l > 0 && (a[i][l - 1] == c || a[i][l - 1] == c - 'a' + 'A'))
                    l--;
                while (r < m - 1 && (a[i][r + 1] == c || a[i][r + 1] == c - 'a' + 'A'))
                    r++;
                int u, d;
                if (i < a3)
                {
                    u = 0; d = a3 - 1;
                }
                else if (i > a4)
                {
                    u = a4 + 1;
                    d = n - 1;
                }
                else
                {
                    u = a3;
                    d = a4;
                }
                int k = i - 1;
                while (k >= 0 && a[k][j] == '.')
                {
                    rep(t, l, r + 1)
                        a[k][t] = c;
                    k--;
                }
                k = i + 1;
                while (k < n && a[k][j] == '.')
                {
                    rep(t, l, r + 1)
                        a[k][t] = c;
                    k--;
                }
            }
    rep(i, 0, n)
        cout << a[i] << "\n";
}
