#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

#define prev asdklsad

using namespace std;

const int maxn = 2e5 + 7;

int par[maxn], classes[maxn], p[maxn], cnt[maxn], cl[maxn];

vector<int> suffArray(string s){
    int n = s.size();
    int num = 256;
    for (int i = 0; i < n; i++) {
        cnt[(int)s[i]]++;
        classes[i] = (int)s[i];
    }
    p[0] = n;
    classes[n] = 0;
    for (int i = 1; i < num; i++)
        cnt[i] += cnt[i - 1];
    for (int i = n - 1; i >= 0; i--)
        p[--cnt[(int)s[i]] + 1] = i;
    n++;
    for (int l = 0; (1 << l) < n; l++){
        fill(cnt, cnt + num, 0);
        for (int i = 0; i < n; i++){
            par[i] = p[i] - (1 << l);
            cnt[classes[i]]++;
            if (par[i] < 0)
                par[i] += n;
           // cout << par[i] << " ";
        }
        //cout << endl;
        for (int i = 1; i < num; i++)
            cnt[i] += cnt[i - 1];
       // cout << par[0] << endl;
        for (int i = n - 1; i >= 0; i--)
            p[--cnt[classes[par[i]]]] = par[i];
        //for (int i = 0; i < n; i++)
        //    cout << p[i] << " ";
        //exit(0);
        cl[p[0]] = 0;
        for (int i = 1; i < n; i++){
            cl[p[i]] = cl[p[i - 1]];
            int x = p[i - 1] + (1 << l);
            if (x >= n)
                x -= n;
            int y = p[i] + (1 << l);
            if (y >= n)
                y -= n;
           // cout << classes[p[i - 1]] << " " << classes[p[i]] << endl;
            if (classes[p[i - 1]] != classes[p[i]] || classes[x] != classes[y])
                cl[p[i]]++;
        }
        copy(cl, cl + n, classes);
        num = classes[p[n - 1]] + 1;
    }
    vector<int> result(n - 1);
    for (int i = 0; i < n - 1; i++)
        result[i] = p[i + 1];
    return result;
}

vector<int> getLcp(vector<int>& suff, string s) {
    int n = suff.size();
    vector<int> index(n);
    for (int i = 0; i < n; i++)
        index[suff[i]] = i;
    int k = 0;
    vector<int> answer(n - 1);
    for (int i = 0; i < n; i++){
        if (index[i] == n - 1){
            k = 0;
            continue;
        }
        k = max(k - 1, 0);
        int j = suff[index[i] + 1];
        //cout << i << " " << j << " ";
        while (i + k < n && j + k < n && s[i + k] == s[j + k])
            k++;
        //cout << k << endl;
        answer[index[i]] = k;
    }
    return answer;
}

set<int> arr[maxn];
int prev[maxn];

int getPrev(int v){
    if (prev[v] == v)
        return v;
    return prev[v] = getPrev(prev[v]);
}

int join(int a, int b){
    a = getPrev(a);
    b = getPrev(b);
    if (arr[a].size() > arr[b].size())
        swap(a, b);
    prev[a] = b;
    int result = maxn;
   // for (int x : arr[a])
   // for (int x : arr[a])
   //     cout << x << " ";
   // cout << endl;
    //for (int x : arr[b])
   //     cout << x << " ";
    //cout << endl;
    for (int x : arr[a]){
        auto f = arr[b].lower_bound(x);
        if (f != arr[b].end())
            result = min(result, (*f) - x);
        if (f != arr[b].begin())
            result = min(result, x - *(--f));
    }
    for (int x : arr[a])
        arr[b].insert(x);
   // cout << result << endl;
    //exit(0);
    return result;
}

int gcd(int a, int b){
    return b > 0 ? gcd(b, a % b) : a;
}

int main()
{
    #ifdef kek
        ifstream cin("a.in");
    #endif // kek
    string s;
    cin >> s;
    auto suff = suffArray(s);
    auto lcp = getLcp(suff, s);
    int n = s.size();
    vector<int> order(n - 1);
    iota(order.begin(), order.end(), 0);
    sort(order.begin(), order.end(), [&](int i, int j) {return lcp[i] > lcp[j]; });
    for (int i = 0; i < n; i++){
        arr[i].insert(i);
        prev[i] = i;
    }
    ll p = 0, q = 1;
   // return 0;
   //join()
   //cout << join(1, 0) << endl;
   //return 0;
    for (int x : order){
        ll pp = lcp[x];
        ll qq = join(suff[x], suff[x + 1]);

    //    cout << x << " " << pp << " " << qq << endl;
    //    cout << pp << " " << qq << endl;
        if (p * qq < q * pp)
            p = pp, q = qq;
    }
    int d = gcd(p, q);
    cout << (p + q) / d << "/" << q / d << endl;
    return 0;

}
