#define _CRT_SECURE_NO_WARNINGS
#include <queue>
#include <vector>
#include <algorithm>
#include <cmath>


using namespace std;

int main()
{
	int n, m;
	scanf("%d %d", &n, &m);
	vector<vector<int>> mat(n, vector<int>());
	int* dst = new int[n];
	for (int i = 0; i < n; i++)
	{
		dst[i] = -1;
	}
	for (int i = 0; i < n - 1; i++)
	{
		int temp1, temp2;
		scanf("%d %d", &temp1, &temp2);
		temp1--;
		temp2--;
		mat[temp1].push_back(temp2);
		mat[temp2].push_back(temp1);
	}

	vector<int> parts;
	parts.resize(m);
	for (int i = 0; i < m; i++) {
		scanf("%d", &parts[i]);
		parts[i]--;
	}

	queue<int> q;
	q.push(parts[0]);
	dst[parts[0]] = 0;
	int maxDist = 0;
	while (!q.empty())
	{
		int curr = q.front();
		q.pop();
		for (int i = 0; i < mat[curr].size(); i++)
			if (dst[mat[curr][i]] == -1)
			{
				q.push(mat[curr][i]);
				dst[mat[curr][i]] = dst[curr] + 1;
				maxDist = fmax(dst[mat[curr][i]], maxDist);
			}
	}


	maxDist /= 2;


	bool cool = true;
	for (int i = n - 1; i >= 0; i--)
	{
		int max = abs(dst[parts[0]] - dst[i]);
		if (max != maxDist) continue;
		for (int j = 1; j < m; j++) {
			if (abs(dst[parts[j]] - dst[i]) != maxDist)
			{
				printf("NO");
				return 0;
			}
		}

		printf("YES\n%i", i + 1);
		return 0;

	}
}