#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include <queue>

typedef long long ll;

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int n, m;
	cin >> n >> m;
	std::vector<std::vector<int>> a(n);
	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		a[x].push_back(y);
		a[y].push_back(x);
	}

	std::vector<int> d(n, -1), c(n, 0);
	queue<int> q;
	for (int i = 0; i < m; i++) {
		int x;
		cin >> x;
		x--;
		q.push(x);
		d[x] = 0;
		c[x] = 1;
	}

	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int u : a[v]) {
			if (d[u] == -1) {
				d[u] = d[v] + 1;
				c[u] = c[v];
				q.push(u);
			}
			else if (d[u] == d[v] + 1) {
				c[u] += c[v];
			}
		}
	}
	for (int i = 0; i < n; i++) {
		// cout << i << " " << c[i] << "\n";
		if (c[i] == m) {
			cout << "YES\n" << i + 1 << "\n";
			return 0;
		}
	}
	cout << "NO";


}

/*

6 3
1 2
2 3
3 4
4 5
4 6
1 5 6

*/