#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <queue>
#include <map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}

		int ans = 0;

		for (int j = 1; j < n/2; j++) {
			unordered_map<int, short int> ds;
			for (int i = 0; i < j; i++) {
				ds[a[j] - a[i]]++;
			}
			for (int k = j + 1; k < n; k++) {
				ans += ds[a[k] - a[j]];
			}
		}

		for (int j = n / 2; j < n - 1; j++) {
			unordered_map<int, short int> ds;
			for (int k = j+1; k < n; k++) {
				ds[a[k] - a[j]]++;
			}
			for (int i = 0; i < j; i++) {
				ans += ds[a[j] - a[i]];
			}
		}

		cout << ans << "\n";
	}

	return 0;
}

/*
4
5 1 2 1 2 1
3 30 20 10
5 1 2 2 3 4
9 3 1 4 1 5 9 2 6 5
*/