import kotlin.math.roundToLong
import kotlin.random.Random

fun readTokens() = readLine()!!.split(' ')
fun readLongs() = readTokens().map { it.toLong() }
fun readInt() = readLine()!!.toInt()

fun main() {
    val T = readInt()
    for (TT in 0 until T) {
        val n = readInt()
        val a = readLongs()

        val COUNT = 200000

        var count = 0

        for (i in 0 .. COUNT) {
            var x = -1
            var y = -1
            var z = -1

            while (!(x < y && y < z)) {
                x = Random.Default.nextInt(n)
                y = Random.Default.nextInt(n)
                z = Random.Default.nextInt(n)
            }

            if (a[y] - a[x] == a[z] - a[y]) {
                count++
            }
        }

        val d = count.toDouble() / COUNT
        val r = ((n-2)*(n-1)*n*d/6).roundToLong()
        println(r)
    }
}