#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int maxN = 200005;
const int maxA = 1000005;
const int BUBEN = 1100;

int ans[maxA];
int arr[maxN];
int pref[maxN];

int main() {
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        pref[i + 1] = arr[i] + pref[i];
    }

    int mmax = 0;
    for (int i = 0; i < n; i++) mmax = max(arr[i], mmax);

    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;

        if (t < mmax) {
            cout << "Impossible" << "\n";
            continue;
        }

        if (ans[t] != 0) {
            cout << ans[t] << "\n";
            continue;
        }

        if (t <= BUBEN) {
            ans[t] = 1;
            int cur = 0;
            int s = 0;
            while (cur < n) {
                s += arr[cur];
                if (s > t) {
                    ans[t]++;
                    s = arr[cur];
                }
                cur++;
            }
        }
        else {
            ans[t] = 0;
            int cur = 0;
            while (cur < n) {
                int l = cur, r = n;
                while (r - l > 1) {
                    int m = (l + r) / 2;
                    if (pref[m + 1] - pref[cur] > t) r = m;
                    else l = m;
                }
                ans[t]++;
                cur = l + 1;
            }
        }

        cout << ans[t] << "\n";
    }


    return 0;
}
