#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define sz(s) (int)(s).size()
#define mp make_pair
using namespace std;

typedef long double ld;
typedef long long ll;
mt19937 rng(time(0));

string str[300];

struct Edge {
    pair<int, int> a, b;
};

vector<Edge> p;
int n, m;
int kx[] = {-1, 0, 1, 0}, ky[] = {0, 1, 0, -1};
bool used[300][300];

void dfs(int x, int y, int mv = 0, int px = -2, int py = -2) {
    used[x][y] = true;
    p.push_back({mp(x + 1, y), mp(x, y + 1)});
    if (mv == 2 || mv == 3)
        swap(p.back().a, p.back().b);
        int c = 8;

    for (int i = 0; i < c; i++) {
            int I = i % 4;
        int dx = x + kx[I], dy = y + ky[I];
        if (dx == px && dy == py) c = i + 4;
        if (dx < 0 || dy < 0 || dx >= n || dy >= m || used[dx][dy] || str[dx][dy] != 'X')
            continue;
        dfs(dx, dy, I, x, y);
    }
    p.push_back({mp(x, y), mp(x + 1, y + 1)});
    if (mv == 2 || mv == 3)
        swap(p.back().a, p.back().b);
}

bool cr(pair<int, int> a, pair<int, int> b) {
    return (abs(a.first - b.first) + abs(a.second - b.second) == 1);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cout.precision(12);
    cin >> m >> n;
    int x = -1, y = -1;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> str[i];
        for (int j = 0; j < m; j++) {
            if (str[i][j] == 'X')
                x = i, y = j;
        }
    }
    dfs(x, y);
    cout << 2 * sz(p) - 1 << endl;
    for (int i = 0; i < sz(p); i++) {
        cout << p[i].a.second << " " << p[i].a.first << endl;
        cout << p[i].b.second << " " << p[i].b.first << endl;
    }
}

