#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define sz(s) (int)(s).size()
#define mp make_pair
using namespace std;

typedef long double ld;
typedef long long ll;
mt19937 rng(time(0));

const ll INF = 1e18;

int n, m;
bool mark[200500], bad[200500];
vector<int> g[200500];
int last[200500];

void gg() {
    cout << "NO";
    exit(0);
}

void dfs(int v, int p = -1) {
    bool good = false;
    for (int u : g[v]) {
        if (u == p)
            continue;
        dfs(u, v);
        good |= !bad[u];
    }
    if (!mark[v] && !good)
        bad[v] = true;
}

pair<int, int> find_leaf(int v, int p = -1) {
    last[v] = p;
    pair<int, int> cur = mp(0, v);
    for (int u : g[v]) {
        if (u == p || bad[u])
            continue;
        cur = max(cur, find_leaf(u, v));
    }
    cur.first++;
    return cur;
}

void diam(int v) {
    int l = find_leaf(v).second;
    auto tmp = find_leaf(l);
    int r = tmp.second;
    int dist = tmp.first;
    if (dist % 2 == 0) gg();
    for (int i = 0; i < dist / 2; i++)
        r = last[r];
    vector<int> d(n);
    d[r] = 1;
    queue<int> q;
    set<int> s;
    q.push(r);
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        if (mark[x]) {
            s.insert(d[x]);
        }
        for (int i : g[x]) {
            if (!d[i]) {
                d[i] = d[x] + 1;
                q.push(i);
            }
        }
    }
    if (s.size() != 1) gg();
    else cout << "YES" << endl << r + 1;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    //freopen("input.txt", "r", stdin);
    cout.precision(12);
    cin >> n >> m;
    //cout << n << " " << m << endl;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u-1].push_back(v-1);
        g[v-1].push_back(u-1);
    }
    int mx = -1;
    for (int i = 0; i < m; i++) {
        int v;
        cin >> v;
        v--;
        mark[v] = true;
        mx = max(mx, v);
    }
    dfs(mx);
    diam(mx);
}
