#include <iostream>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int nums[n][n];
    int paths[n][n];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            char c;
            cin >> c;
            nums[i][j] = (int) (c - '0');
            paths[i][j] = 0;
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (j <= i) {
                cout << 0;
                continue;
            }

            int res = 0;
            for (int k = i + 1; k < j; k++) {
                if (paths[i][k]) {
                    res += nums[k][j];
                }
            }
            res = res % 10;
            //cout << endl << i << " " << j << " " << res <<  " " << nums[i][j] << endl;
            if (res != nums[i][j]) {
                paths[i][j] = 1;
                cout << 1;
            }
            else {
                cout << 0;
            }
        }
        cout << endl;
    }
}
