#include <iostream>
#include <vector>
#include <set>

using namespace std;

int n, m;
vector<vector<int>> g;
set<int> c;

vector<bool> used;
vector<int> path;
int mid = 0;

bool dfs(int s, int f) {
    used[s] = 1;
    path.push_back(s);
    if (s == f) {
        mid = path[path.size() / 2];
        return (path.size() % 2 == 1);
    }
    for (auto to : g[s]) {
        if (!used[to]) {
            return dfs(to, f);
        }
    }
    path.pop_back();
}

int main() {
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int from, to;
        cin >> from >> to;
        g[from - 1].push_back(to - 1);
        g[to - 1].push_back(from - 1);
    }
    for (int j = 0; j < m; j++) {
        int city;
        cin >> city;
        c.insert(city - 1);
    }
    while (c.size() > 1) {
        int city1 = *c.begin();
        c.erase(c.begin());
        int city2 = *c.begin();
        c.erase(c.begin());
        used.assign(n, 0);
        if (dfs(city1, city2)) {
            c.insert(mid);
        } else {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES\n" << *c.begin() + 1;
    return 0;
}